"
COPYRIGHT (c) 1996 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

'From Smalltalk/X, Version:3.2.1 on 5-dec-1997 at 9:34:14 pm'                   !

DeviceWorkstation subclass:#WinWorkstation
	instanceVariableNames:'blackpixel whitepixel listOfFonts rootWin rootDC buttonsPressed
		eventTrace eventBuffer usingSystemPalette 
		inRecursiveDispatch'
	classVariableNames:'BeepFrequency BeepDuration NativeWindows NativeWindowClassTable'
	poolDictionaries:''
	category:'Interface-Graphics'
!

!WinWorkstation primitiveDefinitions!
%{
/*#define COUNT_RESOURCES*/

# undef INT
# define INT WIN_INT
# undef Array
# define Array WIN_Array
# undef Number
# define Number WIN_Number
# undef Method
# define Method WIN_Method
# undef Point
# define Point WIN_Point
# undef Rectangle
/*# define Rectangle WIN_Rectangle*/
# undef True
# define True WIN_True
# undef False
# define False WIN_False
# undef Block
# define Block WIN_Block
# undef Context
# define Context WIN_Context

# undef xxCONTEXT
# define xxCONTEXT        WIN_CONTEXT
# undef _xxCONTEXT
# define _xxCONTEXT       _WIN_CONTEXT



#include <stdio.h>
/* #include <malloc.h> */
/* #include <math.h> */
/* #include <string.h> */

#include <stdarg.h>

/* #include <windows.h> */

#  include <windef.h>
#  include <winbase.h>
#  include <wingdi.h>
#  include <winuser.h>

#include <windowsx.h>
#include <process.h>

#   ifdef __DEF_Array
#    undef Array
#    define Array __DEF_Array
#   endif
#   ifdef __DEF_Number
#    undef Number
#    define Number __DEF_Number
#   endif
#   ifdef __DEF_Method
#    undef Method
#    define Method __DEF_Method
#   endif
#   ifdef __DEF_Point
#    undef Point
#    define Point __DEF_Point
#   endif
#   ifdef __DEF_Block
#    undef Block
#    define Block __DEF_Block
#   endif
#   ifdef __DEF_Context
#    undef Context
#    define Context __DEF_Context
#   endif
#   undef INT
#   define INT int

/*
 * some defines - tired of typing ...
 */
#define _HANDLEVal(o)        (HANDLE)(__MKCP(o))
#define _HBITMAPVAL(o)       (HBITMAP)(__MKCP(o))
#define _HWNDVal(o)          (HWND)(__MKCP(o))
#define _HPALETTEVal(o)      (HPALETTE)(__MKCP(o))
#define _HCURSORVal(o)       (HCURSOR)(__MKCP(o))
#define _HGDIOBJVal(o)       (HGDIOBJ)(__MKCP(o))
#define _LOGPALETTEVal(o)    (LOGPALETTE *)(__MKCP(o))
#define _COLORREFVal(o)      (COLORREF)(__MKCP(o))

#define _GCDATA(o)           ((struct gcData *)(__MKCP(o)))
#define _HDCVal(o)           (_GCDATA(o)->hDC)
#define _HPENVal(o)          (_GCDATA(o)->selected.hPen)
#define _HBRUSHVal(o)        (_GCDATA(o)->selected.hBrush)

#define __rootDC             (HDC)(__MKCP(__INST(rootDC)))
#define ISCONNECTED          (__INST(rootDC) != nil)

typedef struct
{
    HPEN        hPen;
    HBRUSH      hBrush;
    HBITMAP     hBitmap;
} gcObjectData;

struct gcData {
    HWND        hWnd;
    int         clipByChild;
    HDC         hDC;
    int         brushType;
    int         lineWidth;
    int         lineStyle;
    int         joinStyle;
    int         capStyle;
    int         fontAscent;
    int         rop2;
    int         bitbltrop2;
    COLORREF    fgColor;
    COLORREF    bgColor;
    HFONT       hFont;
    gcObjectData selected;
    gcObjectData save;
};

/*
 * some synthetic values
 */
# define Button1MotionMask      1
# define Button2MotionMask      2
# define Button3MotionMask      4

# define Button1Mask            Button1MotionMask
# define Button2Mask            Button2MotionMask
# define Button3Mask            Button3MotionMask

# define ControlMask            8
# define ShiftMask              16
# define LeftAltMask            32
# define RightAltMask           64

# define TRANSLATED_KEY         256

/*
 * synthetic events
 */
#define __WM_MOUSEENTER        0x10001
#define __WM_MOUSELEAVE        0x10002
#define __WM_GEXPOSE           0x10003

static int AltMask = RightAltMask;
static int MetaMask = LeftAltMask;

# define WhitePixel     RGB(0xFF, 0xFF, 0xFF)
# define BlackPixel     RGB(0, 0, 0)

/*#undef DEBUG*/
#ifdef DEBUG
# define TH_DPRINTF(x)          /*{ if (__debug__) printf x;}*/
# define POSTPRINTF(x)          { if (__debug__) printf x;}
# define DPRINTF(x)             { if (__debug__) printf x;}
# define DDPRINTF(x)            /*{ if (__debug__) printf x;}*/
# define EVENT_PRINTF(x)        /*{ if (__debug__) printf x;}*/
# define EVENT_PRINTF2(x)       /*{ if (__debug__) printf x;}*/
# define EVENT_PRINTF3(x)       /* */
#else
# define TH_DPRINTF(x)          /* */
# define POSTDPRINTF(x)          /* */
# define DPRINTF(x)             /* */
# define DDPRINTF(x)            /* */
# define EVENT_PRINTF(x)        /* */
# define EVENT_PRINTF2(x)       /* */
# define EVENT_PRINTF3(x)       /* */
#endif

# define BR_SOLID       0
# define BR_PATTERN     1

# define LINE_SOLID     0
# define LINE_DASH      1
# define LINE_DDASH     2

#ifdef KEEP_STD_CURSORS
# define _C_ARROW       1
# define _C_CROSS       2
# define _C_IBEAM       3
# define _C_ICON        4
# define _C_NO          5
# define _C_SIZE        6
# define _C_SIZEALL     7
# define _C_SIZENESW    8
# define _C_SIZENS      9
# define _C_SIZENWSE    10
# define _C_UPARROW     11
# define _C_WAIT        12

 static HCURSOR H_C_ARROW = (HCURSOR)0;
 static HCURSOR H_C_CROSS = (HCURSOR)0;
 static HCURSOR H_C_IBEAM = (HCURSOR)0;
 static HCURSOR H_C_ICON = (HCURSOR)0;
 static HCURSOR H_C_NO = (HCURSOR)0;
 static HCURSOR H_C_SIZE = (HCURSOR)0;
 static HCURSOR H_C_SIZEALL = (HCURSOR)0;
 static HCURSOR H_C_SIZENESW = (HCURSOR)0;
 static HCURSOR H_C_SIZENS = (HCURSOR)0;
 static HCURSOR H_C_SIZENWSE = (HCURSOR)0;
 static HCURSOR H_C_UPARROW = (HCURSOR)0;
 static HCURSOR H_C_WAIT = (HCURSOR)0;
#endif /* KEEP_STD_CURSORS */

static int evRootX, evRootY;
static HWND buttonWindow = (HWND)0;
static int destroyWin;
static int __modifiers;

#define EARLY_DEFPROC
#ifdef EARLY_DEFPROC
static early_defProc = 1;
#else
static early_defProc = 0;
#endif

#define WM_THREADCREATEWINDOW   WM_USER + 0x101
#define WM_THREADDESTROYWINDOW  WM_USER + 0x102
#define WM_CREATECHILD          WM_USER + 0x103

#define THREADINPUTEVENTNAME "InputEvents"
#define THREADEVENTNAME "CreateEvents"
#define THREADMUTEXNAME "MutexToProtectEvents"
#define isInputEvent() ((int)eventQueueHead)

typedef int (*intf)(int);

/*
 * keep the windows cursor and others local in the HWND struct.
 */
typedef struct
{
  int flag;
  int event;
  int x;
  int y;
  int x1;
  int y1;
} localPaintInfo;
#define LI_TOPWIN       1
#define LI_EXPOSE       2
typedef struct
{
	HCURSOR hCursor;
	HBRUSH  bgBrush;
	int flag;
	int minWidth;
	int maxWidth;
	int minHeight;
	int maxHeight;
	localPaintInfo sizeInfo;
	localPaintInfo paintInfo;
} localWindowInfo;
typedef localWindowInfo *plocalWindowInfo;

#define N_WINDOW_PRIVATE (sizeof(plocalWindowInfo))

#define GETLOCALWINDOWINFOPTR(__hWnd__) \
	((localWindowInfo*)GetWindowLong(__hWnd__, 0))
#define SETLOCALWINDOWINFOPTR(__hWnd__,__ptr__) \
	SetWindowLong(__hWnd__, 0 , (DWORD)__ptr__)

#define SetWindow_Cursor(__hWnd__, __hCurs__) \
	(GETLOCALWINDOWINFOPTR(__hWnd__) ? (GETLOCALWINDOWINFOPTR(__hWnd__)->hCursor = __hCurs__) : 0)

#define GetWindow_Cursor(__hWnd__) \
	(GETLOCALWINDOWINFOPTR(__hWnd__) ? GETLOCALWINDOWINFOPTR(__hWnd__)->hCursor : 0)

#define SetWindow_bgBrush(__hWnd__, __bgBrush__) \
	(GETLOCALWINDOWINFOPTR(__hWnd__) ? (GETLOCALWINDOWINFOPTR(__hWnd__)->bgBrush = __bgBrush__) : 0)

#define GetWindow_bgBrush(__hWnd__) \
	(GETLOCALWINDOWINFOPTR(__hWnd__) ? GETLOCALWINDOWINFOPTR(__hWnd__)->bgBrush : 0)

#define GetWindow_paintInfoPtr(__hWnd__) \
	(GETLOCALWINDOWINFOPTR(__hWnd__) ? &(GETLOCALWINDOWINFOPTR(__hWnd__)->paintInfo) : 0)
#define GetWindow_sizeInfoPtr(__hWnd__) \
	(GETLOCALWINDOWINFOPTR(__hWnd__) ? &(GETLOCALWINDOWINFOPTR(__hWnd__)->sizeInfo) : 0)

#define SetWindow_Flag(__hWnd__, __flag__) \
	(GETLOCALWINDOWINFOPTR(__hWnd__) ? (GETLOCALWINDOWINFOPTR(__hWnd__)->flag = __flag__) : 0)

#define GetWindow_Flag(__hWnd__) \
	(GETLOCALWINDOWINFOPTR(__hWnd__) ? GETLOCALWINDOWINFOPTR(__hWnd__)->flag : 0)

struct queuedEvent {
	struct queuedEvent     *ev_next;
	int                     count;
	HWND                    ev_hWnd;
	UINT                    ev_message;
	UINT                    ev_wParam;
	int                     ev_arg1;
	int                     ev_arg2;
	int                     ev_arg3;
	int                     ev_arg4;
};

#define ev_x    ev_arg1
#define ev_y    ev_arg2
#define ev_w    ev_arg3
#define ev_h    ev_arg4

#define ev_keyCode   ev_wParam
#define ev_scanCode  ev_arg3
#define ev_modifiers ev_arg4

#define EV_CHUNK_CNT    64
#define EV_CHUNK_SZ     (EV_CHUNK_CNT*sizeof(struct queuedEvent))

#define BITBLT_COPY             SRCCOPY
#define BITBLT_COPYINVERTED     NOTSRCCOPY
#define BITBLT_XOR              SRCINVERT
#define BITBLT_AND              SRCAND
#define BITBLT_OR               SRCPAINT


%}
! !

!WinWorkstation primitiveVariables!
%{

static int firstInstance = 1;
static char *app_name = "ST/X";
static char *app_nameroot = "ST/X:Root";
static int __debug__ = 0;
static int __depth;
static HWND __rootWin = NULL;
static HWND __rootWinSpezial = NULL;

#define CAPTURE_NONE     0
#define CAPTURE_EXPLICIT 1
#define CAPTURE_IMPLICIT 2

static int currentCapture = CAPTURE_NONE;
static int lastNCMouseX, lastNCMouseY;
static int lastMoveX, lastMoveY, lastSizeWidth, lastSizeHeight;

static HANDLE currentPointerView = (HANDLE)0;
/*static HBRUSH bgBrush = (HBRUSH)0;*/

/* MessageDispatchThread */
static char *_thread_windowName;
static char *_thread_className;
static int _thread_winStyleBits;
static int _thread_winStyleBitsEx;
static HANDLE _thread_parentHandle;
static int _thread_x;
static int _thread_y;
static int _thread_dx;
static int _thread_dy;
static localWindowInfo *_thread_local;
static HANDLE _thread_newWinHandle;

static DWORD _masterThreadId;
static HANDLE _masterThread;
static DWORD _dispatchThreadId;
static BOOL bdispatchThreadState;
static int lockcount;
static HANDLE hdispatchMutex;
static HANDLE hCreateEvent;
static HANDLE hInputEvent;

static int waitForInputEvent = 0;
static int __gcDatas;
static int __createWindows;
static int __cnt_bitmap;
struct queuedEvent *eventFreeList = (struct queuedEvent *)0;
struct queuedEvent *eventQueueHead = (struct queuedEvent *)0;
struct queuedEvent *eventQueueTail = (struct queuedEvent *)0;
static int eventsendcount = 0;
static int eventempfcount = 0;
%}
! !

!WinWorkstation primitiveFunctions!
%{

__debugEvent__() {}
static int st2RGB(int color)
{
  int ir,ig,ib;
  if (__depth < 15)
  {
    return 0;
  }
  else
  {
    if ((__depth == 16) || (__depth == 15))
    {
      ib = (color & 0x1f) << 3;
      ig = ((color >> 5) & 0x1f) << 3;
      ir = ((color >> 10) & 0x1f) << 3;
      ir |= 7;
      ig |= 7;
      ib |= 7;
      return RGB(ir,ig,ib);
    }
    return color;
  }
}
static int RGB2st(int r,int g,int b)
{
  int ir,ig,ib,id;
  if (__depth < 15)
  {
    id = 0;
  }
  else
  {
    if ((__depth == 16) || (__depth == 15))
    {
      ir = (r >> 11) & 0x1f;
      ig = (g >> 11) & 0x1f;
      ib = (b >> 11) & 0x1f;

      id = ( ir << 10 ) | ( ig << 5 ) | ib;
    }
    else
    {
      ir = (r >> 8) & 0xff;
      ig = (g >> 8) & 0xff;
      ib = (b >> 8) & 0xff;

      id = RGB( ir, ig, ib);
    }
  }
  return id;
}
static struct gcData *newGcData()
{
    struct gcData *gcData = (struct gcData *)malloc(sizeof(struct gcData));
    if (! gcData) {
	return 0;
    }
    memset(gcData,0,sizeof(struct gcData));
    gcData->clipByChild = TRUE;
    gcData->bitbltrop2 = BITBLT_COPY;
    gcData->brushType = BR_SOLID;
    gcData->lineWidth = 1;
    gcData->lineStyle = PS_SOLID;
    gcData->joinStyle = PS_JOIN_MITER;
    gcData->capStyle = PS_ENDCAP_FLAT;
}
static HPEN GcDataGetPen(HDC hDC,struct gcData *gcData)
{
    HPEN hPen = gcData->selected.hPen;
    if (! hPen)
    {
	hPen = gcData->selected.hPen = CreatePen(gcData->lineStyle,
					gcData->lineWidth,
					gcData->fgColor);
	if (!gcData->save.hPen)
	  gcData->save.hPen = SelectObject(hDC, hPen);
	else
	  SelectObject(hDC, hPen);
    }
    return hPen;
}
static HBRUSH GcDataGetBrush(HDC hDC,struct gcData *gcData)
{
    HBRUSH hBrush = gcData->selected.hBrush;
    if (! hBrush)
    {
	/*printf("CreateSolidBrush %x\n",gcData->fgColor);*/
	hBrush = gcData->selected.hBrush = CreateSolidBrush(gcData->fgColor);
	if (!gcData->save.hBrush)
	  gcData->save.hBrush = SelectObject(hDC, hBrush);
	else
	  SelectObject(hDC, hBrush);
    }
    return hBrush;
}
static int DelObject(HANDLE o)
{
    int r = DeleteObject(o);
    if (r == 0)
      printf("ERROR in DelObjectect\n");
    return r;
}

static
int lockEvent()
{
    DWORD dwWaitResult;

    /* Request ownership of mutex. */

    dwWaitResult = WaitForSingleObject(
	hdispatchMutex,   /* handle of mutex */
	5000L);   /* time-out interval */

    lockcount++;
    if (lockcount != 1)
    {
       printf("lockcount != 1 :=%d\n",lockcount);
       exit(1);
    }
    switch (dwWaitResult)
    {
	// The thread got mutex ownership.
	case WAIT_OBJECT_0:
	    break;
	// Cannot get mutex ownership due to time-out.
	case WAIT_TIMEOUT:
	    printf("lockEvent fail\n");
	    return FALSE;
	// Got ownership of the abandoned mutex object.
	default:
	    return FALSE;
    }
    return TRUE;
}
void unlockEvent()
{
    if (lockcount != 1)
    {
       printf("lockcount != 1 :=%d\n",lockcount);
    }
    lockcount--;
    /* Release ownership of the mutex object. */
    if (! ReleaseMutex(hdispatchMutex)) {
      /* Deal with error. */
      printf("unlock Error\n");
    }
}
static
void waitInputEvent(int time)
{
  waitForInputEvent = TRUE;
  /* printf(";"); */
  if (!isInputEvent())
  {
    DWORD dwWaitResult;
    /* printf("W"); */
    dwWaitResult = WaitForSingleObject(
      hInputEvent,   /* handle of mutex */
      time);   /* time-out interval */
  }
  waitForInputEvent = FALSE;
}
static
enqEvent(HWND hWnd, UINT message, UINT wParam,int arg1,int arg2,int arg3,int arg4)
{
    struct queuedEvent *ev = 0;
    struct queuedEvent *bulk;
    int i;

    TH_DPRINTF(("TEW\n"));
    if (lockEvent())
    {
      TH_DPRINTF(("TEF\n"));
      if (message == WM_WINDOWPOSCHANGED)
      {
	localPaintInfo *pi = GetWindow_sizeInfoPtr(hWnd);
	if (pi)
	{
	  if (arg3 && arg4)
	  {
	    pi->x = arg1;
	    pi->y = arg2;
	    pi->x1 = arg3;
	    pi->y1 = arg4;
	  }
	  pi->event++;
	}
	else
	 TH_DPRINTF(("Error no sizePaintInfo\n"));
      }
      else if (message == WM_PAINT)
      {
	localPaintInfo *pi = GetWindow_paintInfoPtr(hWnd);
	if (pi)
	{
	  if (pi->event)
	  {
	    if (pi->x > arg1)
	      pi->x = arg1;
	    if (pi->y > arg2)
	      pi->y = arg2;
	    if (pi->x1 < arg3)
	      pi->x1 = arg3;
	    if (pi->y1 < arg4)
	      pi->y1 = arg4;
	  }
	  else
	  {
	    pi->x = arg1;
	    pi->y = arg2;
	    pi->x1 = arg3;
	    pi->y1 = arg4;
	  }
	  pi->event++;
	}
	else
	 TH_DPRINTF(("Error no localPaintInfo\n"));
      }
      ev = eventFreeList;
      if (ev) {
	  eventFreeList = ev->ev_next;
      } else {
#if 1
	  bulk = (struct queuedEvent *) malloc(EV_CHUNK_SZ);
	  if (bulk == 0)
	  {
	    printf("no memory for dispatchqueue\n");
	    exit(1);
	  }
	  for (i=2; i<EV_CHUNK_CNT; i++) {
	      bulk[i-1].ev_next = &(bulk[i]);
	  }
	  bulk[EV_CHUNK_CNT-1].ev_next = (struct queuedEvent *)0;
	  ev = bulk;
	  eventFreeList = &(bulk[1]);
#else
	  ev = (struct queuedEvent *) malloc(sizeof(struct queuedEvent));
	  if (ev == 0)
	  {
	    printf("no memory for dispatchqueue\n");
	    exit(1);
	  }
#endif
      }

      ev->ev_next = (struct queuedEvent *)0;

      ev->count = eventsendcount++;
      ev->ev_hWnd = hWnd;
      ev->ev_message = message;
      ev->ev_wParam = wParam;
      ev->ev_arg1 = arg1;
      ev->ev_arg2 = arg2;
      ev->ev_arg3 = arg3;
      ev->ev_arg4 = arg4;

      if (eventQueueTail) {
	  eventQueueTail->ev_next = ev;
      } else {
	  eventQueueHead = ev;
      }
      eventQueueTail = ev;

      if (waitForInputEvent)
      {
	SetEvent(hInputEvent);
      }

      unlockEvent();
      /*SetThreadPriority(_masterThread,THREAD_PRIORITY_HIGHEST);*/
      Sleep(0);
    }
}

static
struct queuedEvent *deqEvent()
{
  struct queuedEvent *ev = 0;

  if (lockEvent())
  {

    while (TRUE)
    {
      TH_DPRINTF(("TDEQ\n"));
      ev = eventQueueHead;
      if (ev)
      {
	eventQueueHead = ev->ev_next;
	if (! eventQueueHead)
	{
	    eventQueueTail = (struct queuedEvent *)0;
	}
	if (eventempfcount != ev->count)
	{
	  printf("eventcount error %d <-> %d\n",eventempfcount,ev->count);
	}
	eventempfcount++;
	if (ev->ev_message == WM_DESTROY)
	{
	    if (ev->ev_arg1)
	    {
	      if (UnregisterClass((char*)ev->ev_arg1,(HANDLE) __getHInstance()))
	      {
		/*printf("UnregisterClass %s ok.\n",(char*)ev->ev_arg1);*/
		free((char*)ev->ev_arg1);
		ev->ev_arg1 = 0;
	      }
	      else
	      {
		/* noch einmal in die queue */
		if (ev->ev_arg2++ < 100)
		{
		  ev->ev_next = (struct queuedEvent *)0;
		  ev->count = eventsendcount++;

		  if (eventQueueTail) {
		      eventQueueTail->ev_next = ev;
		  } else {
		      eventQueueHead = ev;
		  }
		  eventQueueTail = ev;
		  if (ev->ev_arg2 > 98)
		  {
		    printf("UnregisterClass %s failed. Wait 1 sec.\n",(char*)ev->ev_arg1);
		    unlockEvent();
		    sleep(1);
		    lockEvent();
		  }
		  else
		  {
		    unlockEvent();
		    sleep(0);
		    lockEvent();
		  }
		  continue;
		}
		else /* fail evtl. spter ndern und in st verzgert aufrufen */
		{
		  printf("UnregisterClass %s failed.\n",(char*)ev->ev_arg1);
		  free((char*)ev->ev_arg1);
		  ev->ev_arg1 = 0;
		}
	      }
	    }
	}
	if (ev->ev_message == WM_WINDOWPOSCHANGED)
	{
	  localPaintInfo *pi = GetWindow_sizeInfoPtr(ev->ev_hWnd);
	  if (pi)
	  {
	    --pi->event;
	    if ((pi->event <= 0) && (pi->flag == 0))
	    {
	      pi->event = 0;
	      /*pi->flag = 1;*/
	      ev->ev_arg1 = pi->x;
	      ev->ev_arg2 = pi->y;
	      ev->ev_arg3 = pi->x1;
	      ev->ev_arg4 = pi->y1;
	      break;
	    }
	    else
	    {
	      /* free Event */
	      ev->ev_next = eventFreeList;
	      eventFreeList = ev;
	    }
	  }
	  else
	   break;
	}
	else
#if 1
	if (ev->ev_message == WM_PAINT)
	{
	  localPaintInfo *pi = GetWindow_paintInfoPtr(ev->ev_hWnd);
	  if (pi)
	  {
	    if (--pi->event <= 0)
	    {
	      pi->event = 0;
	      ev->ev_arg1 = pi->x;
	      ev->ev_arg2 = pi->y;
	      ev->ev_arg3 = pi->x1 - pi->x;
	      ev->ev_arg4 = pi->y1 - pi->y;
	      /*if (pi->flag & LI_EXPOSE)
		ev->ev_message = __WM_GEXPOSE;*/

	      break;
	    }
	    else
	    {
	      /* free Event */
	      ev->ev_next = eventFreeList;
	      eventFreeList = ev;
	    }

	  }
	  else
	   break;
	}
	else
#endif
	  break;

      }
      else
	break;
    }

    unlockEvent();
  }
    /*if (!ev)
      SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);*/
  return ev;
}

static
freeEvent(ev)
    struct queuedEvent *ev;
{
    if (lockEvent())
    {
      ev->ev_next = eventFreeList;
      eventFreeList = ev;
      unlockEvent();
    }
}

static
getModifiers()
{
    int modifiers = 0;
    if (GetKeyState(VK_SHIFT) & 0x8000)
	modifiers |= ShiftMask;
    if (GetKeyState(VK_CONTROL) & 0x8000)
	modifiers |= ControlMask;
#if 0
    if (GetKeyState(VK_RMENU) & 0x8000)
	modifiers |= RightAltMask;
    if (GetKeyState(VK_LMENU) & 0x8000)
	modifiers |= LeftAltMask;
#else
    if (GetKeyState(VK_MENU) & 0x8000)
	modifiers |= LeftAltMask;
#endif
    if (GetKeyState(VK_LBUTTON) & 0x8000)
	modifiers |= Button1Mask;
    if (GetKeyState(VK_MBUTTON) & 0x8000)
	modifiers |= Button2Mask;
    if (GetKeyState(VK_RBUTTON) & 0x8000)
	modifiers |= Button3Mask;

    __modifiers = modifiers;
    return modifiers;
}

#if 0
static
getWinEvents(all)
{
    MSG msg;
    int more;
#ifdef CALLLEVEL_DEBUG
    static int callLevel = 0;
#endif

    if (GetQueueStatus(QS_ALLINPUT) && PeekMessage(&msg, (HWND)0, 0, 0, PM_NOREMOVE)) {
	more = 1;

#ifdef CALLLEVEL_DEBUG
	DPRINTF(("(%d\n", callLevel)); callLevel++;
#endif

	while (more) {
	    GetMessage(&msg, (HWND)0, 0, 0);
	    /* nothing to do */
	    TH_DPRINTF(("GETMESSAGE %d\n",msg.message));

	    if (! all) {
		break;
	    } else {
		more = PeekMessage(&msg, (HWND)0, 0, 0, PM_NOREMOVE);
	    }
	}
#ifdef CALLLEVEL_DEBUG
	callLevel--; DPRINTF((")%d\n", callLevel));
#endif
    }
}
#endif
static
winEventProcessing(hWnd, message, wParam, lParam, pDefault)
    HWND hWnd;                /* window handle                   */
    UINT message;             /* type of message                 */
    UINT wParam;              /* additional information          */
    LONG lParam;              /* additional information          */
    int *pDefault;
{
    LPMINMAXINFO lpmmi;
    WINDOWPOS *posStruct;
    RECT rct;
    RECT upd;
    int modifiers;
    int x, y, w, h;
    int isNative = 0;
    PAINTSTRUCT ps;

/*
    EVENT_PRINTF(("winEvent hWin=0x%x message=0x%x wP=0x%x lP=0x%x\n",
			hWnd, message, wParam, lParam));
*/


    /*
     * messages which are enqueued to be handled by the view thread
     */
    switch (message) {
	case WM_CREATE:
	    {
	      CREATESTRUCT *lpcs = (LPCREATESTRUCT) lParam; // structure with creation data
	      SETLOCALWINDOWINFOPTR(hWnd,lpcs->lpCreateParams);
	      if (GETLOCALWINDOWINFOPTR(hWnd) != lpcs->lpCreateParams)
		DPRINTF(("SETLOCALWINDOWINFOPTR ERROR\n"));
	      /*enqEvent(hWnd, message, wParam, 0, 0, 0, 0);*/
	      *pDefault = 0;
#ifdef COUNT_RESOURCES
	      __createWindows++;
#endif
	      DPRINTF(("WM_CREATE\n"));
#if 0
	      if (GetParent(hWnd))
	      {
		 SendMessage(GetParent(hWnd),WM_CREATECHILD,(WPARAM)hWnd,0);
	      }
#endif
	    }
	    break;
	case WM_CREATECHILD:
	    {
	    }
	    break;
	case WM_CLOSE:
	    DPRINTF(("WM_CLOSE\n"));
	    if (!destroyWin)
	      enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    else
	    {
	      destroyWin = 0;
	      if (!DestroyWindow(hWnd))
	      {
		DPRINTF(("DestroyWindow ERROR\n"));
	      }

	    }
	    *pDefault = 0;
	    return 0;
	    break;
	case WM_DESTROY:
	    {
	      char *n = 0;
	      DPRINTF(("WM_DESTROY\n"));
	      if (GETLOCALWINDOWINFOPTR(hWnd))
	      {
		if (GETLOCALWINDOWINFOPTR(hWnd)->flag & LI_TOPWIN)
		{
		  n = (char*)malloc(200);
		  GetClassName(hWnd,n,200);
		}
#ifdef COUNT_RESOURCES
	      __createWindows--;
#endif
	      /* free all resources */
		if (GetWindow_bgBrush(hWnd))
		  DelObject(GetWindow_bgBrush(hWnd));
		free(GETLOCALWINDOWINFOPTR(hWnd));
		SETLOCALWINDOWINFOPTR(hWnd,0);
	      }


	      enqEvent(hWnd, message, wParam, (int)n, 0, 0, 0);
	      *pDefault = 0;
	      return 0;
	    }
	    break;
	case WM_GETMINMAXINFO:
	    {
		lpmmi = (LPMINMAXINFO) lParam;

		DPRINTF(("WM_GETMINMAXINFO handle=%x got min: %d/%d\n",
			    hWnd,
			    lpmmi->ptMinTrackSize.x,
			    lpmmi->ptMinTrackSize.y));

		if (GETLOCALWINDOWINFOPTR(hWnd) &&
		    GETLOCALWINDOWINFOPTR(hWnd)->minWidth &&
		    GETLOCALWINDOWINFOPTR(hWnd)->maxWidth
		   )
		{
		  lpmmi->ptMaxSize.x = GETLOCALWINDOWINFOPTR(hWnd)->maxWidth;
		  lpmmi->ptMaxSize.y = GETLOCALWINDOWINFOPTR(hWnd)->maxHeight;
		  lpmmi->ptMaxTrackSize.x = GETLOCALWINDOWINFOPTR(hWnd)->maxWidth;
		  lpmmi->ptMaxTrackSize.y = GETLOCALWINDOWINFOPTR(hWnd)->maxHeight;
		  lpmmi->ptMinTrackSize.x = GETLOCALWINDOWINFOPTR(hWnd)->minWidth;
		  lpmmi->ptMinTrackSize.y = GETLOCALWINDOWINFOPTR(hWnd)->minHeight;
		  DPRINTF(("WM_GETMINMAXINFO handle=%x return min: %d/%d max: %d/%d\n",
				  hWnd,
				  GETLOCALWINDOWINFOPTR(hWnd)->minWidth, GETLOCALWINDOWINFOPTR(hWnd)->minHeight,
				  GETLOCALWINDOWINFOPTR(hWnd)->maxWidth, GETLOCALWINDOWINFOPTR(hWnd)->maxHeight));
		}
		*pDefault = 0;
	    }
	    break;
	case WM_SETCURSOR:
	    {
		HCURSOR curs;
		int hitCode;

		hitCode = LOWORD(lParam);
		if (hitCode != HTCLIENT) {
		    /*
		     * not in client area ...
		     */
		    return 0;
		}
		DPRINTF(("WM_SETCURSOR\n"));
		curs = GetWindow_Cursor(hWnd);
		if (curs) {
		    SetCursor(curs);
		    *pDefault = 0;
		    return 1;
		}

	    }
	    /*enqEvent(hWnd, message, wParam, 0, 0, 0, 0);*/
	    return 0;
	case WM_WINDOWPOSCHANGED:
	    /*
	     * ignore child window messages ...
	     */
	    if (GetParent(hWnd)) {
		break;
	    }

	    GetClientRect(hWnd, &rct);
	    EVENT_PRINTF(("WM_WINDOWPOSCHANGED\n"));
	    enqEvent(hWnd, message, wParam,
			       rct.left, rct.top,
			       rct.right-rct.left+1,
			       rct.bottom-rct.top+1);
	    return 0;

	case WM_ERASEBKGND:
	    EVENT_PRINTF(("WM_ERASEBKGND\n"));
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    {
		int state;
		HDC dc = (HDC)wParam;
		HBRUSH br = GetWindow_bgBrush(hWnd);
		if (br == 0)
		  br = GetStockObject(BLACK_BRUSH);
		SuspendThread(_masterThread);
		state = SaveDC(dc);
		GetClientRect(hWnd, (LPRECT) &upd);
		SelectClipRgn(dc,0);
		FillRect(dc, &upd, br);
		/*FillRect(GetDCEx(hWnd,0,DCX_CLIPCHILDREN), &upd, br);*/
		RestoreDC(dc,state);
		ResumeThread(_masterThread);

	    }
	    *pDefault = 0;
	    return 1;
	    break;
	case WM_PAINT:
	    EVENT_PRINTF(("WM_PAINT\n"));
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    if (GetUpdateRect(hWnd, &upd, TRUE))
	    {
		enqEvent(hWnd, message, wParam, upd.left, upd.top, upd.right, upd.bottom);
	    }
	    /**pDefault = 0;*/
	    return 0;
	    break;

	case WM_SIZE:
	    EVENT_PRINTF(("WM_SIZE\n"));
	    switch(wParam)
	    {
	      case SIZE_RESTORED:
	      case SIZE_MAXIMIZED:
		GetClientRect(hWnd, (LPRECT) &upd);
		enqEvent(hWnd, WM_PAINT, wParam, upd.left, upd.top, upd.right, upd.bottom);
		/*printf("WM_SIZE %x w %d h %d\n",hWnd,LOWORD(lParam),HIWORD(lParam));*/
		break;
	    }
	    break;
	case WM_SHOWWINDOW:
	    EVENT_PRINTF(("WM_SHOWWINDOW\n"));
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    *pDefault = 0;
	    return 0;

	case WM_MOUSEACTIVATE :
	    EVENT_PRINTF2(("WM_MOUSEACTIVATE h=%x\n", hWnd));
#if 0
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);

	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    *pDefault = 0;
	    return MA_ACTIVATE;
	    /*return MA_ACTIVATEANDEAT;*/
#else
	    break;
#endif
	case WM_ACTIVATE:
	    EVENT_PRINTF2(("WM_ACTIVATE %s h=%x\n",
			    LOWORD(wParam) ? "active" : "inactive",
			    hWnd));

	    switch (LOWORD(wParam)) {
		case WA_INACTIVE:
		    EVENT_PRINTF2(("WM_ACTIVATE inactive h=%x\n", hWnd));
		    break;
		case WA_ACTIVE:
		    EVENT_PRINTF2(("WM_ACTIVATE active h=%x\n", hWnd));
		    {
		      POINT p;
		      HWND hWndChild;

		      p.x = evRootX;
		      p.y = evRootY;
		      ScreenToClient(hWnd, &p);
		      hWndChild = ChildWindowFromPoint(hWnd,p);
		      /*printf("WM_ACTIVATE active h=%x p=%d.%d in %x\n", hWnd,p.x,p.y,hWndChild);*/
		      if (hWndChild && (hWndChild != hWnd))
		      {
			  modifiers = getModifiers();
			  if (hWnd != currentPointerView)
			  {
			      if (currentPointerView)
			      {
				  enqEvent(currentPointerView, __WM_MOUSELEAVE, 0, -1, -1, 0, modifiers);
				  currentPointerView = 0;
			      }
			      enqEvent(hWnd, __WM_MOUSEENTER, 0, evRootX, evRootY, 0, modifiers);
			      SetFocus(hWnd);
			      currentPointerView = hWnd;
			  }
		      }
		    }
		    break;
		case WA_CLICKACTIVE:
		    EVENT_PRINTF2(("WM_ACTIVATE clkactive h=%x\n", hWnd));
		    break;
		default:
		    EVENT_PRINTF2(("WM_ACTIVATE ? h=%x\n", hWnd));
		    break;
	    }
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    return 0;

	case WM_SYSCHAR:
	    EVENT_PRINTF2(("WM_SYSCHAR h=%x %x\n", hWnd, wParam));
	    goto commonChar;

	case WM_CHAR:
	    EVENT_PRINTF2(("WM_CHAR h=%x %x\n", hWnd, wParam));
	commonChar:
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    modifiers = getModifiers();
	    {
		POINT p;

		p.x = evRootX;
		p.y = evRootY;
		ScreenToClient(hWnd, &p);
		x = p.x;
		y = p.y;
	    }
	    enqEvent(hWnd, WM_KEYDOWN, wParam, x, y, lParam, modifiers | TRANSLATED_KEY);
	    enqEvent(hWnd, WM_KEYUP, wParam, x, y, lParam, modifiers | TRANSLATED_KEY);
	    *pDefault = 0;
	    return 0;

	case WM_SYSKEYUP:
	    EVENT_PRINTF2(("WM_SYSKEYUP %x\n, wParam"));
	    goto commonKey;

	case WM_SYSKEYDOWN:
	    EVENT_PRINTF2(("WM_SYSKEYDOWN %x\n, wParam"));
	    goto commonKey;

	case WM_KEYUP:
	    EVENT_PRINTF2(("WM_KEYUP h=%x %x\n", hWnd, wParam));
	    goto commonKey;

	case WM_KEYDOWN:
	    EVENT_PRINTF2(("WM_KEYDOWN h=%x %x\n", hWnd, wParam));

	    /* while debugging ... */
	    if (wParam == VK_ESCAPE) {
		ReleaseCapture();
		currentCapture = CAPTURE_NONE;
	    }

	commonKey:
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    modifiers = getModifiers();
	    {
		POINT p;

		p.x = evRootX;
		p.y = evRootY;
		ScreenToClient(hWnd, &p);
		x = p.x;
		y = p.y;
	    }

	    enqEvent(hWnd, message, wParam, x, y, lParam, modifiers);
	    *pDefault = 0;
	    return 0;

	case WM_MOUSEMOVE:
	    EVENT_PRINTF3(("WM_MOUSEMOVE h=%x\n", hWnd));
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }

	    {
		short x, y;

		x = LOWORD(lParam);
		y = HIWORD(lParam);

		modifiers = getModifiers();

		if (hWnd != currentPointerView) {
		    if (currentPointerView) {
			enqEvent(currentPointerView, __WM_MOUSELEAVE, 0, -1, -1, 0, modifiers);
			currentPointerView = 0;
		    }
		    enqEvent(hWnd, __WM_MOUSEENTER, 0, x, y, 0, modifiers);
		    if (IsChild(GetActiveWindow(),hWnd))
		      SetFocus(hWnd);
		    currentPointerView = hWnd;
		}
		enqEvent(hWnd, message, wParam, x, y, 0, modifiers);
	    }
	    *pDefault = 0;
	    return 0;

	case WM_LBUTTONDOWN:
	case WM_MBUTTONDOWN:
	case WM_RBUTTONDOWN:
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }

/*printf("setCapture (button down)\n");*/

	    if (currentCapture == CAPTURE_NONE)
	    {
		currentCapture = CAPTURE_IMPLICIT;
		SetFocus(hWnd);
		SetCapture(hWnd);
	    }
	    goto commonButton;

	case WM_LBUTTONUP:
	case WM_MBUTTONUP:
	case WM_RBUTTONUP:
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }

/*printf("releaseCapture (button up)\n");*/

	    if (currentCapture == CAPTURE_IMPLICIT) {
		currentCapture = CAPTURE_NONE;
		ReleaseCapture();
	    }
	    goto commonButton;

	case WM_LBUTTONDBLCLK:
	case WM_MBUTTONDBLCLK:
	case WM_RBUTTONDBLCLK:
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	commonButton:
	    modifiers = getModifiers();
	    EVENT_PRINTF3(("WM_BUTTONUP/DOWN h=%x pos=%d/%d\n",
			   hWnd, LOWORD(lParam), HIWORD(lParam)));

	    enqEvent(hWnd, message, wParam, LOWORD(lParam),
					    HIWORD(lParam),
					    wParam,
					    modifiers);
	    *pDefault = 0;
	    break;
	case WM_KILLFOCUS:
	    EVENT_PRINTF(("WM_KILLFOCUS\n"));
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    break;
	case WM_SETFOCUS:
	    EVENT_PRINTF(("WM_SETFOCUS\n"));
	    enqEvent(hWnd, message, wParam, 0, 0, 0, 0);
	    if (isNative) {
		*pDefault = 1;
		return 0;
	    }
	    break;
	case WM_STYLECHANGING:
	    EVENT_PRINTF(("WM_STYLECHANGING\n"));
	    break;

	case WM_STYLECHANGED:
	    EVENT_PRINTF(("WM_STYLECHANGED\n"));
	    break;

	case WM_GETTEXT:
	    /*EVENT_PRINTF(("WM_GETTEXT %x\n", message));*/
	    break;

	case WM_GETTEXTLENGTH:
	    EVENT_PRINTF(("WM_GETTEXTLENGTH %x\n", message));
	    break;

	case WM_NCCREATE:
	    EVENT_PRINTF(("WM_NCCREATE %x\n", message));
	    break;

	case WM_NCHITTEST:
	    EVENT_PRINTF3(("WM_NCHITTEST %x\n", message));
	    break;

	case WM_NCMOUSEMOVE:
	    {
		short x, y;

		x = LOWORD(lParam);
		y = HIWORD(lParam);
		EVENT_PRINTF(("WM_NCMOUSEMOVE %d/%d\n", x, y));
		lastNCMouseX = x;
		lastNCMouseY = y;
	    }
	    break;

	case WM_PARENTNOTIFY:
	    EVENT_PRINTF2(("WM_PARENTNOTIFY h=%x hChild=%x %d\n",
				hWnd, lParam, LOWORD(wParam)));
	    break;

	case WM_NCLBUTTONDOWN:
	    EVENT_PRINTF(("WM_NCLBUTTONDOWN\n"));
	    {
		short x, y;

		x = LOWORD(lParam);
		y = HIWORD(lParam);
		lastNCMouseX = x;
		lastNCMouseY = y;
	    }
	    break;

	case WM_NCLBUTTONUP:
	    EVENT_PRINTF(("WM_NCLBUTTONUP\n"));
	    break;

	case WM_NCRBUTTONDOWN:
	    EVENT_PRINTF(("WM_NCRBUTTONDOWN\n"));
	    break;

	case WM_NCRBUTTONUP:
	    EVENT_PRINTF(("WM_NCRBUTTONUP\n"));
	    break;

	case WM_NCMBUTTONDOWN:
	    EVENT_PRINTF(("WM_NCMBUTTONDOWN\n"));
	    break;

	case WM_NCMBUTTONUP:
	    EVENT_PRINTF(("WM_NCMBUTTONUP\n"));
	    break;

	case WM_SETTEXT:
	    EVENT_PRINTF(("WM_SETTEXT\n"));
	    break;

	case 0x88:
	    EVENT_PRINTF(("0x88 (undoc)\n"));
	    break;

	case WM_NCCALCSIZE:
	    EVENT_PRINTF(("WM_NCCALCSIZE\n"));
	    break;

	case WM_NCPAINT:
	    EVENT_PRINTF3(("WM_NCPAINT\n"));
	    break;

	case WM_SYSCOMMAND:
	    switch (wParam & ~0x000F) {
		case SC_CLOSE:
		    EVENT_PRINTF2(("WM_SYSCOMMAND SC_CLOSE\n"));
		    break;

		case SC_MOVE:
		    EVENT_PRINTF2(("WM_SYSCOMMAND SC_MOVE\n"));
		    break;

		case SC_RESTORE:
		    EVENT_PRINTF2(("WM_SYSCOMMAND SC_RESTORE\n"));
		    break;

		case SC_SIZE:
		    EVENT_PRINTF2(("WM_SYSCOMMAND SC_SIZE\n"));
		    break;

		default:
		    EVENT_PRINTF2(("WM_SYSCOMMAND %x\n", wParam));
		    break;
	    }
	    break;
	case WM_INITMENU:
	    EVENT_PRINTF(("WM_INITMENU\n"));
	    break;
	case WM_INITMENUPOPUP:
	    EVENT_PRINTF(("WM_INITMENUPOPUP\n"));
	    break;
	case WM_ENTERIDLE:
	    EVENT_PRINTF(("WM_ENTERIDLE\n"));
	    break;
	case WM_ENTERMENULOOP:
	    EVENT_PRINTF(("WM_ENTERMENULOOP\n"));
	    break;
	case WM_EXITMENULOOP:
	    EVENT_PRINTF(("WM_EXITMENULOOP\n"));
	    break;
	case WM_MENUSELECT:
	    EVENT_PRINTF(("WM_MENUSELECT\n"));
	    break;
	case WM_QUIT:
	    EVENT_PRINTF(("WM_QUIT\n"));
	    break;
	case WM_NCDESTROY:
	    EVENT_PRINTF(("WM_NCDESTROY\n"));
	    break;
	case WM_QUERYNEWPALETTE:
	    EVENT_PRINTF(("WM_QUERYNEWPALETTE\n"));
	    break;
	case WM_PALETTECHANGED:
	    EVENT_PRINTF(("WM_PALETTECHANGED\n"));
	    break;
	case WM_NCACTIVATE:
	    EVENT_PRINTF(("WM_NCACTIVATE\n"));
	    break;
	case WM_ACTIVATEAPP:
	    EVENT_PRINTF2(("WM_ACTIVATEAPP %s\n", wParam ? "active" : "inactive"));
	    break;
	case WM_SYSDEADCHAR:
	    EVENT_PRINTF2(("WM_SYSDEADCHAR %x\n, wParam"));
	    break;
	case WM_DEADCHAR:
	    EVENT_PRINTF2(("WM_DEADCHAR %x\n, wParam"));
	    break;
	case WM_PAINTICON:
	    EVENT_PRINTF(("WM_PAINTICON\n"));
	    break;
	case WM_ICONERASEBKGND:
	    EVENT_PRINTF(("WM_ICONERASEBKGND\n"));
	    break;
	case WM_WINDOWPOSCHANGING:
	    EVENT_PRINTF(("WM_WINDOWPOSCHANGING\n"));
	    break;
	case WM_QUERYOPEN:
	    EVENT_PRINTF(("WM_QUERYOPEN\n"));
	    break;
	case WM_QUERYENDSESSION:
	    EVENT_PRINTF(("WM_QUERYENDSESSION\n"));
	    break;
	case WM_FONTCHANGE:
	    EVENT_PRINTF(("WM_FONTCHANGE\n"));
	    break;
	case WM_CAPTURECHANGED:
	    EVENT_PRINTF(("WM_CAPTURECHANGED\n"));
	    break;
	case WM_MOVING:
	    EVENT_PRINTF(("WM_MOVING\n"));
	    break;
	case WM_SYSCOLORCHANGE:
	    EVENT_PRINTF(("WM_SYSCOLORCHANGE\n"));
	    break;
	case WM_SIZING:
	    EVENT_PRINTF(("WM_SIZING\n"));
	    /*__debugEvent__();*/
	    break;
	case WM_EXITSIZEMOVE:
	    EVENT_PRINTF(("WM_EXITSIZEMOVE\n"));
	    break;
	case WM_ENTERSIZEMOVE:
	    EVENT_PRINTF(("WM_ENTERSIZEMOVE\n"));
	    break;
	case WM_MOVE:
	    EVENT_PRINTF(("WM_MOVE\n"));
	    break;
	default:
	    EVENT_PRINTF(("msg = %x\n", message));
	    break;
    }
    return 0;
}
static
winEventProcessingRoot(hWnd, message, wParam, lParam, pDefault)
    HWND hWnd;                /* window handle                   */
    UINT message;             /* type of message                 */
    UINT wParam;              /* additional information          */
    LONG lParam;              /* additional information          */
    int *pDefault;
{
    LPMINMAXINFO lpmmi;
    WINDOWPOS *posStruct;
    RECT rct;
    RECT upd;
    int modifiers;
    int x, y, w, h;
    PAINTSTRUCT ps;


/*    printf("winEvent hWin=0x%x message=0x%x wP=0x%x lP=0x%x\n",
			hWnd, message, wParam, lParam);
*/


    /*
     * messages which are enqueued to be handled by the view thread
     */
    switch (message) {
	case WM_CREATE:
	    {
	      CREATESTRUCT *lpcs = (LPCREATESTRUCT) lParam; // structure with creation data
	      SETLOCALWINDOWINFOPTR(hWnd,lpcs->lpCreateParams);
	      if (GETLOCALWINDOWINFOPTR(hWnd) != lpcs->lpCreateParams)
		DPRINTF(("SETLOCALWINDOWINFOPTR ERROR\n"));
	      *pDefault = 0;
	      DPRINTF(("WM_CREATE\n"));
	    }
	    break;
#if 1
	case WM_ERASEBKGND:
	    EVENT_PRINTF(("WM_ERASEBKGND\n"));
	    {
		int state;
		HDC dc = (HDC)wParam;
		HBRUSH br = GetStockObject(HOLLOW_BRUSH);
		GetClientRect(hWnd, (LPRECT) &upd);
		FillRect(dc, &upd, br);
	    }
	    *pDefault = 0;
	    return 1;
	    break;
	case WM_PAINT:
	    EVENT_PRINTF(("WM_PAINT\n"));
	    if (GetUpdateRect(hWnd, &upd, TRUE))
	    {
	    }
	    DefWindowProc(hWnd, message, wParam, lParam);
	    /**pDefault = 0;*/
	    return 0;
	    break;
#endif
	case WM_SETCURSOR:
	    {
		HCURSOR curs;
		int hitCode;

		hitCode = LOWORD(lParam);
		if (hitCode != HTCLIENT) {
		    /*
		     * not in client area ...
		     */
		    return 0;
		}
		DPRINTF(("WM_SETCURSOR\n"));
		curs = GetWindow_Cursor(hWnd);
		if (curs) {
		    SetCursor(curs);
		    *pDefault = 0;
		    return 1;
		}

	    }
	    return 0;
	case WM_SYSCHAR:
	    EVENT_PRINTF2(("WM_SYSCHAR h=%x %x\n", hWnd, wParam));
	    goto commonChar;

	case WM_CHAR:
	    EVENT_PRINTF2(("WM_CHAR h=%x %x\n", hWnd, wParam));
	commonChar:
	    modifiers = getModifiers();
	    *pDefault = 0;
	    return 0;

	case WM_SYSKEYUP:
	    EVENT_PRINTF2(("WM_SYSKEYUP %x\n, wParam"));
	    goto commonKey;

	case WM_SYSKEYDOWN:
	    EVENT_PRINTF2(("WM_SYSKEYDOWN %x\n, wParam"));
	    goto commonKey;

	case WM_KEYUP:
	    EVENT_PRINTF2(("WM_KEYUP h=%x %x\n", hWnd, wParam));
	    goto commonKey;

	case WM_KEYDOWN:
	    EVENT_PRINTF2(("WM_KEYDOWN h=%x %x\n", hWnd, wParam));

	    /* while debugging ... */
	    if (wParam == VK_ESCAPE) {
		ReleaseCapture();
		currentCapture = CAPTURE_NONE;
	    }

	commonKey:
	    modifiers = getModifiers();
	    *pDefault = 0;
	    return 0;
	case WM_LBUTTONDOWN:
	case WM_MBUTTONDOWN:
	case WM_RBUTTONDOWN:
	    goto commonButton;

	case WM_LBUTTONUP:
	case WM_MBUTTONUP:
	case WM_RBUTTONUP:
	    ReleaseCapture();
	    ShowWindow(hWnd,SW_HIDE);
	    goto commonButton;

	case WM_LBUTTONDBLCLK:
	case WM_MBUTTONDBLCLK:
	case WM_RBUTTONDBLCLK:
	commonButton:
	    modifiers = getModifiers();
	    EVENT_PRINTF3(("WM_BUTTONUP/DOWN h=%x pos=%d/%d\n",
			   hWnd, LOWORD(lParam), HIWORD(lParam)));

	    *pDefault = 0;
	    break;
	default:
	    EVENT_PRINTF(("msg = %x\n", message));
	    break;
    }
    return 0;
}
DWORD WINAPI dispatchThread(LPVOID arg)
{
    static int th_calls;
    RECT rect;
    MSG msg;
    localWindowInfo *li;
    _dispatchThreadId = GetCurrentThreadId();
    TH_DPRINTF(("TS %d\n", th_calls++));
    PeekMessage(&msg,NULL,0,0,PM_NOREMOVE);   /* must be */
    AttachThreadInput(_dispatchThreadId,_masterThreadId,TRUE);

    GetWindowRect(GetDesktopWindow(), &rect);
    /* allocate localMemory for Window */
    li = (localWindowInfo*)malloc(sizeof(localWindowInfo));
    if (li)
    {
      memset(li,0,sizeof(*_thread_local));
    }
    __rootWinSpezial = CreateWindowEx( WS_EX_TRANSPARENT,app_nameroot,app_nameroot,0,
				0,0,
				rect.right-rect.left,rect.bottom-rect.top,
				0,0,(HANDLE) __getHInstance(),li);

    printf("__rootWinSpezial %x\n",__rootWinSpezial);
    SetWindowPos(__rootWinSpezial, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);

    SetEvent(hCreateEvent);

    while (bdispatchThreadState)
    {
	TH_DPRINTF(("TG %d\n", th_calls++));
	GetMessage(&msg, NULL, 0, 0);
	TH_DPRINTF(("TD %d\n", th_calls++));
	destroyWin = 0;
	if (msg.message == WM_THREADDESTROYWINDOW)
	{
	  destroyWin = TRUE;
	  msg.message = WM_CLOSE;
	  DPRINTF(("WM_THREADDESTROYWINDOW\n"));
	}
	else if (msg.message == WM_THREADCREATEWINDOW)
	{
	  TH_DPRINTF(("C %d\n", th_calls));
	  _thread_newWinHandle = CreateWindowEx(
				      _thread_winStyleBitsEx,
				      _thread_className,
				      _thread_windowName,
				      _thread_winStyleBits,
				      _thread_x, _thread_y,
				      _thread_dx,_thread_dy,
				      _thread_parentHandle,
				      NULL,           /* menu */
				      (HANDLE) __getHInstance(),
				      _thread_local);

	  SetEvent(hCreateEvent);
	  continue;
	}
	/* TranslateMessage(&msg); */ /* Translates virtual key codes */
	if ((msg.message == WM_KEYDOWN) || (msg.message == WM_KEYUP)
	 || (msg.message == WM_SYSKEYDOWN) || (msg.message == WM_SYSKEYUP)) {
	    if (((msg.wParam >= '0') && (msg.wParam <= 'Z'))
	     || (msg.wParam == 0x20)
	     || (msg.wParam >= 0xB0)) {
		/*
		 * translate to a WM_CHAR message
		 */
		if (TranslateMessage(&msg))
		    continue;
	    }
	}
	evRootX = msg.pt.x;
	evRootY = msg.pt.y;
	DispatchMessage(&msg);   /* Dispatches message to window */
    }
    return 0;
}

LONG APIENTRY
MainWndProc(hWnd, message, wParam, lParam)
    HWND hWnd;                /* window handle                   */
    UINT message;             /* type of message                 */
    UINT wParam;              /* additional information          */
    LONG lParam;              /* additional information          */
{
    int wantDefault = 1;
    int retVal;

    TH_DPRINTF(("TMW %d\n",message));
    retVal = winEventProcessing(hWnd, message, wParam, lParam, &wantDefault);
    if (wantDefault) {
	DDPRINTF((">>DefWindowProc\n"));
	retVal = DefWindowProc(hWnd, message, wParam, lParam);
	DDPRINTF(("<<DefWindowProc\n"));
    }
    return retVal;
}

LONG APIENTRY
MainWndProcRoot(hWnd, message, wParam, lParam)
    HWND hWnd;                /* window handle                   */
    UINT message;             /* type of message                 */
    UINT wParam;              /* additional information          */
    LONG lParam;              /* additional information          */
{
    int wantDefault = 1;
    int retVal;

    TH_DPRINTF(("TMW %d\n",message));
    retVal = winEventProcessingRoot(hWnd, message, wParam, lParam, &wantDefault);
    return TRUE;
}

int CALLBACK
EnumFPTypeFaceProc( lplf, lptm, dwType, lpData )
	LOGFONT*        lplf;
	TEXTMETRIC*     lptm;
	DWORD           dwType;
	LPARAM          lpData;
{
	OBJ t;
	OBJ* refToList;
	OBJ  typeFaceList;

	if (lplf) {
	    t = __MKSTRING( lplf->lfFaceName );
	    refToList = (OBJ*) lpData;
	    typeFaceList = *refToList;
	    __SSEND1( typeFaceList, @symbol(add:), 0, t );
	}
	return 1;
}

int CALLBACK
EnumFontsProc( lplf, lptm, dwType, lpData )
	LOGFONT*      lplf;     /* address of logical-font data */
	TEXTMETRIC*   lptm;     /* address of physical font data */
	DWORD         dwType;   /* font type */
	LPARAM        lpData;   /* address of application supplied data */
{
	OBJ newArray, t;
	OBJ *refToList;
	OBJ list;
	char *s;

	DPRINTF(("EnumFontProc\n\n\n\n"));

	if( lplf ) {
	    DPRINTF((" lfHeight          %d\n", lplf->lfHeight ));
	    DPRINTF((" lfWidth           %d\n", lplf->lfWidth  ));
	    DPRINTF((" lfEscapement      %d\n", lplf->lfEscapement  ));
	    DPRINTF((" lfOrientation     %d\n", lplf->lfOrientation  ));
	    DPRINTF((" lfWeight          %d\n", lplf->lfWeight  ));
	    DPRINTF((" lfItalic          %d\n", lplf->lfItalic  ));
	    DPRINTF((" lfUnderline       %d\n", lplf->lfUnderline  ));
	    DPRINTF((" lfStrikeOut       %d\n", lplf->lfStrikeOut  ));
	    DPRINTF((" lfCharSet         %d\n", lplf->lfCharSet  ));
	    DPRINTF((" lfOutPrecision    %d\n", lplf->lfOutPrecision  ));
	    DPRINTF((" lfClipPrecision   %d\n", lplf->lfClipPrecision  ));
	    DPRINTF((" lfQuality         %d\n", lplf->lfQuality  ));
	    DPRINTF((" lfPitchAndFamily  %d\n", lplf->lfPitchAndFamily  ));
	    DPRINTF((" lfFaceName        %s\n\n", lplf->lfFaceName  ));

	    newArray = __ARRAY_NEW_INT(16);
	    __ArrayInstPtr(newArray)->a_element[0] = __MKSMALLINT(lplf->lfHeight);
	    __ArrayInstPtr(newArray)->a_element[1] = __MKSMALLINT(lplf->lfWidth);
	    __ArrayInstPtr(newArray)->a_element[2] = __MKSMALLINT(lplf->lfEscapement);
	    __ArrayInstPtr(newArray)->a_element[3] = __MKSMALLINT(lplf->lfOrientation);
	    switch (lplf->lfWeight) {
		case FW_NORMAL:
		    s = "normal";
		    break;
		case FW_BOLD:
		    s = "bold";
		    break;
		case FW_MEDIUM:
		    s = "medium";
		    break;
		case FW_LIGHT:
		    s = "demi";
		    break;
		default:
		    s = "other";
		    break;
	    }
	    __PROTECT__(newArray);
	    t = __MKSTRING(s);
	    __UNPROTECT__(newArray);
	    __ArrayInstPtr(newArray)->a_element[4] = t; __STORE(newArray, t);

	    if( lplf->lfItalic == TRUE ) {
		if( lplf->lfUnderline == TRUE ) {
		    if( lplf->lfStrikeOut == TRUE ) {
			s = "italic-underline-strikeOut";
		    } else {
			s = "italic-underline";
		    }
		} else {
		    if( lplf->lfStrikeOut == TRUE ) {
			s = "italic-strikeOut";
		    } else {
			s = "italic";
		    }
		}
	    } else {
		if( lplf->lfUnderline == TRUE ) {
		    if( lplf->lfStrikeOut == TRUE ) {
			s = "underline-strikeOut";
		    } else {
			s = "underline";
		    }
		} else {
		    if( lplf->lfStrikeOut == TRUE ) {
			s = "strikeOut";
		    } else {
			s = "normal";
		    }
		}
	    }
	    __PROTECT__(newArray);
	    t = __MKSTRING(s);
	    __UNPROTECT__(newArray);
	    __ArrayInstPtr(newArray)->a_element[15] = t; __STORE(newArray, t);

	    __ArrayInstPtr(newArray)->a_element[5] = __MKSMALLINT(lplf->lfItalic);
	    __ArrayInstPtr(newArray)->a_element[6] = __MKSMALLINT(lplf->lfUnderline);
	    __ArrayInstPtr(newArray)->a_element[7] = __MKSMALLINT(lplf->lfStrikeOut);
	    __ArrayInstPtr(newArray)->a_element[8] = __MKSMALLINT(lplf->lfCharSet);
	    __ArrayInstPtr(newArray)->a_element[9] = __MKSMALLINT(lplf->lfOutPrecision);
	    __ArrayInstPtr(newArray)->a_element[10] = __MKSMALLINT(lplf->lfClipPrecision);
	    __ArrayInstPtr(newArray)->a_element[11] = __MKSMALLINT(lplf->lfQuality);
	    __ArrayInstPtr(newArray)->a_element[12] = __MKSMALLINT(lplf->lfPitchAndFamily);
	    /* ... */
	    __PROTECT__(newArray);
	    t = __MKSTRING(lplf->lfFaceName);
	    __UNPROTECT__(newArray);
	    __ArrayInstPtr(newArray)->a_element[13] = t; __STORE(newArray, t);

#ifdef OLD
	    if( dwType == DEVICE_FONTTYPE ) 
		s = "device";
	    else if( dwType == RASTER_FONTTYPE )
		s = "raster";
	    else if( dwType == TRUETYPE_FONTTYPE )
		s = "typetype";
	    else
		s = "unknown";
#else
	    switch (lplf->lfCharSet) {
		case ANSI_CHARSET:
		    s = "ansi";
		    break;
		case DEFAULT_CHARSET:
		    s = "default";
		case SYMBOL_CHARSET:
		    s = "symbol";
		case SHIFTJIS_CHARSET:
		    s = "sjis";
		case GB2312_CHARSET:
		    s = "gb";
		case HANGEUL_CHARSET:
		    s = "hangeul";
		case CHINESEBIG5_CHARSET:
		    s = "big5";
		case OEM_CHARSET:
		    s = "oem";
		    break;
# ifdef JOHAB_CHARSET
		case JOHAB_CHARSET:
		    s = "johab";
		    break;                
# endif
# ifdef HEBREW_CHARSET
		case HEBREW_CHARSET:
		    s = "hebrew";
		    break;                
# endif
# ifdef GREEK_CHARSET
		case GREEK_CHARSET:
		    s = "greek";
		    break;                
# endif
# ifdef RUSSIAN_CHARSET
		case RUSSIAN_CHARSET:
		    s = "russian";
		    break;                
# endif
# ifdef MAC_CHARSET
		case MAC_CHARSET:
		    s = "mac";
		    break;                
# endif
		default:
		    s = "unknown";
		    break;
	    }
#endif
	    __PROTECT__(newArray);
	    t = __MKSTRING(s);
	    __UNPROTECT__(newArray);
            
	    __ArrayInstPtr(newArray)->a_element[14] = t; __STORE(newArray, t);

	    refToList = (OBJ*) lpData;
	    list = *refToList;
	    __SSEND1(list, @symbol(add:), 0, newArray);
	}

	DPRINTF((" dwType            %d\n", dwType ));
	return 1;
}

%}
! !

!WinWorkstation class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 1996 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    See more documentation in my superclass, DeviceWorkstation.

    [author:]
	Claus Gittinger
"
! !

!WinWorkstation class methodsFor:'initialization'!

initialize
    |nButtons swap|

    super initialize.

    NativeWindows := false.

    BeepFrequency := 440.       "/ Hertz
    BeepDuration := 200.        "/ millis

    ButtonTranslation := #(1 2 2).

    nButtons := self getSystemMetrics:#mouseButtons.
    swap := self getSystemMetrics:#swapButton.

    nButtons == 0 ifTrue:[
	'WinWorkstation [warning]: mouse-less operation may not work' infoPrintCR.
    ] ifFalse:[
	nButtons == 2 ifTrue:[
	    ButtonTranslation := #(1 2).
	].
	swap ifTrue:[
	    ButtonTranslation := ButtonTranslation copy reverse
	]
    ].

    "/ translation table from ST/X windowType symbol (system-independent)
    "/ to Windows windowClass (windows-specific).
 
    NativeWindowClassTable := IdentityDictionary new.
    NativeWindowClassTable at:#ScrollBar     put:'SCROLLBAR'.
    NativeWindowClassTable at:#CheckBox      put:'BUTTON'.
    NativeWindowClassTable at:#RadioButton   put:'BUTTON'.
    NativeWindowClassTable at:#Button        put:'BUTTON'.
    NativeWindowClassTable at:#DefaultButton put:'BUTTON'.
    NativeWindowClassTable at:#ComboBox      put:'COMBOBOX'.
    NativeWindowClassTable at:#EditField     put:'EDIT'.
    NativeWindowClassTable at:#ListBox       put:'LISTBOX'.
!

nativeWindows:aBoolean
    "enable / disable use of native windows"

    NativeWindows := aBoolean
! !

!WinWorkstation class methodsFor:'error handling'!

debug:aBoolean
%{  /* NOCONTEXT */

    __debug__ = (aBoolean == true) ? 1 : 0;
%}
!

prim
   "show prim values"
   
   ('WINWORKSTATION: pW=',self primWindows printString,'pB=',self primBitmaps printString,'pGc=',self primgcData printString) errorPrintNL
!

primBitmaps
%{  /* NOCONTEXT */
    RETURN ( __MKSMALLINT(__cnt_bitmap));
%}
!

primWindows
%{  /* NOCONTEXT */
    RETURN ( __MKSMALLINT(__createWindows));
%}
!

primgcData
%{  /* NOCONTEXT */
    RETURN ( __MKSMALLINT(__gcDatas));
%}
! !

!WinWorkstation class methodsFor:'queries'!

getSystemMetrics:aSymbol
%{  /* UNLIMITEDSTACK (WIN95 only) */
    int info = 0;
    int isBool = 0;
    int arg;

    if (aSymbol == @symbol(swapButton)) {
	arg = SM_SWAPBUTTON;
	isBool = 1;
    } else if (aSymbol == @symbol(mouseButtons)) {
	arg = SM_CMOUSEBUTTONS;
    } else if (aSymbol == @symbol(iconWidth)) {
	arg = SM_CXICON;
    } else if (aSymbol == @symbol(iconHeight)) {
	arg = SM_CYICON;
    } else if (aSymbol == @symbol(cursorWidth)) {
	arg = SM_CXCURSOR;
    } else if (aSymbol == @symbol(cursorHeight)) {
	arg = SM_CYCURSOR;
    } else if (aSymbol == @symbol(captionHeight)) {
	arg = SM_CYCAPTION;
    } else if (aSymbol == @symbol(resizeFrameWidth)) {
	arg = SM_CXFRAME;
    } else if (aSymbol == @symbol(resizeFrameHeight)) {
	arg = SM_CYFRAME;
    } else if (aSymbol == @symbol(borderFrameWidth)) {
	arg = SM_CXBORDER;
    } else if (aSymbol == @symbol(borderFrameHeight)) {
	arg = SM_CYBORDER;
    } else if (aSymbol == @symbol(fullScreenWindowWidth)) {
	arg = SM_CXFULLSCREEN;
    } else if (aSymbol == @symbol(fullScreenWindowHeight)) {
	arg = SM_CYFULLSCREEN;
    } else {
	RETURN (nil);
    }
    info = GetSystemMetrics(arg);
    if (isBool) {
	RETURN (info ? true : false);
    }
    RETURN (__MKSMALLINT(info));
%}
!

platformName
    "ST-80 compatibility.
     Return a string describing the display systems platform."

    ^ 'WIN32'  

    "Modified: 26.5.1996 / 15:32:46 / cg"
! !

!WinWorkstation methodsFor:'accessing & queries'!

anyButtonMotionMask
    "return the state-mask for any button in motion events' state-field.
     This is the devices mask."

%{  /* NOCONTEXT */
    RETURN ( __MKSMALLINT(Button1MotionMask | Button2MotionMask | Button3MotionMask));
%}
!

blackpixel
    "return the colornumber of black"

    ^ blackpixel
!

button1MotionMask
    "return the state-mask for button1 in motion events' state-field.
     For backward compatibility."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(Button1MotionMask));
%}

    "
     Display button1MotionMask
    "
!

button2MotionMask
    "return the state-mask for button2 in motion events' state-field
     For backward compatibility."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(Button2MotionMask)); 
%}
!

button3MotionMask
    "return the state-mask for button3 in motion events' state-field
     For backward compatibility."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(Button3MotionMask)); 
%}
!

buttonMotionMask:aButton
    "return the state-mask for button1 in motion events state-field.
     This is the devices mask."

%{  /* NOCONTEXT */
    if (aButton == __MKSMALLINT(1)) {
	RETURN (__MKSMALLINT(Button1MotionMask));    
    }
    if (aButton == __MKSMALLINT(2)) {
	RETURN (__MKSMALLINT(Button2MotionMask));    
    }
    if (aButton == __MKSMALLINT(3)) {
	RETURN (__MKSMALLINT(Button3MotionMask));    
    }
%}.
    ^ nil
!

controlMask
    "return the state-mask for the CTRL modified in motion events' state-field."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(ControlMask));
%}
!

defaultEventMask
    "return a mask to enable some events by default."

%{  /* NOCONTEXT */
#ifdef XXX
    RETURN (__MKSMALLINT(ExposureMask | StructureNotifyMask |
			 KeyPressMask | KeyReleaseMask |
			 EnterWindowMask | LeaveWindowMask |
			 ButtonPressMask | ButtonMotionMask | ButtonReleaseMask ));
#endif
%}.
    ^ 0
!

displayFileDescriptor
    "return the displays fileNumber for select, if any"

%{  /* NOCONTEXT */
    RETURN (nil);
%}
!

displayName
    "return the display-connections display name.
     For Windows, a dummy name is returned"

    ^ 'local'
!

getSystemColor:aKey
    |rgb|

    rgb := self primGetSystemColor:aKey.
    rgb notNil ifTrue:[
	^ Color
	    redByte:((rgb bitShift:-16) bitAnd:16rFF)
	    greenByte:((rgb bitShift:-8) bitAnd:16rFF)
	    blueByte:(rgb bitAnd:16rFF)
    ].
    ^ nil
!

primGetSystemColor:aKey
%{  /* UNLIMITEDSTACK (WIN95 only) */
    if (aKey == @symbol(COLOR_WINDOW)) {
	RETURN (__MKSMALLINT(GetSysColor(COLOR_WINDOW)));
    }
    if (aKey == @symbol(COLOR_WINDOWTEXT)) {
	RETURN (__MKSMALLINT(GetSysColor(COLOR_WINDOWTEXT)));
    }
    if (aKey == @symbol(COLOR_MENU)) {
	RETURN (__MKSMALLINT(GetSysColor(COLOR_MENU)));
    }
    if (aKey == @symbol(COLOR_MENUTEXT)) {
	RETURN (__MKSMALLINT(GetSysColor(COLOR_MENUTEXT)));
    }
    RETURN (nil);
%}.
!

primTranslatePointX:x y:y from:windowId1 to:windowId2

%{  /* UNLIMITEDSTACK (WIN95 only) */
    HWND w1, w2;
    POINT point;

    if (__isExternalAddress(windowId1)
     && __isExternalAddress(windowId2)
     && __bothSmallInteger(x, y)) {
	w1 = _HWNDVal(windowId1);
	w2 = _HWNDVal(windowId2);
	point.x = __intVal(x);
	point.y = __intVal(y);
	DPRINTF(("TransPoint %x %d/%d ->",w1,point.x,point.y));
	ClientToScreen(w1,&point);
	ScreenToClient(w2,&point);
	DPRINTF((" %x %d/%d\n",w2,point.x,point.y));
	RETURN (__MKPOINT_INT(point.x, point.y));

#if 0
    int xpos, ypos;
    RECT srcRect, dstRect;
    RECT srcClRect, dstClRect;
	GetWindowRect(w1, &srcRect);
	GetWindowRect(w2, &dstRect);
	memset(&srcClRect,0,sizeof(srcClRect));
	memset(&dstClRect,0,sizeof(dstClRect));
	/*GetClientRect(w1, &srcClRect);
	GetClientRect(w2, &dstClRect);*/

	DDPRINTF(("srcRect: %d/%d -> %d/%d   dstRect: %d/%d -> %d/%d\n",
	    srcRect.left, srcRect.top, srcRect.right, srcRect.bottom,
	    dstRect.left, dstRect.top, dstRect.right, dstRect.bottom));
	printf("srcRect: %d/%d -> %d/%d   dstRect: %d/%d -> %d/%d\n",
	    srcRect.left, srcRect.top, srcRect.right, srcRect.bottom,
	    dstRect.left, dstRect.top, dstRect.right, dstRect.bottom);

	xpos = (srcRect.left + srcClRect.left) - (dstRect.left + dstClRect.left) + __intVal(x);
	ypos = (srcRect.top + srcClRect.top) - (dstRect.top + dstClRect.top) + __intVal(y);
	RETURN (__MKPOINT_INT(xpos, ypos));
#endif
    }
    RETURN (nil);
%}
!

protocolVersion
    "return the displays protocol version.
     For Windows, a dummy number is returned"

    ^ '1'

    "
     Display protocolVersion
    "
!

serverVendor
    "return the server vendor string. 
     For Windows, a dummy name is returned"

    ^ 'microsoft'

    "
     Display serverVendor
    "
!

shiftMask
    "return the state-mask for the SHIFT modified in motion events' state-field."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(ShiftMask));
%}
!

translatePoint:aPoint from:windowId1 to:windowId2
    "given a point in window1, return the coordinate in window2.
     This expects a device coordinate (relative to the first views origin)
     in aPoint and returns a device coordinate relative to the 2nd views origin.
     - use to xlate points from a window to rootwindow"

    |x1 y1|

    x1 := aPoint x truncated.
    y1 := aPoint y truncated.
    ^ self primTranslatePointX:x1 y:y1 from:windowId1 to:windowId2
!

vendorRelease
    "return the display-servers vendor release 
     - should normally not be of any interest, 
     but may be usefule for special cases.
     (to avoid bugs in certain implementations / releases)"

    ^ 1

    "
     Display vendorRelease
    "
!

viewIdFromPoint:aPoint in:windowId
    "given a point in rootWindow, return the viewId of the subview of windowId
     hit by this coordinate. Return nil if no view was hit.
     The returned id may be the id of a non ST view.
     - used to find the window to drop objects after a cross-view drag."
     
    windowId notNil ifTrue:[
	aPoint isPoint ifTrue:[
	    ^ self primViewIdFromPoint:aPoint asPoint truncated in:windowId
	]
    ].

    ^ nil
!

primViewIdFromPoint:aPoint in:windowId
    "given a point in rootWindow, return the viewId of the subview of windowId
     hit by this coordinate. Return nil if no view was hit.
     The returned id may be the id of a non ST view.
     - used to find the window to drop objects after a cross-view drag."

%{  /* UNLIMITEDSTACK (WIN95 only) */

    OBJ xp, yp;
    int xpos, ypos;
    HWND child_return;

    if (ISCONNECTED
     && __isExternalAddress(windowId)
     && __isPoint(aPoint))
    {
	xp = _point_X(aPoint);
	yp = _point_Y(aPoint);
	if (__bothSmallInteger(xp, yp))
	{
	    POINT p;
	    HWND hWnd = _HWNDVal(windowId);
	    p.x = __intVal(xp);
	    p.y = __intVal(yp);
	    child_return = ChildWindowFromPoint(hWnd,p);

	    if ((child_return) && (child_return != hWnd))
	    {
		RETURN ( __MKEXTERNALADDRESS(child_return) );
	    }
	    RETURN ( nil );
	}
    }
%}.
!


whitepixel
    "return the colornumber of white"

    ^ whitepixel
! !

!WinWorkstation methodsFor:'accessing display capabilities'!

scrollsAsynchronous
    "return true, if this display asynchronously sends expose events after a
     scroll operation. False otherwise. Asynchronous expose events are an X
     speciality, which affects a few methods outside of the display class (sorry)"

    "/ event Handling erst verbessern 
    ^ false
!

supportedImageFormats
    "return an array with supported image formats; each array entry
     is another array, consisting of depth and bitsPerPixel values."

    |info|

    info := IdentityDictionary new.
    info at:#depth put:depth.
    info at:#bitsPerPixel put:depth.
    info at:#padding put:32.
    ^ Array with:info
!


iconSizes
    "Get the preferred/supported icon sizes."

    |d|

    d := IdentityDictionary new.
    d at:#minWidth put:(self class getSystemMetrics:#iconWidth).
    d at:#maxWidth put:(self class getSystemMetrics:#iconHeight).
    d at:#widthStep put:1.
    d at:#minHeight put:(self class getSystemMetrics:#iconWidth).
    d at:#maxHeight put:(self class getSystemMetrics:#iconHeight).
    d at:#heightStep put:1.

    ^ OrderedCollection with:d

    "
     Display iconSizes
    "
!

supportsIconViews
    "return true, if this device supports views as icons."

    ^ true

    "
     Display supportsIconViews
    "

    "Modified: 10.6.1996 / 20:11:48 / cg"
    "Created: 10.6.1996 / 21:08:18 / cg"
!

supportsDeepIcons
    "return true, if this device supports deepicons."

    ^ true

!

usableExtent
    "return the usable extent of the display (in pixels).
     Normally, the same as extent, but may be smaller, in
     case some menu space is taken up by the window manager (windows)"

    ^ (self class getSystemMetrics:#fullScreenWindowWidth)
      @
      (self class getSystemMetrics:#fullScreenWindowHeight)
! !

!WinWorkstation methodsFor:'bitmap/window creation'!

createBitmapFromArray:anArray width:w height:h
    |bitmapId|

    bitmapId := self primCreateBitmapFromArray:anArray width:w height:h.

    bitmapId isNil ifTrue:[
	'WINWORKSTATION: cannot create bitmap' errorPrintCR.
    ].
    ^ bitmapId
!

createBitmapWidth:w height:h

%{  /* UNLIMITEDSTACK (WIN95 only) */
    HANDLE newBitmapHandle;
    int b_width, b_height;
/*    printf("CreateBitmap B/W\n");*/

    if (__bothSmallInteger(w, h)) {
	b_width = __intVal(w);
	b_height = __intVal(h);
	newBitmapHandle = CreateBitmap(b_width, b_height, 1, 1, NULL);

	if (newBitmapHandle)
	{
#ifdef COUNT_RESOURCES
	    __cnt_bitmap++;
	   printf("CreateBitmap %d\n",__cnt_bitmap);
#endif
	  RETURN ( __MKOBJ(newBitmapHandle));
	}
	DPRINTF(("empty bitmap handle = %x\n", newBitmapHandle));

    }
    RETURN (nil);
%}
!

createPixmapWidth:w height:h depth:d
    "allocate a pixmap on the Xserver, the contents is undefined
     (i.e. random). Return a bitmap id or nil"

%{  /* UNLIMITEDSTACK (WIN95 only) */
    /* die todo */
    HANDLE newBitmapHandle;
    /*printf("CreateBitmap Color\n");*/
    if (__bothSmallInteger(w, h) && __isSmallInteger(d) && ISCONNECTED)
    {
	if (__intVal(d) == 1)
	{
	  newBitmapHandle = CreateBitmap(__intVal(w), __intVal(h) , 1, 1, NULL);
	}
	else
	{
	  /*if (__intVal(d) != __depth)
	  {
	    printf("invalite depth\n");
	    RETURN (nil);
	  } */
	  newBitmapHandle = CreateCompatibleBitmap(__rootDC,__intVal(w), __intVal(h) );
	}
	if (newBitmapHandle)
	{
#ifdef COUNT_RESOURCES
	    __cnt_bitmap++;
	   printf("CreateBitmap %d\n",__cnt_bitmap);
#endif
	  RETURN ( __MKOBJ(newBitmapHandle));
	}
	DPRINTF(("empty bitmap handle = %x\n", newBitmapHandle));
    }
    RETURN (nil);
%}
!

createWindowFor:aView type:typeSymbol
		 origin:origin
		 extent:extent
		 minExtent:minExt
		 maxExtent:maxExt
		 borderWidth:bWidth
		 subViewOf:wsuperView
		 style:wStyle
		 inputOnly:winputOnly
		 label:wlabel
		 owner:wowner
		 icon:wicon
		 iconMask:wiconMask
		 iconView:wiconView

    |xpos ypos wwidth wheight minWidth minHeight maxWidth maxHeight
     bColorId wsuperViewId wcursorId wiconId wiconMaskId windowId
     weventMask wiconViewId bitGravity viewGravity vBgColor
     vBgForm deepForm preferredVisual preferredDepth wiconHeight
     wiconWidth windowType windowClass moreArgs|

    displayId isNil ifTrue:[
	self primitiveFailed.
	^ nil
    ].

    origin notNil ifTrue:[
	xpos := origin x.
	ypos := origin y.
    ] ifFalse:[
	xpos := ypos := 0.
    ].
    extent notNil ifTrue:[
	wwidth := extent x.
	wheight := extent y.
    ] ifFalse:[
	wwidth := 100.
	wheight := 40.
    ].
    minExt notNil ifTrue:[
	minWidth := minExt x.
	minHeight := minExt y
    ].
    maxExt notNil ifTrue:[
	maxWidth := maxExt x.
	maxHeight := maxExt y
    ].

    wsuperView notNil ifTrue:[
	wsuperViewId := wsuperView id
    ].
"/    wcursor isNil ifTrue:[
"/        'XWORKSTATION: cursor nil - defaulted' errorPrintNL
"/    ] ifFalse:[
"/        wcursorId := wcursor id
"/    ].

    wicon notNil ifTrue:[
	wiconId := wicon id.
	wiconHeight := wicon height.
	wiconWidth  := wicon width.
	wiconMask notNil ifTrue:[
	    wiconMaskId := wiconMask id
	]
    ].
"/    wiconView notNil ifTrue:[
"/        wiconViewId := wiconView id
"/    ].
"/    weventMask := aView eventMask.

    NativeWindows ifTrue:[
	windowType := aView nativeWindowType.

	"/ if it is already a string, take it as it is;
	"/ otherwise, it must be a symbol and is used
	"/ as a key into the nativeClass translation map.

	windowType isString ifTrue:[
	    windowClass := windowType
	] ifFalse:[
	    windowClass := NativeWindowClassTable at:windowType ifAbsent:nil
	]
    ].

    moreArgs := Array new:20.
    moreArgs at:1 put:xpos.
    moreArgs at:2 put:ypos.
    moreArgs at:3 put:wwidth.
    moreArgs at:4 put:wheight.
    moreArgs at:5 put:minWidth.
    moreArgs at:6 put:minHeight.
    moreArgs at:7 put:maxWidth.
    moreArgs at:8 put:maxHeight.
    moreArgs at:9 put:wsuperViewId.
    moreArgs at:10 put:wcursorId.
    moreArgs at:11 put:wiconId.
    moreArgs at:12 put:wiconMaskId.
    moreArgs at:13 put:wiconWidth.
    moreArgs at:14 put:wiconHeight.
    moreArgs at:15 put:windowType.
    moreArgs at:16 put:windowClass.
    windowId := self 
		primCreateWindowFor:aView 
		type:typeSymbol 
		borderWidth:bWidth 
		subViewOf:wsuperView
		style:wStyle 
		inputOnly:winputOnly
		label:wlabel 
		owner:wowner 
		icon:wicon 
		iconMask:wiconMask
		moreArgs:moreArgs.

    windowId notNil ifTrue:[self addKnownView:aView withId:windowId].
    ^ windowId
!

destroyGC:aGCId
%{  /* UNLIMITEDSTACK (WIN95 only) */
    HDC hDC;
    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);

#ifdef COUNT_RESOURCES
	__gcDatas--;
#endif
	hDC = gcData->hDC;
	if (hDC)
	{
	  if (gcData->save.hPen) {
	      SelectObject(hDC,gcData->save.hPen);
	      gcData->save.hPen = 0;
	  }
	  if (gcData->save.hBrush) {
	      SelectObject(hDC,gcData->save.hBrush);
	      gcData->save.hBrush = 0;
	  }
	  if (gcData->save.hBitmap) {
	      SelectObject(hDC,gcData->save.hBitmap);
	      gcData->save.hBitmap = 0;
	  }
	  if (gcData->selected.hPen) {
	      DelObject(gcData->selected.hPen);
	      gcData->selected.hPen = 0;
	  }
	  if (gcData->selected.hBrush) {
	      DelObject(gcData->selected.hBrush);
	      gcData->selected.hBrush = 0;
	  }
	  if (gcData->selected.hBitmap) {
	      DelObject(gcData->selected.hBitmap);
	      gcData->selected.hBitmap = 0;
	  }
	  if (gcData->selected.hBrush) {
	      DelObject(gcData->selected.hBrush);
	      gcData->selected.hBrush = 0;
	  }
	  if (gcData->hWnd)
	  {
	    ReleaseDC(gcData->hWnd,gcData->hDC);
	  }
	  else
	  {
	    if (DeleteDC(gcData->hDC) == 0)
	      printf("ERROR DeleteDC\n");
	  }
	  gcData->hDC = (HDC)0;
	}
	free(gcData);
    }
%}
!

destroyPixmap:aDrawableId

%{  /* UNLIMITEDSTACK (WIN95 only) */
    if (__isExternalAddress(aDrawableId) && ISCONNECTED) {
	HANDLE bitmapHandle = _HANDLEVal(aDrawableId);

	if (bitmapHandle)
	{
#ifdef COUNT_RESOURCES
	    __cnt_bitmap--;
	    printf("DestroyBitmap %d\n",__cnt_bitmap);
#endif
	    if( DelObject(bitmapHandle) )
	    {
		DPRINTF(("Bitmap deleted!\n"));
	    }
	}
    }
%}
!

destroyView:aView withId:aWindowId
    self primDestroyView:aView withId:aWindowId.
    self removeKnownView:aView withId:aWindowId
!

gcFor:aDrawableId

%{  /* UNLIMITEDSTACK (WIN95 only) */
    HDC dc;
    HWND hWnd;
    struct gcData *gcData;

    if (__isExternalAddress(aDrawableId)) {
	hWnd = _HWNDVal(aDrawableId);
	dc = GetDC(hWnd);
	/*dc = GetDCEx(hWnd,0,DCX_CLIPCHILDREN);*/
	if (! dc) {
	    RETURN (nil);
	}
	gcData = newGcData();
	if (! gcData) {
	    RETURN (nil);
	}
#ifdef COUNT_RESOURCES
	__gcDatas++;
#endif
	gcData->hWnd = hWnd;
	gcData->hDC = dc;

	RETURN ( __MKOBJ(gcData) );
    }
    RETURN (nil);
%}
!

gcForBitmap:aDrawableId

%{  /* UNLIMITEDSTACK (WIN95 only) */
    struct gcData *gcData;

    if (__isExternalAddress(aDrawableId)) {  /* HBITMAP */
	HBITMAP hBitmap = _HBITMAPVAL(aDrawableId);
	HDC hDC = CreateCompatibleDC(__rootDC);
	if (! hDC) {
	    RETURN (nil);
	}
	gcData = newGcData();
	if (! gcData) {
	    RETURN (nil);
	}

	gcData->hDC = hDC;
	gcData->save.hBitmap = SelectObject(hDC,hBitmap);

#ifdef COUNT_RESOURCES
	__gcDatas++;
#endif
	RETURN ( __MKOBJ(gcData) );
    }
    RETURN (nil);
%}
!

primCreateBitmapFromArray:anArray width:w height:h

%{  /* UNLIMITEDSTACK */

    HBITMAP newBitmapHandle;
    unsigned char fastBits[10000];
    int b_width, b_height, bytesPerRowST, bytesPerRowWN, padding, nBytes;
    int row, col;
    unsigned char *cp, *bPits;
    unsigned char *b_bits;
    unsigned char *pBits;
    int index;
    unsigned char *allocatedBits = 0;
/*
    if (! ISCONNECTED) {
	RETURN (nil);
    }
*/
    if (__bothSmallInteger(w, h) && _isNonNilObject(anArray))
    {
	b_width = __intVal(w);
	b_height = __intVal(h);
	bytesPerRowST = (b_width + 7) / 8;
	bytesPerRowWN = (b_width + 15) / 16 * 2;
	padding = bytesPerRowWN - bytesPerRowST;
	nBytes = b_height * bytesPerRowWN;

	if (nBytes < sizeof(fastBits))
	{
	    cp = b_bits = fastBits;
	}
	else
	{
	    cp = b_bits = allocatedBits = (unsigned char *) malloc(nBytes);
	}
	if (cp)
	{
	    if (__qClass(anArray) == @global(ByteArray))
	    {
		pBits = __ByteArrayInstPtr(anArray)->ba_element;
		for (row = b_height; row; row--) {
		    for (col = bytesPerRowST; col; col--) {
			*cp++ = ( *pBits++ /*^ 0xFF */);
		    }
		    cp += padding;
		}
		DPRINTF(("create bitmap ...\n"));

		newBitmapHandle = CreateBitmap(b_width, b_height, 1, 1, b_bits );

		if( newBitmapHandle )
		{
#ifdef COUNT_RESOURCES
		  __cnt_bitmap++;
		  printf("CreateBitmap %d\n",__cnt_bitmap);
#endif
		  DPRINTF(("returning bitmap ...\n"));
		  RETURN ( __MKOBJ(newBitmapHandle));
		}
		DPRINTF(("create bitmap FAILED!!!\n"));
	    }
	    else
	    {
		DPRINTF(("not a ByteArray\n"));
	    }

	}
    }
    if (allocatedBits)
    {
      DPRINTF(("freeing up bitmap bits ...\n"));
      free(allocatedBits);
    }
    DPRINTF(("returning nil ...\n"));
    RETURN ( nil );
%}
!

primCreateWindowFor:aView type:aSymbol
	  borderWidth:bWidth subViewOf:wsuperView
	  style:wStyle inputOnly:winputOnly
	  label:wlabel owner:wowner
	  icon:wicon iconMask:wiconMask
	  moreArgs:moreArgs

%{  /* UNLIMITEDSTACK */

    WNDCLASS wc;
    long bg, bd, bw;
    int winStyleBits, winEXStyleBits;
    int w, h, x, y;
    int min_width, min_height;
    int max_width, max_height;
    RECT rec;
    HANDLE parentHandle;
    OBJ xpos, ypos, wwidth, wheight;
    OBJ minWidth, minHeight, maxWidth, maxHeight;
    OBJ wsuperViewId, wcursorId, wiconId, wiconMaskId;
    OBJ wiconWidth, wiconHeight;
    OBJ windowType, windowClass, windowId;
    int isTopWindow = 0;

    unsigned char* cp;
    HBITMAP        xBitMap, maskBitmap;
    int            height, width;
    int            nBytes, nBits;
    int            index;
    HICON          xIcon = (HICON)0;
    SIZE           oldSize;
    ICONINFO       iconInfo;
    char *className;

    xpos = __ArrayInstPtr(moreArgs)->a_element[0];
    ypos = __ArrayInstPtr(moreArgs)->a_element[1];
    wwidth = __ArrayInstPtr(moreArgs)->a_element[2];
    wheight = __ArrayInstPtr(moreArgs)->a_element[3];
    minWidth = __ArrayInstPtr(moreArgs)->a_element[4];
    minHeight = __ArrayInstPtr(moreArgs)->a_element[5];
    maxWidth = __ArrayInstPtr(moreArgs)->a_element[6];
    maxHeight = __ArrayInstPtr(moreArgs)->a_element[7];
    wsuperViewId = __ArrayInstPtr(moreArgs)->a_element[8];
    wcursorId = __ArrayInstPtr(moreArgs)->a_element[9];
    wiconId = __ArrayInstPtr(moreArgs)->a_element[10];
    wiconMaskId = __ArrayInstPtr(moreArgs)->a_element[11];
    wiconWidth = __ArrayInstPtr(moreArgs)->a_element[12];
    wiconHeight = __ArrayInstPtr(moreArgs)->a_element[13];
    windowType = __ArrayInstPtr(moreArgs)->a_element[14];
    windowClass = __ArrayInstPtr(moreArgs)->a_element[15];

    bg = WhitePixel;
    bd = BlackPixel;
#if 1
    /* get bitmap for icon */
    if(  __isExternalAddress(wiconId) )
    {
	xBitMap = _HBITMAPVAL( wiconId );
	if( xBitMap != 0 )
	{
	  BITMAP bm;
	  if (GetObject(xBitMap, sizeof(bm), (LPSTR)&bm))
	  {
	    int d = bm.bmPlanes * bm.bmBitsPixel;
	    BYTE *ep;

	    DPRINTF(("Bitmap w:%d h:%d p:%d d:%d\n",bm.bmWidth,bm.bmHeight,bm.bmPlanes,bm.bmBitsPixel));
	    height = __intVal( wiconHeight );
	    width  = __intVal( wiconWidth  );
	    nBytes = ( width + 15 ) / 16;
	    nBytes = height * nBytes * 2;
	    ep = (unsigned char *) malloc(nBytes);
	    if ( ep != 0 )
	    {
		memset(ep,0,nBytes);
		maskBitmap = CreateBitmap(width, height, 1, 1, ep );
		free(ep);
		if( maskBitmap != NULL )
		{
		    DPRINTF(( "BITMAP mask CREATED!!!\n" ));
		    iconInfo.fIcon = TRUE;
		    iconInfo.hbmMask  = maskBitmap;
		    iconInfo.hbmColor = xBitMap;
		    xIcon = CreateIconIndirect( &iconInfo );
		    DPRINTF(( "ICON CREATED!!!\n" ));
		    DelObject( maskBitmap );
		} else {
		    DPRINTF(( "BITMAP mask CREATION failed!!!\n" ));
		}
	    } else {
		DPRINTF(( " malloc failed\n" ));
	    }
	  }
	} else {
	    DPRINTF((" xBitMap is zero \n" ));
	}
    } else {
	if (wiconId == nil) {
	    DPRINTF((" wiconId is nil\n"));
	} else {
	    DPRINTF((" wiconId is not an external address\n"));
	}
    }
#endif
    if (__bothSmallInteger(wwidth, wheight)) {
	w = __intVal(wwidth);
	h = __intVal(wheight);
    } else {
	w = h = 100;
    }

    if (__bothSmallInteger(xpos, ypos)) {
	x = __intVal(xpos);
	y = __intVal(ypos);
    } else {
	x = y = 0;
    }

    if (__bothSmallInteger(minWidth, minHeight)) {
	min_width = __intVal(minWidth);
	min_height = __intVal(minHeight);
    } else {
	min_width = min_height = 0;
    }

    if (__bothSmallInteger(maxWidth, maxHeight)) {
	max_width = __intVal(maxWidth);
	max_height = __intVal(maxHeight);
    } else {
	max_width = max_height = 10000;
    }

    winStyleBits = winEXStyleBits = 0;

    if (__isSmallInteger(bWidth)) {
	bw = __intVal(bWidth);
	if (bw) {
	    winStyleBits |= WS_BORDER;
	    bw = 1;
	}
    } else {
	bw = 0;
    }

    className = app_name;

/*    if (__isString(windowClass)) {
	className = __stringVal(windowClass);
    }

    if (__isString(windowClass)) {
	if (__isInteger(wStyle)) {
	    winStyleBits |= __longIntVal(wStyle);
	} else {
	    if (windowType == @symbol(RadioButton)) {
		winStyleBits |= BS_RADIOBUTTON;
	    } else if (windowType == @symbol(CheckBox)) {
		winStyleBits |= BS_CHECKBOX;
	    } else if (windowType == @symbol(HorizontalScrollbar)) {
		winStyleBits |= SBS_HORZ;
	    } else if (windowType == @symbol(VerticalScrollBar)) {
		winStyleBits |= SBS_VERT;
	    }
	}
    }
*/
    if (__isExternalAddress(wsuperViewId)) {
	/*
	 * a child window
	 */
	parentHandle = _HANDLEVal(wsuperViewId);
	winStyleBits |= WS_CHILD | WS_CLIPSIBLINGS;
	DPRINTF(("parent handle=%x\n", parentHandle));

    }
    else
    {
	char buf[200];
	static winCount;
	sprintf(buf,"%s#%d",app_name,++winCount);
	/*
	 * a top window
	 */
	parentHandle = NULL;
	isTopWindow = 1;
	DPRINTF(("topview - registerClass\n"));


#if 1
	wc.style = /* CS_HREDRAW | CS_VREDRAW |*/ CS_OWNDC  | CS_DBLCLKS;
	wc.lpfnWndProc = (WNDPROC) MainWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = N_WINDOW_PRIVATE;
	wc.hInstance = (HANDLE) __getHInstance();
	if (xIcon) {
	    wc.hIcon   = xIcon;
	    /* wc.hIconSm = wiconId; In 4.x there are large and small icons */
	} else {
	    wc.hIcon = NULL;        /* THIS MUST BE NULL TO DELETE ICONS */
	}
	wc.hCursor = 0 /* LoadCursor(NULL, IDC_ARROW) */;

	wc.hbrBackground = 0; /*CreateSolidBrush (bg);*/

	wc.lpszMenuName =  NULL;
	wc.lpszClassName = buf;

	if (!RegisterClass(&wc)) {
	    DPRINTF(("RegisterClass failed\n"));
/*            return NULL;     */
	}

	className = buf;
#endif
	winStyleBits |= WS_CLIPCHILDREN;

	if (wStyle == @symbol(popUp)) {
	    winStyleBits |= WS_POPUP;
	} else if (wStyle == @symbol(dialog)) {
/*
	    winStyleBits |= WS_OVERLAPPED | WS_CAPTION | WS_THICKFRAME;
*/
	    winStyleBits |= WS_OVERLAPPED | WS_CAPTION | DS_MODALFRAME | WS_SYSMENU;
	    if ((min_width || min_height)
	     && (min_width == max_width)
	     && (min_height == max_height)) {
		winStyleBits &= ~WS_THICKFRAME;
	    }
	} else {
	    winStyleBits |= WS_OVERLAPPEDWINDOW;
	    winEXStyleBits |= WS_EX_CLIENTEDGE;

	}
    }
    rec.left = x;
    rec.top = y;
    rec.right = x + w;
    rec.bottom = y+ h;
    _thread_winStyleBitsEx = WS_EX_LEFT | WS_EX_NOPARENTNOTIFY;
    AdjustWindowRectEx(&rec,winStyleBits,0,_thread_winStyleBitsEx);

    DPRINTF(("create%s pos==%d/%d size=%d/%d bw=%d class='%s'...\n",
		((wStyle == @symbol(popUp)) ? " popUp" : ""), x, y, w, h, bw, className));

    /* allocate localMemory for Window */
    _thread_local = (localWindowInfo*)malloc(sizeof(localWindowInfo));
    if (_thread_local)
    {
      memset(_thread_local,0,sizeof(*_thread_local));
      _thread_local->minWidth = min_width;
      _thread_local->maxWidth = max_width;
      _thread_local->minHeight = min_height;
      _thread_local->maxHeight = max_height;
      if (isTopWindow)
	_thread_local->flag = LI_TOPWIN;

      _thread_className = className;
      _thread_winStyleBits = winStyleBits;
      _thread_parentHandle = parentHandle;
      _thread_x = rec.left;
      _thread_y = rec.top;
      _thread_dx = rec.right - rec.left;
      _thread_dy = rec.bottom - rec.top;
      _thread_newWinHandle = 0;

      if (isTopWindow)
      {
	  if (__isString(wlabel) || __isSymbol(wlabel)) {
	      _thread_windowName = (char *) __stringVal(wlabel);
	      DPRINTF(("title = %s\n", _thread_windowName));
	  }
      }
      PostThreadMessage(_dispatchThreadId,WM_THREADCREATEWINDOW,0,0);
      {
	DWORD dwWaitResult;

	/* Request ownership of mutex. */
	dwWaitResult = WaitForSingleObject(
	  hCreateEvent,   /* handle of mutex */
	  5000L);   /* time-out interval */
      }
    }

    DPRINTF(("handle = %x\n", _thread_newWinHandle));

    if (! _thread_newWinHandle) {
	RETURN ( nil );
    }

    windowId = __MKOBJ(_thread_newWinHandle);
    DPRINTF(("done - create\n"));
    RETURN (windowId);
%}
!

primDestroyView:aView withId:aWindowId

%{  /* UNLIMITEDSTACK (WIN95 only) */
    HICON yIcon;
    if (__isExternalAddress(aWindowId)) {
	HWND win = _HWNDVal(aWindowId);

	if (win && IsWindow(win))
	{
	   yIcon = (HICON)GetClassLong(_thread_newWinHandle,GCL_HICON);
	   SetClassLong(_thread_newWinHandle,GCL_HICON,(DWORD)0);
	   /* It has to be checked whether thia can be deleted!!!!! */
	   if( yIcon )
	   {
		if( DestroyIcon( yIcon ) )
		    DPRINTF(( "Old icon deleted\n" ));
	   }
	   /*printf("post WM_THREADDESTROYWINDOW\n");*/
	   PostMessage(win,WM_THREADDESTROYWINDOW,0,0);
	}
    }
%}
!

rootWindowId
    "return the id of the root window.
     This is the window you see as background,
     however, it may or may not be the real physical root window,
     since some window managers install a virtual root window on top
     of the real one. If this is the case, that views id is returned here."

    ^ rootWin
! !

!WinWorkstation methodsFor:'color stuff'!

colorRed:redVal green:greenVal blue:blueVal
    "allocate a color with rgb values (0..100) - return the color index (i.e. colorID).
     This method is obsoleted by #colorScaledRed:scaledGreen:scaledBlue:"

    |r g b|

    r := self percentToDeviceColorValue:redVal.
    g := self percentToDeviceColorValue:greenVal.
    b := self percentToDeviceColorValue:blueVal.
    ^ self colorScaledRed:r scaledGreen:g scaledBlue:b
!

colorScaledRed:r scaledGreen:g scaledBlue:b
    "allocate a color with rgb values (0..16rFFFF) - return the color index
     (i.e. colorID)"
%{
    int id, ir, ig, ib;

    if (__bothSmallInteger(r, g)
     && __isSmallInteger(b))
    {
      id = RGB2st(__intVal(r),__intVal(g),__intVal(b));
      DDPRINTF(("alloc color %d/%d/%d -> %x\n", ir, ig, ib, id));
      RETURN ( __MKSMALLINT(id) );
    }
%}.
    self primitiveFailed.
    ^ nil
!

freeColor:colorIndex
    "free a display color when its no longer needed"

    'free color' printCR.
    ^ self
!

getRGBFrom:index into:aBlock
    "get rgb components (0..100) of color in map at:index,
     and evaluate the 3-arg block, aBlock with them"

    |val|

    self getScaledRGBFrom:index into:[:r :g :b |
	val := aBlock
		value:(r * 100.0 / 16rFFFF)
		value:(g * 100.0 / 16rFFFF)
		value:(b * 100.0 / 16rFFFF)
    ].
    'get RGB' printCR.
    ^ val
!

getScaledRGBFrom:index into:aBlock
    "get rgb components (0 .. 16rFFFF) of color in map at:index,
     and evaluate the 3-arg block, aBlock with them"

    |r g b|
%{
    int id = __intVal(index);
    int iR, iG, iB;

    id = st2RGB(id);
    iR = id & 0xFF;
    iG = (id >> 8) & 0xFF;
    iB = (id >> 16) & 0xFF;
    iR = (iR << 8) | iR;
    iG = (iG << 8) | iG;
    iB = (iB << 8) | iB;

    r = __MKSMALLINT(iR);
    g = __MKSMALLINT(iG);
    b = __MKSMALLINT(iB);
    /*printf("get color %x -> %x/%x/%x\n",id, iR, iG, iB);*/
%}.
    ^ aBlock value:r value:g value:b
!

percentToDeviceColorValue:aPercentage
    "given a color-component value in percent (0..100), return the corresponding
     WIN-component value (0..16rFFFF) as an integer"

%{  /* NOCONTEXT */

    if (__isSmallInteger(aPercentage)) {
	RETURN ( __MKSMALLINT(0xFFFF * __intVal(aPercentage) / 100) );
    }
    if (__isFloat(aPercentage)) {
	RETURN ( __MKSMALLINT(0xFFFF * (int)(__floatVal(aPercentage)) / 100) );
    }
%}.
    ^ (16rFFFF * aPercentage / 100) rounded
! !

!WinWorkstation methodsFor:'cursor stuff'!

builtInCursorShapes
    "return a collection of standard cursor names.
     Those are built into Windows and need not be created as
     user cursors.
     (actually, there are more than those below ...)"

    "/ if you add something here, also add to #shapeNumberFromCursor ...

    ^ #(
	#upLeftArrow            "/ IDC_ARROW
	#upDownArrow            "/ IDC_SIZENS
	#leftRightArrow         "/ IDC_SIZEWE
	#text                   "/ IDC_IBEAM
	#wait                   "/ IDC_WAIT
	#execute                "/ IDC_APPSTARTING
	#crossHair              "/ IDC_CROSS
	#fourWay                "/ IDC_SIZEALL
       )
!

createCursorShape:aShape
    "create a cursor given a shape-symbol"

    |number|

    number := self shapeNumberFromSymbol:aShape.
    ^ self primCreateCursorShapeNr:number
!

createCursorSourceBits:sourceBytes maskBits:maskBytes hotX:hx hotY:hy width:w height:h
    "create a cursor given 2 bitmaps (source, mask) and a hotspot"

    |id padding bpl bplPadded srcOffs dstOffs
     src mask srcPadded maskPadded cW cH nB nR cursor |

    cW := self class getSystemMetrics:#cursorWidth.
    cH := self class getSystemMetrics:#cursorHeight.
    "/ ('cursorWidth ',cW printString,'cursorHeight ',cH printString) infoPrintCR.
    src := sourceBytes.
    mask := maskBytes.
    padding := self cursorBitmapPadding.

    "/ repadding and/or resizing required ?
    bpl := sourceBytes size / h.
    bplPadded := (cW + padding - 1) // padding * 2.

    bpl ~~ bplPadded ifTrue:[
	 "/     'repad cursor bits' infoPrintCR.
	srcPadded := ByteArray new:(bplPadded * cH).
	nB := bpl min: bplPadded.
	nR := cH min: h.

	dstOffs := srcOffs := 1.
	1 to:nR do:[:row |
	    srcPadded
		replaceFrom:dstOffs
		to:(dstOffs+nB-1)
		with:src
		startingAt:srcOffs.
	    dstOffs := dstOffs + bplPadded.
	    srcOffs := srcOffs + bpl.
	].

	maskPadded := ByteArray new:(bplPadded * cH).
	dstOffs := srcOffs := 1.
	1 to:nR do:[:row |
	    maskPadded
		replaceFrom:dstOffs
		to:(dstOffs+nB-1)
		with:mask
		startingAt:srcOffs.
	    dstOffs := dstOffs + bplPadded.
	    srcOffs := srcOffs + bpl.
	].
	src := srcPadded.
	mask := maskPadded.

    ].
    mask invert.
    "/src invert.
    cursor := self
	primCreateCursorSourceBits:src
	maskBits:mask
	hotX:hx hotY:hy
	width:cW height:cH.
    cursor notNil ifTrue:[  ^ cursor ].
    self halt.
!

createCursorSourceForm:sourceBytes maskForm:maskBytes hotX:hx hotY:hy width:w height:h
    "create a cursor given 2 bitmaps (source, mask) and a hotspot"
    'createCursorSourceForm:maskForm:hotX:hotY:width:height: not yet implemented' errorPrintCR.
!

cursorBitmapPadding
    ^ 16 "/ windows requires short-padded rows
!

destroyCursor:aCursorId

%{  /* UNLIMITEDSTACK (WIN95 only) */

    if (ISCONNECTED) {
	if (__isExternalAddress(aCursorId)) {
	    HCURSOR curs = _HCURSORVal(aCursorId);

	    if (curs) {
#ifdef KEEP_STD_CURSORS
		if ((curs != H_C_ARROW)
		 && (curs != H_C_CROSS)
		 && (curs != H_C_IBEAM)
		 && (curs != H_C_ICON)
		 && (curs != H_C_NO)
		 && (curs != H_C_SIZE)
		 && (curs != H_C_SIZEALL)
		 && (curs != H_C_SIZENESW)
		 && (curs != H_C_SIZENS)
		 && (curs != H_C_SIZENWSE)
		 && (curs != H_C_UPARROW)
		 && (curs != H_C_WAIT)) 
#endif /* KEEP_STD_CURSORS */
		{
		    DestroyCursor(curs);
		}
	    }
	    RETURN ( self );
	}
    }
%}
!

needDeviceFormsForCursor
    ^ false
!

primCreateCursorShapeNr:number

%{  /* UNLIMITEDSTACK (WIN95 only) */
    HCURSOR newCursor;
    LPCTSTR cId;

    if (__isSmallInteger(number)) {
	cId = (LPCTSTR)(__intVal(number));
	newCursor = LoadCursor(NULL, cId);
	if (newCursor) {
#ifdef KEEP_STD_CURSORS
	    if (cId == IDC_ARROW)
		H_C_ARROW = newCursor;
	    else if (cId == IDC_CROSS)
		H_C_CROSS = newCursor;
	    else if (cId == IDC_IBEAM)
		H_C_IBEAM = newCursor;
	    else if (cId == IDC_ICON)
		H_C_ICON = newCursor;
	    else if (cId == IDC_NO)
		H_C_NO = newCursor;
	    else if (cId == IDC_SIZE)
		H_C_SIZE = newCursor;
	    else if (cId == IDC_SIZEALL)
		H_C_SIZEALL = newCursor;
	    else if (cId == IDC_SIZENESW)
		H_C_SIZENESW = newCursor;
	    else if (cId == IDC_SIZENS)
		H_C_SIZENS = newCursor;
	    else if (cId == IDC_SIZENWSE)
		H_C_SIZENWSE = newCursor;
	    else if (cId == IDC_UPARROW)
		H_C_UPARROW = newCursor;
	    else if (cId == IDC_WAIT)
		H_C_WAIT = newCursor;
#endif /* KEEP_STD_CURSORS */
	    RETURN ( __MKOBJ(newCursor) );
	}
    }
    RETURN (nil);
%}
!

primCreateCursorSourceBits:src maskBits:mask hotX:hx hotY:hy width:w height:h

%{  /* UNLIMITEDSTACK (WIN95) */
    HCURSOR newCursor;

    if (__isByteArray(src)
     && __isByteArray(mask)
     && __bothSmallInteger(hx, hy)
     && __bothSmallInteger(w, h)) {

	newCursor = CreateCursor((HANDLE) __getHInstance(),
				 __intVal(hx), __intVal(hy),
				 __intVal(w), __intVal(h),
				 __ByteArrayInstPtr(mask)->ba_element,
				 __ByteArrayInstPtr(src)->ba_element);
	if (newCursor) {
	    RETURN ( __MKOBJ(newCursor));
	}
    }
    RETURN (nil);
%}
!

shapeNumberFromSymbol:shape
    "given a shape-symbol, return the corresponding cursor-number,
     or nil if no such standard cursor exists."

    "this is pure Win-knowlegde - but you may easily add more"

%{  /* NOCONTEXT */
    if (shape == @symbol(upLeftArrow)) {
	RETURN ( __MKSMALLINT( (INT)IDC_ARROW));
    }
    if (shape == @symbol(upDownArrow)) {
	RETURN ( __MKSMALLINT( (INT)IDC_SIZENS));
    }
    if (shape == @symbol(leftRightArrow)) {
	RETURN ( __MKSMALLINT( (INT)IDC_SIZEWE));
    }
    if (shape == @symbol(text)) {
	RETURN ( __MKSMALLINT( (INT)IDC_IBEAM));
    }
    if (shape == @symbol(wait)) {
	RETURN ( __MKSMALLINT( (INT)IDC_WAIT));
    }
    if (shape == @symbol(crossHair)) {
	RETURN ( __MKSMALLINT( (INT)IDC_CROSS));
    }
    if (shape == @symbol(fourWay)) {
	RETURN ( __MKSMALLINT( (INT)IDC_SIZEALL));
    }
    if (shape == @symbol(execute)) {
	RETURN ( __MKSMALLINT( (INT)IDC_APPSTARTING));
    }
%}.
"/    ('WINWORKSTATION: invalid cursorShape:' , shape printString) infoPrintNL.
    ^  nil
! !

!WinWorkstation methodsFor:'drawing'!

copyFromId:sourceId x:srcX y:srcY gc:srcGCId to:destId x:dstX y:dstY gc:dstGCId
		width:w height:h
    "do a bit-blt; copy bits from the rectangle defined by
     srcX/srcY and w/h from the sourceId drawable to the rectangle
     below dstX/dstY in the destId drawable. Trigger an error if any
     argument is not integer."

%{  /* UNLIMITEDSTACK (WIN95 only) */

    struct gcData *gcData = 0;
    struct gcData *srcGcData = 0;
    HDC srcDC = (HDC)0;
    HDC dstDC = (HDC)0;

    if (__isExternalAddress(dstGCId)) {
	gcData = _GCDATA(dstGCId);
	dstDC = _HDCVal(dstGCId);
	DDPRINTF(("dstDC = %x\n", dstDC));
    }
    else
    {
	goto fail;
    }
    if (__isExternalAddress(srcGCId))
    {
	srcGcData = _GCDATA(srcGCId);
	srcDC = _HDCVal(srcGCId);
	DDPRINTF(("srcDC = %x\n", srcDC));
    }
    else
    {
	goto fail;
    }

    if (__bothSmallInteger(w, h)
     && __bothSmallInteger(srcX, srcY)
     && __bothSmallInteger(dstX, dstY))
    {
	int fun = BITBLT_COPY;
	if (srcGcData && gcData)
	{
	  fun = gcData->bitbltrop2;
#if 0
	  switch (fun)
	  {
	    case BITBLT_COPY:
	      printf("BITBLT_COPY\n");
	      break;
	    case BITBLT_COPYINVERTED:
	      printf("BITBLT_COPYINVERTED\n");
	      break;
	    case BITBLT_XOR:
	      printf("BITBLT_XOR\n");
	      break;
	    case BITBLT_AND:
	      printf("BITBLT_AND\n");
	      break;
	    case BITBLT_OR:
	      printf("BITBLT_OR\n");
	      break;
	  }
#endif
	  if ((srcDC == dstDC) && (fun == BITBLT_COPY))
	  {
	    RECT rec,uprec;
	    rec.left = __intVal(srcX);
	    rec.top = __intVal(srcY);
	    rec.right = rec.left + __intVal(w);
	    rec.bottom = rec.top + __intVal(h);
	    DDPRINTF(("dst and src is DC %x fun == BITBLT_COPY  --> scrolling %d %d\n",gcData->hWnd,__intVal(dstX) - __intVal(srcX),__intVal(dstY) - __intVal(srcY)));
	    ScrollDC(srcDC,__intVal(dstX) - __intVal(srcX),__intVal(dstY) - __intVal(srcY),&rec,0,0,&uprec);
	    if (srcGcData->hWnd)
	      InvalidateRect(srcGcData->hWnd,&uprec,FALSE/*TRUE*/);

	    RETURN ( self );

	  }
	  if (srcGcData->hWnd)
	  {
	      /*printf("src is HWND %x\n",srcGcData->hWnd);*/
	  }
	  fun = gcData->bitbltrop2;
	  SetTextColor(dstDC, gcData->bgColor);
	  SetBkColor(dstDC, gcData->fgColor);
	  if (BitBlt(dstDC,
		 __intVal(dstX), __intVal(dstY),
		 __intVal(w), __intVal(h),
		 srcDC,
		 __intVal(srcX), __intVal(srcY),
		 fun)
	       == 0
	      )
	  {
	     printf("ERROR in BitBlt\n");
	  }
	  SetTextColor(dstDC, gcData->fgColor);
	  SetBkColor(dstDC, gcData->bgColor);
	  RETURN ( self );
	}
    }

 fail: ;
%}.
 ^ nil
"/

"/copyFromId:sourceId x:srcX y:srcY gc:srcGCId to:destId x:dstX y:dstY gc:dstGCId
"/              width:w height:h

"/    ^ self
"/        primCopyFromId:sourceId
"/                     x:srcX y:srcY gc:srcDCId
"/                    to:destId x:dstX y:dstY gc:dstDCId
"/               width:w height:h
"/    r notNil ifTrue:[^ self].
"/   ('WINWORKSTATION: invalid srcGCId' ) errorPrintNL.
"/   self primitiveFailed
!

copyPlaneFromId:sourceId x:srcX y:srcY gc:srcDCId to:destId x:dstX y:dstY gc:dstDCId
		width:w height:h
    "do a bit-blt, but only copy the low-bit plane;
     copy bits from the rectangle defined by
     srcX/srcY and w/h from the sourceId drawable to the rectangle
     below dstX/dstY in the destId drawable. Trigger an error if any
     argument is not integer."

    ^ self
	copyFromId:sourceId
		 x:srcX y:srcY gc:srcDCId
		to:destId x:dstX y:dstY gc:dstDCId
	     width:w height:h
!

displayArcX:x y:y width:width height:height from:startAngle angle:angle in:aDrawableId with:aGCId
    "draw an arc. If any of x,y, w or h is not an integer, an error is triggered.
     The angles may be floats or integer - they are given in degrees."

%{  /* UNLIMITEDSTACK (WIN95 only) */
    /* die todo */
    int __x, __y, w, h;
    float angle1, angle2;
    double f;

    if (__isSmallInteger(startAngle))
	angle1 = (float)(__intVal(startAngle));
    else if (__isFloat(startAngle)) {
	angle1 = __floatVal(startAngle);
    }
    if (__isSmallInteger(angle))
	angle2 = (float)(__intVal(angle));
    else if (__isFloat(angle)) {
	angle2 = __floatVal(angle);
    }
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC hDC;
	HBRUSH hBrush;
	HPEN hPen;
	POINT p;

	w = __intVal(width);
	h = __intVal(height);
	__x = __intVal(x);
	__y = __intVal(y);

	hDC = _HDCVal(aGCId);

	if (! GcDataGetPen(hDC,gcData)) {
	    DPRINTF(("displayArc: no pen\n"));
	} else {
	    int xB, yB, xE, yE;

	    if (angle2 - angle1 >= 360) {
		xB = xE = __x + w / 2;
		yB = yE = __y + h / 2;
	    } else {
		double sin(), cos();

		/* sigh - compute the intersections ... */
		xB = (int)sin((angle1-90) / 180 * 3.14159);
		yB = (int)cos((angle1-90) / 180 * 3.14159);
		xE = (int)sin((angle2-90) / 180 * 3.14159);
		yE = (int)cos((angle2-90) / 180 * 3.14159);
		xB += __x + w / 2;
		yB += __y + w / 2;
		xE += __x + w / 2;
		yE += __y + w / 2;
		DPRINTF(("partial displayArc not yet implemented\n"));
	    }
	    Arc(hDC,
		__x, __y,
		__x + w, __y + h,
		xB, yB,
		xE, yE);
	}
	RETURN ( self );
    }
%}
!

displayLineFromX:x0 y:y0 toX:x1 y:y1 in:aDrawableId with:aGCId
    "draw a line. If the coordinates are not integers, an error is triggered."

%{  /* UNLIMITEDSTACK (WIN95 only) */
    if (__isExternalAddress(aGCId)
     /*&& __isExternalAddress(aDrawableId)*/
     && __bothSmallInteger(x0, y0)
     && __bothSmallInteger(x1, y1)) {
	struct gcData *gcData = _GCDATA(aGCId);
	int __x1 = __intVal(x1), __y1 = __intVal(y1);


/*      DPRINTF(("displayLine: %d/%d -> %d/%d in %x\n",
		    __intVal(x0), __intVal(y0),
		    __x1, __y1,_HWNDVal(aDrawableId)));
*/


	if (! GcDataGetPen(gcData->hDC,gcData)) {
	    DPRINTF(("displayLine: no pen\n"));
	} else {
	    MoveToEx(gcData->hDC, __intVal(x0), __intVal(y0), NULL);

	    LineTo(gcData->hDC, __x1, __y1);
	    /*
	     * end-point ...
	     */
	    LineTo(gcData->hDC, __x1+1, __y1);
	}

	RETURN ( self );
    }
%}
!

displayPointX:px y:py in:aDrawableId with:aGCId
    "draw a point. If x/y are not integers, an error is triggered."

%{  /* UNLIMITEDSTACK (WIN95 only) */
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(px, py)) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC hDC = gcData->hDC;
	POINT p;
	int __x = __intVal(px), __y = __intVal(py);

	if (! GcDataGetPen(hDC,gcData)) {
	    DPRINTF(("displayPoint: no pen\n"));
	} else {
	    MoveToEx(hDC, __x, __y, NULL);
	    /*
	     * end-point ...
	     */
	    LineTo(hDC, __x+1, __y);
	}

	RETURN ( self );
    }
%}
!

displayPolygon:aPolygon in:aDrawableId with:aGCId
    "draw a polygon, the argument aPolygon is a Collection of individual points,
     which define the polygon.
     If any coordinate is not integer, an error is triggered."

    |numberOfPoints newPoints|

    numberOfPoints := aPolygon size.
    self
	primDisplayPolygon:aPolygon n:numberOfPoints
	in:aDrawableId with:aGCId
!

displayRectangleX:x y:y width:width height:height in:aDrawableId with:aGCId
    "draw a rectangle. If the coordinates are not integers, an error is triggered."

%{  /* UNLIMITEDSTACK (WIN95 only) */
    int w, h;
    int xL, yT;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC hDC = gcData->hDC;

	xL = __intVal(x);
	yT = __intVal(y);
	w = __intVal(width);
	h = __intVal(height);

	DPRINTF(("displayRectangle: %d/%d -> %d/%d\n",
			xL, yT, w, h));
	/*
	 * need this check here: some servers simply dump core with bad args
	 */
	if ((w >= 0) && (h >= 0)) {
	    if (! GcDataGetPen(hDC,gcData)) {
		DPRINTF(("displayRect: no pen\n"));
	    } else {
		MoveToEx(hDC, xL, yT, NULL);
		LineTo(hDC, xL+w-1, yT);
		LineTo(hDC, xL+w-1, yT+h-1);
		LineTo(hDC, xL, yT+h-1);
		LineTo(hDC, xL, yT);
	    }
	}
	RETURN ( self );
    }
%}
!

displayString:aString from:index1 to:index2 x:x y:y in:aDrawableId with:aGCId opaque:opaque
    "draw a sub-string - if opaque is false, draw foreground only; otherwise, draw both
     foreground and background characters.
     If the coordinates are not integers, an error is triggered."

%{  /* UNLIMITEDSTACK (WIN95 only) */
    unsigned char *cp;
    OBJ cls;
    int  i1, i2, l, n;
#   define NLOCALBUFFER 200
    short xlatebuffer[NLOCALBUFFER];
    int nInstBytes;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isNonNilObject(aString)
     && __bothSmallInteger(index1, index2)
     && __bothSmallInteger(x, y)) {
	struct gcData *gcData = _GCDATA(aGCId);
	int pX, pY;
	HDC hDC;

	hDC = gcData->hDC;

	pX = __intVal(x);
	pY = __intVal(y);
	pY -= gcData->fontAscent;

	cls = __qClass(aString);

	i1 = __intVal(index1) - 1;
	if (i1 >= 0) {
	    i2 = __intVal(index2) - 1;
	    if (i2 < i1) {
		RETURN (self);
	    }

	    cp = _stringVal(aString);
	    l = i2 - i1 + 1;

	    if ((cls == @global(String)) || (cls == @global(Symbol))) {
		n = _stringSize(aString);
		if (i2 < n) {
		    cp += i1;
		    if (l > 1000) l = 1000;
DDPRINTF(("string: %s pos=%d/%d\n", cp, pX, pY));
		    if (opaque == true) {
			SetBkMode(hDC, OPAQUE);
		    } else {
			SetBkMode(hDC, TRANSPARENT);
		    }
		    TextOut(hDC, pX, pY, (char *)cp, l);
		    RETURN ( self );
		}
	    }

	    nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
	    cp += nInstBytes;

	    if (__isBytes(aString)) {
		n = __byteArraySize(aString) - nInstBytes - 1;

		if (i2 < n) {
		    cp += i1;
		    if (l > 1000) l = 1000;
DDPRINTF(("string: %s pos=%d/%d\n", cp, pX, pY));
		    if (opaque == true) {
			SetBkMode(hDC, OPAQUE);
		    } else {
			SetBkMode(hDC, TRANSPARENT);
		    }
		    TextOut(hDC, pX, pY, (char *)cp, l);
		    RETURN ( self );
		}
	    }

#ifdef NOTDEF 
	    /* TWOBYTESTRINGS */
	    if (__isWords(aString)) {
		n = (__byteArraySize(aString) - nInstBytes) / 2;

		if (i2 < n) {
		    union {
			char b[2];
			unsigned short s;
		    } u;
		    int i;
		    XChar2b *cp2 = (XChar2b *)0;
		    int mustFree = 0;

		    cp += (i1 * 2);
		    if (l > 1000) l = 1000;

		    /*
		     * ST/X TwoByteStrings store the asciiValue in native byteOrder;
		     * X expects them MSB first
		     * convert as required
		     */

		    u.s = 0x1234;
		    if (u.b[0] != 0x12) {
			if (l <= NLOCALBUFFER) {
			    cp2 = xlatebuffer;
			} else {
			    cp2 = (XChar2b *)(malloc(l * 2));
			    mustFree = 1;
			}
			for (i=0; i<l; i++) {
			    cp2[i].byte1 = (((XChar2b *)cp)[i]).byte2;
			    cp2[i].byte2 = (((XChar2b *)cp)[i]).byte1;
			}
			cp = (char *) cp2;
		    }

		    if (opaque == true)
			XDrawImageString16(myDpy, win, gc, __intVal(x), __intVal(y), (XChar2b *)cp, l);
		    else
			XDrawString16(myDpy, win, gc, __intVal(x), __intVal(y), (XChar2b *)cp, l);

		    if (mustFree) {
			free(cp2);
		    }

		    RETURN ( self );
		}
	    }
#endif
	}
    }
#undef NLOCALBUFFER
%}
!

drawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth padding:padding
			  width:imageWidth height:imageHeight 
			      x:srcx y:srcy
			   into:aDrawableId 
			      x:dstx y:dsty 
			  width:w height:h 
			   with:aGCId

    "draw a bitImage which has depth id, width iw and height ih into
     the drawable. draw a region of w/h pixels from srcx/srcy to dstx/dsty.
     Individual source pixels have bitsPerPixel bits, allowing to draw
     depth and pixel-units to be different.
     It has to be checked elsewhere, that the server can do it with the given
     depth - otherwise, primitive failure will be signalled.
     Also it is assumed, that the colormap is setup correctly and the
     colors are allocated - otherwise the colors may be wrong."

    "
     sorry; I had to separate it into 2 methods, since XPutImage needs
     an unlimited stack, and thus cannot send primitiveFailed
    "
    (self primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth
		padding:padding
		width:imageWidth height:imageHeight 
		x:srcx y:srcy
		into:aDrawableId 
		x:dstx y:dsty 
		width:w height:h 
		with:aGCId)
    ifFalse:[
	"
	 also happens, if a segmentation violation occurs in the 
	 XPutImage ...
	"
	self primitiveFailed
    ].
!

fillArcX:x y:y width:width height:height from:startAngle angle:angle
	       in:aDrawableId with:aGCId
    "fill an arc. If any coordinate is not integer, an error is triggered.
     The angles may be floats or integer - they are given in degrees."

%{  /* UNLIMITEDSTACK (WIN95 only) */

    int w, h, angle1, angle2;
    double f;

    if (__isSmallInteger(startAngle))
	angle1 = __intVal(startAngle) * 64;
    else if (__isFloat(startAngle)) {
	f = __floatVal(startAngle);
	angle1 = (int)(f * 64);
    }
    if (__isSmallInteger(angle))
	angle2 = __intVal(angle) * 64;
    else if (__isFloat(angle)) {
	f = __floatVal(angle);
	angle2 = (int)(f * 64);
    }
    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	w = __intVal(width);
	h = __intVal(height);
	/*
	 * need this check here: some servers simply dump core with bad args
	 */
	if ((w >= 0) && (h >= 0) && (angle1 >= 0) && (angle2 >= 0)) {
    /* die todo */
	    DPRINTF(("fillArc not yet implemented\n"));
	}
	RETURN ( self );
    }
%}
!

fillPolygon:aPolygon in:aDrawableId with:aGCId
    "fill a polygon given by its points. 
     If any coordinate is not integer, an error is triggered."

    |numberOfPoints|

    numberOfPoints := aPolygon size.
    self
	primFillPolygon:aPolygon n:numberOfPoints 
	in:aDrawableId with:aGCId
!

fillRectangleX:x y:y width:width height:height in:aDrawableId with:aGCId
    "fill a rectangle. If any coordinate is not integer, an error is triggered."

%{  /* UNLIMITEDSTACK (WIN95 only) */

    int w, h;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	w = __intVal(width);
	h = __intVal(height);

	/*DPRINTF(("fillRect %d/%d -> %d/%d\n", __intVal(x), __intVal(y), w, h));*/

	/*
	 * need this check here: some servers simply dump core with bad args
	 */
	if ((w >= 0) && (h >= 0))
	{
	    struct gcData *gcData = _GCDATA(aGCId);
	    HDC hDC;
	    HBRUSH hBrush;
	    RECT rct;

	    hDC = _HDCVal(aGCId);
	    hBrush = GcDataGetBrush(hDC,gcData);
	    if (! hBrush)
	    {
		DPRINTF(("fillRectangle: no brush\n"));
	    }
	    else
	    {
	      if (! GcDataGetPen(hDC,gcData))
	      {
		  DPRINTF(("displayArc: no pen\n"));
	      }
	      else
	      {
		rct.left = __intVal(x);
		rct.top = __intVal(y);
		rct.right = rct.left + w; /* FillRect excludes right/bottom */
		rct.bottom = rct.top + h;

		/*FillRect(hDC, &rct, hBrush);*/
		Rectangle(hDC,rct.left,rct.top,rct.right,rct.bottom);
	      }
	    }
	}
	RETURN ( self );
    }
%}
!

primDisplayPolygon:aPolygon n:numberOfPoints in:aDrawableId with:aGCId

%{  /* UNLIMITEDSTACK (WIN95 only) */
    OBJ point, px, py;
    int i, num;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isSmallInteger(numberOfPoints)) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC hDC = gcData->hDC;
	POINT p;

	num = __intVal(numberOfPoints);

	for (i=0; i<num; i++) {
	    point = __AT_(aPolygon, __MKSMALLINT(i+1));
	    if (! __isPoint(point)) goto fail;
	    px = _point_X(point);
	    py = _point_Y(point);
	    if (! __bothSmallInteger(px, py))
		goto fail;
	}
	if (! GcDataGetPen(hDC,gcData)) {
	    DPRINTF(("displayPolygon: no pen\n"));
	} else {
	    for (i=0; i<num; i++) {
		point = __AT_(aPolygon, __MKSMALLINT(i+1));
		px = _point_X(point);
		py = _point_Y(point);
		if (i == 0) {
		    MoveToEx(hDC, __intVal(px), __intVal(py), NULL);
		} else {
		    p.x = __intVal(px);
		    p.y = __intVal(py);
		    if (i == (num-1)) {
			PolylineTo(hDC, &p, 1);
		    } else {
			LineTo(hDC, p.x, p.y);
			/*
			 * end-point ...
			 */
			LineTo(hDC, p.x+1, p.y);
		    }
		}
	    }
	}

	RETURN ( self );
    }
fail: ;
%}
!

primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth
	padding:padding
	width:imageWidth height:imageHeight
	x:srcx y:srcy
	into:aDrawableId
	x:dstx y:dsty
	width:w height:h
	with:aGCId

    "since XPutImage may allocate huge amount of stack space
     (some implementations use alloca), this must run with unlimited stack."

%{  /* UNLIMITEDSTACK */
    /* die todo */
    struct gcData *gcData = 0;
    HDC hDC = (HDC)0;

    if (ISCONNECTED
     && __isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(srcx, srcy)
     && __bothSmallInteger(dstx, dsty)
     && __bothSmallInteger(w, h)
     && __bothSmallInteger(imageWidth, imageHeight)
     && __bothSmallInteger(imageDepth, bitsPerPixel)
     && __isSmallInteger(padding)
     && __isByteArray(imageBits))
     {
	struct
	{
	  BITMAPINFOHEADER bmiHeader;
	  DWORD b;
	  DWORD g;
	  DWORD r;
	} bitmap;
	gcData = _GCDATA(aGCId);
	hDC = _HDCVal(aGCId);
	DDPRINTF(("hDC = %x\n", hDC));
	if (! gcData )
	    goto fail;
	bitmap.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bitmap.bmiHeader.biPlanes = 1;
	if (__intVal(imageDepth) == 24)
	  bitmap.bmiHeader.biCompression = BI_RGB;
	else if (__intVal(imageDepth) == 16)
	{
	  /*bitmap.bmiHeader.biCompression = BI_BITFIELDS;
	  bitmap.b = 0x001f;
	  bitmap.g = 0x03e0;
	  bitmap.r = 0x7c00;*/
	  bitmap.bmiHeader.biCompression = BI_RGB;
	}
	bitmap.bmiHeader.biSizeImage = 0;
	bitmap.bmiHeader.biXPelsPerMeter = 0;
	bitmap.bmiHeader.biYPelsPerMeter = 0;
	bitmap.bmiHeader.biClrUsed = 0;
	bitmap.bmiHeader.biClrImportant = 0;
	bitmap.bmiHeader.biWidth = __intVal(imageWidth);
	bitmap.bmiHeader.biHeight = -(__intVal(imageHeight));
	bitmap.bmiHeader.biBitCount = __intVal(bitsPerPixel);
	printf("drawBits depth:%d bitsPerPixel:%d IW%d W:%d H:%d\n",__intVal(imageDepth),bitmap.bmiHeader.biBitCount,bitmap.bmiHeader.biWidth,__intVal(w),bitmap.bmiHeader.biHeight);
	SetDIBitsToDevice(hDC,__intVal(dstx),__intVal(dsty),
			      __intVal(w), __intVal(h),
			      __intVal(srcx), __intVal(srcy),
			      0,__intVal(h),
			      (void *)__ByteArrayInstPtr(imageBits)->ba_element,
			      (BITMAPINFO*)&bitmap,DIB_RGB_COLORS);
	RETURN ( true );
    }

fail: ;
%}
.
    ^ false
!

primFillPolygon:aPolygon n:numberOfPoints in:aDrawableId with:aGCId

%{  /* UNLIMITEDSTACK (WIN95 only) */
    OBJ point, px, py;
    int i, num;

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aDrawableId)
     && __isSmallInteger(numberOfPoints)) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC hDC;
	POINT p;

	num = __intVal(numberOfPoints);
	if (num < 3) {
	    RETURN ( self );
	}
	for (i=0; i<num; i++) {
	    point = __AT_(aPolygon, __MKSMALLINT(i+1));
	    if (! __isPoint(point)) goto fail;
	    px = _point_X(point);
	    py = _point_Y(point);
	    if (! __bothSmallInteger(px, py))
		goto fail;
	}

	hDC = _HDCVal(aGCId);

	if (! GcDataGetBrush(hDC,gcData)) {
	    DPRINTF(("fillPolygon: no brush\n"));
	} else {
	    BeginPath(hDC);

	    for (i=0; i<num; i++) {
		point = __AT_(aPolygon, __MKSMALLINT(i+1));
		px = _point_X(point);
		py = _point_Y(point);
		if (i == 0) {
		    MoveToEx(hDC, __intVal(px), __intVal(py), NULL);
		} else {
		    if (i == (num-1)) {
			p.x = __intVal(px);
			p.y = __intVal(py);
			PolylineTo(hDC, &p, 1);
		    } else {
			LineTo(hDC, __intVal(px), __intVal(py));
		    }
		}
	    }

	    EndPath(hDC);
	    FillPath(hDC);
	}
	RETURN ( self );

fail: ;
    }
%}
! !

!WinWorkstation methodsFor:'event handling'!

configEventProcessedFor:aWindowId
%{
    if (__isExternalAddress(aWindowId))
    {
      HWND hWnd = _HWNDVal(aWindowId);

    }
%}
!

dispatchEventFor:aViewIdOrNil withMask:eventMask
    "central event handling method:
     get next event and send appropriate message to the sensor or view.
     If the argument aViewIdOrNil is nil, events for any view are processed,
     otherwise only events for the view with given id are processed.
     If the argument aMask is nonNil, only events for this eventMask are
     handled."
    |aEvent|
    "/self eventQueuedAlready ifFalse:[
    "/  self getEventFor:aViewIdOrNil withMask:eventMask
    "/].

    "/AbortSignal catch:[
	aEvent := self primDeqEvent.
	self dispatchLastEvent:aEvent.
	self primFreeEvent:aEvent.
    "/].
!

dispatchExposeEventFor:aViewIdOrNil
    "get next expose event and send appropriate message to the sensor or view.
     If the argument aViewIdOrNil is nil, events for any view are processed,
     otherwise only events for the view with given id are processed."

    self dispatchEventFor:aViewIdOrNil withMask:(self eventMaskFor:#expose)
!

dispatchLastEvent:aEvent
    |theView symS arg butt sibling windowID siblingID propertyID selectionID targetID requestorID
     eventType|

%{  /* STACK: 8000 */
    struct queuedEvent *ev = 0;
    struct inlineCache *ipS;

    static struct inlineCache vid = _ILC1;
    static struct inlineCache conf = _ILC5;
    static struct inlineCache skp = _ILC4;
    static struct inlineCache skr = _ILC4;
    static struct inlineCache exp = _ILC5;
    static struct inlineCache gexpS = _ILC6;
    static struct inlineCache nexpS = _ILC1;
    static struct inlineCache clr = _ILC5;
    static struct inlineCache bp = _ILC4;
    static struct inlineCache br = _ILC4;
    static struct inlineCache bmp = _ILC4;
    static struct inlineCache bsp = _ILC4;
    static struct inlineCache mot = _ILC4;
    static struct inlineCache unmap = _ILC1;
    static struct inlineCache map = _ILC1;
    static struct inlineCache termS = _ILC1;
    static struct inlineCache destr = _ILC1;
    static struct inlineCache setCurs = _ILC1;
    static struct inlineCache focOut = _ILC1;
    static struct inlineCache focIn = _ILC1;
    static struct inlineCache act = _ILC2;
    static struct inlineCache pe = _ILC4;
    static struct inlineCache pl = _ILC2;

    int x, y, w, h;
    int keyCode, modifiers, isDoubleClick = 0;
    int isDown = 1;
    int state;
    OBJ upDown;
    char nameBuffer[100];
    HWND hWnd = 0;
    DDPRINTF(("dispatchLast\n"));

    if (__isExternalAddress(aEvent))
    {
       ev = ((struct queuedEvent *)(__MKCP(aEvent)));
    }
    if (! ev) {
	DPRINTF(("no event in dispatchLastEvent\n"));
	RETURN (false);
    }
    hWnd = ev->ev_hWnd;
    if (!(hWnd /*&& IsWindow(hWnd)*/)) {
	DPRINTF(("wrong hWnd in event in dispatchLastEvent\n"));
	RETURN (false);
    }
    {
	OBJ t;

	/*
	 * very often, its another event for the same view ...
	 * avoid creation & lookup then.
	 */
	if ((t = __INST(lastId)) != nil) {
	    if (__isExternalAddress(t)) {
		if (_HWNDVal(t) == hWnd) {
		    theView = __INST(lastView);
		    if (__isNonNilObject(theView)) {
			if (__qClass(theView) == nil) {
			    theView = nil;
			}
		    }
		}
	    }
	}

	if (theView == nil) {
	    windowID = __MKOBJ(ev->ev_hWnd);
	    theView = (*vid.ilc_func)(self, @symbol(viewFromId:), nil, &vid, windowID);
	}
    }

    if (theView == nil) {
	DPRINTF(("nil view [hWnd=%x] in dispatchEvent\n", ev->ev_hWnd));

	RETURN (false);
    }

    switch (ev->ev_message) {
#if 1
	    case WM_WINDOWPOSCHANGED:
		{
		RECT rct;

		DPRINTF((">>> WM_WINDOWPOSCHANGED -> configureX:y:width:height:view:\n"));

		x = ev->ev_x;
		y = ev->ev_y;
		w = ev->ev_w;
		h = ev->ev_h;

		/*printf(">>> WM_WINDOWPOSCHANGED -> configureX:%d y:%d width:%d height: %d\n",x,y,w,h);*/

		(*conf.ilc_func)(self,
			     @symbol(configureX:y:width:height:view:),
			     nil, &conf,
			     __MKSMALLINT(x),
			     __MKSMALLINT(y),
			     __MKSMALLINT(w),
			     __MKSMALLINT(h),
			     theView);
		}
		break;
#endif
	    case WM_SHOWWINDOW:
		if (ev->ev_wParam == TRUE) {
		    DPRINTF((">>> WM_SHOWWINDOW -> mappedView:\n"));
		    (*map.ilc_func)(self,
				     @symbol(mappedView:),
				     nil, &map, theView);
		} else {
		    DPRINTF((">>> WM_SHOWWINDOW -> unMappedView:\n"));
		    (*unmap.ilc_func)(self,
				       @symbol(unmappedView:),
				       nil, &unmap, theView);
		}
		break;

	    case WM_CLOSE:
		    (*termS.ilc_func)(self,
				      @symbol(terminateView:), nil, &termS, theView);
		    break;
	    case WM_DESTROY:
		DPRINTF((">>> WM_DESTROY -> destroyedView\n"));
		(*destr.ilc_func)(self,
				   @symbol(destroyedView:),
				   nil, &destr, theView);
		break;

	    case WM_ACTIVATE:
		DPRINTF((">>> WM_ACTIVATE h=%x\n", ev->ev_hWnd));

		switch (LOWORD(ev->ev_wParam)) {
		    case WA_INACTIVE:
			(*act.ilc_func)(self,
					@symbol(activate:view:),
					nil,
					&act,
					false,
					theView);
/*
			(*focOut.ilc_func)(self,
					    @symbol(focusOutView:),
					    nil,
					    &focOut,
					    theView);
*/
			break;

		    case WA_ACTIVE:
		    case WA_CLICKACTIVE:
			(*act.ilc_func)(self,
					@symbol(activate:view:),
					nil,
					&act,
					true,
					theView);
/*
			(*focIn.ilc_func)(self,
					   @symbol(focusInView:),
					   nil,
					   &focIn,
					   theView);
*/
			break;
		    default:
			break;
		}
		break;

	    case WM_MOUSEACTIVATE:
		DPRINTF((">>> WM_MOUSEACTIVATE h=%x\n", ev->ev_hWnd));
/*
		(*act.ilc_func)(self,
				@symbol(activate:view:),
				nil,
				&act,
				true,
				theView);
*/

		(*focIn.ilc_func)(self,
				   @symbol(focusInView:),
				   nil,
				   &focIn,
				   theView);
		break;

	    case WM_SETFOCUS:
		DPRINTF((">>> WM_SETFOCUS h=%x\n", ev->ev_hWnd));
		(*focIn.ilc_func)(self,
				   @symbol(focusInView:),
				   nil,
				   &focIn,
				   theView);
		break;

	    case WM_KILLFOCUS:
		DPRINTF((">>> WM_KILLFOCUS h=%x\n", ev->ev_hWnd));
		(*focOut.ilc_func)(self,
				   @symbol(focusOutView:),
				   nil,
				   &focOut,
				   theView);
		break;

#ifdef WHY
	    case WM_SETCURSOR:
		DPRINTF((">>> WM_SETCURSOR h=%x\n", ev->ev_hWnd));

		(*setCurs.ilc_func)(self,
				   @symbol(setCursorInView:),
				   nil,
				   &setCurs,
				   theView);
		break;
#endif
	    case __WM_GEXPOSE:
		x = ev->ev_x;
		y = ev->ev_y;
		w = ev->ev_w;
		h = ev->ev_h;
		(*gexpS.ilc_func)(self,
			 @symbol(graphicsExposeX:y:width:height:final:view:), nil, &gexpS,
			 __MKSMALLINT(x),
			 __MKSMALLINT(y),
			 __MKSMALLINT(w),
			 __MKSMALLINT(h),
			 true,
			 theView);
		 /* fall into */
		 (*nexpS.ilc_func)(self,
			 @symbol(noExposeView:), nil, &nexpS,
			 theView);
	    break;
	    case WM_PAINT:
		x = ev->ev_x;
		y = ev->ev_y;
		w = ev->ev_w;
		h = ev->ev_h;
		/*printf("paint %x: %d %d %d %d\n",ev->ev_hWnd,x,y,w,h);*/
	    /*expose:*/
		DPRINTF((">>> WM_PAINT -> expose %d/%d -> %d/%d\n", x, y, w, h));
		(*exp.ilc_func)(self,
			 @symbol(exposeX:y:width:height:view:),
			 nil, &exp,
			 __MKSMALLINT(x),
			 __MKSMALLINT(y),
			 __MKSMALLINT(w),
			 __MKSMALLINT(h),
			 theView);
		break;

	    case WM_LBUTTONDBLCLK:
		isDoubleClick = 1;
		butt = __MKSMALLINT(1);
		goto commonButtonDown;

	    case WM_LBUTTONUP:
		isDown = 0;
		butt = __MKSMALLINT(1);
		goto commonButtonDown;

	    case WM_LBUTTONDOWN:
		butt = __MKSMALLINT(1);
		goto commonButtonDown;

	    case WM_MBUTTONDBLCLK:
		isDoubleClick = 1;
		butt = __MKSMALLINT(2);
		goto commonButtonDown;

	    case WM_MBUTTONUP:
		isDown = 0;
		butt = __MKSMALLINT(2);
		goto commonButtonDown;

	    case WM_MBUTTONDOWN:
		butt = __MKSMALLINT(2);
		goto commonButtonDown;

	    case WM_RBUTTONDBLCLK:
		isDoubleClick = 1;
		butt = __MKSMALLINT(3);
		goto commonButtonDown;

	    case WM_RBUTTONUP:
		isDown = 0;
		butt = __MKSMALLINT(3);
		goto commonButtonDown;

	    case WM_RBUTTONDOWN:
		butt = __MKSMALLINT(3);
		goto commonButtonDown;

	    commonButtonDown:
		x = ev->ev_x;
		y = ev->ev_y;
		modifiers = ev->ev_modifiers;

		if (isDown) {
		    buttonWindow = ev->ev_hWnd;
		} else {
		    buttonWindow = (HWND)0;
		}

		if (__INST(buttonTranslation) != nil) {
		    butt = __AT_(__INST(buttonTranslation), butt);
		}
		arg = butt;

		__INST(altDown) = (modifiers & AltMask) ? true : false;
		__INST(metaDown) = (modifiers & MetaMask) ? true : false;
		__INST(shiftDown) = (modifiers & ShiftMask) ? true : false;
		__INST(ctrlDown) = (modifiers & ControlMask) ? true : false;

		if (isDoubleClick) {
		    ipS = &bmp;
		    symS = @symbol(buttonMultiPress:x:y:view:);
		} else {
		    if (isDown) {
#ifdef NO_LONGERT
			if (modifiers & ShiftMask) {
			    ipS = &bsp;
			    symS = @symbol(buttonShiftPress:x:y:view:);
			} else 
#endif
			{
			    ipS = &bp;
			    symS = @symbol(buttonPress:x:y:view:);
			}
		    } else {
			ipS = &br;
			symS = @symbol(buttonRelease:x:y:view:);
		    }
		}

		if (__isSymbol(arg)) {
		    DPRINTF(("buttonPress/buttonRelease: %s %d/%d\n", 
				__stringVal(arg), x, y));
		} else {
		    DPRINTF(("buttonPress/buttonRelease: %d %d/%d\n", 
				__intVal(arg), x, y));
		}

		(*(*ipS).ilc_func)(self, symS, nil, ipS,
				   arg,
				   __MKSMALLINT(x),
				   __MKSMALLINT(y),
				   theView);
		break;

	    case __WM_MOUSEENTER:
		x = ev->ev_x;
		y = ev->ev_y;
		state = ev->ev_modifiers;
/*
		state = 0;
		if (ev->ev_wParam & MK_CONTROL)
		    state |= ControlMask;
		if (ev->ev_wParam & MK_LBUTTON)
		    state |= Button1Mask;
		if (ev->ev_wParam & MK_MBUTTON)
		    state |= Button2Mask;
		if (ev->ev_wParam & MK_RBUTTON)
		    state |= Button3Mask;
		if (ev->ev_wParam & MK_SHIFT)
		    state |= ShiftMask;
*/
		DPRINTF((">>> WM_MOUSEENTER: %d/%d %x\n", x, y, state));
		(*pe.ilc_func)(self, @symbol(pointerEnter:x:y:view:),
				    nil, &pe,
				    __MKSMALLINT(state),
				    __MKSMALLINT(x),
				    __MKSMALLINT(y),
				    theView);
		break;

	    case __WM_MOUSELEAVE:
		state = ev->ev_modifiers;
/*
		state = 0;
		if (ev->ev_wParam & MK_CONTROL)
		    state |= ControlMask;
		if (ev->ev_wParam & MK_LBUTTON)
		    state |= Button1Mask;
		if (ev->ev_wParam & MK_MBUTTON)
		    state |= Button2Mask;
		if (ev->ev_wParam & MK_RBUTTON)
		    state |= Button3Mask;
		if (ev->ev_wParam & MK_SHIFT)
		    state |= ShiftMask;
*/
		DPRINTF((">>> WM_MOUSELEAVE: %d/%d %x\n", x, y, state));
		(*pl.ilc_func)(self, @symbol(pointerLeave:view:),
				    nil, &pl,
				    __MKSMALLINT(state),
				    theView);
		break;

	    case WM_MOUSEMOVE:

		x = ev->ev_x;
		y = ev->ev_y;
		state = ev->ev_modifiers;
/*
		state = 0;
		if (ev->ev_wParam & MK_CONTROL)
		    state |= ControlMask;
		if (ev->ev_wParam & MK_LBUTTON)
		    state |= Button1Mask;
		if (ev->ev_wParam & MK_MBUTTON)
		    state |= Button2Mask;
		if (ev->ev_wParam & MK_RBUTTON)
		    state |= Button3Mask;
		if (ev->ev_wParam & MK_SHIFT)
		    state |= ShiftMask;
*/
		DPRINTF((">>> WM_MOUSEMOVE: %d/%d %x\n", x, y, state));

#ifdef NOTDEF
		if (buttonWindow) {
		    if (buttonWindow != ev->ev_hWnd) {
			/*
			 * translate for window, where button was pressed
			 * originally (X motion semantics)
			 */
			{
			    POINT p;

			    p.x = x;
			    p.y = y;
			    MapWindowPoints(ev->ev_hWnd, buttonWindow, &p, 1);
			    x = p.x;
			    y = p.y;
			    DPRINTF(("xlated to %d/%d for %x\n",
					x, y, buttonWindow));
			}
			windowID = __MKOBJ(buttonWindow);
			theView = (*vid.ilc_func)(self, @symbol(viewFromId:),
						  nil, &vid, windowID);
		    }
		}
#endif

		(*mot.ilc_func)(self, @symbol(buttonMotion:x:y:view:),
				    nil, &mot,
				    __MKSMALLINT(state),
				    __MKSMALLINT(x),
				    __MKSMALLINT(y),
				    theView);
		break;

	    case WM_CHAR:
		DPRINTF((">>> WM_CHAR: %d/%d\n", x, y));
		symS = @symbol(keyPress:x:y:view:);
		ipS = &skp;
		upDown = true;
		goto keyPressAndRelease;
	    case WM_SYSKEYUP:
	    case WM_KEYUP:
		DPRINTF((">>> WM_KEYUP / SYSKEYUP: %d/%d\n", x, y));
		symS = @symbol(keyRelease:x:y:view:);
		ipS = &skr;
		upDown = false;
		goto keyPressAndRelease;

	    case WM_SYSKEYDOWN:
	    case WM_KEYDOWN:
		DPRINTF((">>> WM_KEYDOWN / SYSKEYDOWN: %d/%d\n", x, y));
		symS = @symbol(keyPress:x:y:view:);
		ipS = &skp;
		upDown = true;
		/* FALL INTO */

	    keyPressAndRelease: ;

		x = ev->ev_x;
		y = ev->ev_y;

#ifdef NOTDEF
		{
		    BYTE vKeyState[256];
		    char buff[5];

		    GetKeyboardState(vKeyState);
		    ToAscii(ev->ev_keyCode, ev->ev_scanCode, vKeyState, &buff; 0);
		}
#endif

		keyCode = ev->ev_keyCode;
		modifiers = ev->ev_modifiers;

		if (modifiers & TRANSLATED_KEY) {
		    if (modifiers & ControlMask) {
			if (keyCode < 0x20) {
			    keyCode = keyCode + 'a' - 1;
			    if (modifiers & ShiftMask) {
				keyCode = keyCode - 'a' + 'A';
			    }
			}
		    } else if (modifiers & (MetaMask | AltMask)) {
			if (! (modifiers & ShiftMask)) {
			    if ((keyCode >= 'A') && (keyCode <= 'Z')) {
				keyCode = keyCode - 'A' + 'a';
			    }
			}
		    }
		    arg = __MKCHARACTER(keyCode & 0xFF);
		} else {
		    switch (keyCode) {
			case VK_PRIOR:
			    arg = @symbol(Prior);
			    break;

			case VK_NEXT:
			    arg = @symbol(Next);
			    break;

			case VK_END:
			    arg = @symbol(End);
			    break;

			case VK_HOME:
			    arg = @symbol(Home);
			    break;

			case VK_LEFT:
			    arg = @symbol(CursorLeft);
			    break;

			case VK_RIGHT:
			    arg = @symbol(CursorRight);
			    break;

			case VK_UP:
			    arg = @symbol(CursorUp);
			    break;

			case VK_DOWN:
			    arg = @symbol(CursorDown);
			    break;

			case VK_MENU:  /*alt taste bei w95 ???*/
			    arg = @symbol(Menu);
			    break;

			case VK_LMENU:
			    arg = @symbol(Menu_L);
			    break;

			case VK_RMENU:
			    arg = @symbol(Menu_R);
			    break;

			case VK_PAUSE:
			    arg = @symbol(Pause);
			    break;

			case VK_HELP:
			    arg = @symbol(Help);
			    break;

			case VK_EXECUTE:
			    arg = @symbol(Execute);
			    break;

			case VK_CANCEL:
			    arg = @symbol(Cancel);
			    break;

			case VK_SELECT:
			    arg = @symbol(Select);
			    break;

			case VK_PRINT:
			    arg = @symbol(Print);
			    break;

			case VK_SNAPSHOT:
			    arg = @symbol(Snapshot);
			    break;

			case VK_INSERT:
			    arg = @symbol(Insert);
			    break;

			case VK_DELETE:
			    arg = @symbol(Delete);
			    break;

			case VK_BACK:
			    arg = @symbol(BackSpace);
			    break;

			case VK_LWIN:
			    arg = @symbol(Win_L);
			    break;

			case VK_RWIN:
			    arg = @symbol(Win_R);
			    break;

			case VK_APPS:
			    arg = @symbol(Appl);
			    break;

			case VK_NUMPAD0:
			    arg = @symbol(KeyPad0);
			    break;

			case VK_NUMPAD1:
			    arg = @symbol(KeyPad1);
			    break;

			case VK_NUMPAD2:
			    arg = @symbol(KeyPad2);
			    break;

			case VK_NUMPAD3:
			    arg = @symbol(KeyPad3);
			    break;

			case VK_NUMPAD4:
			    arg = @symbol(KeyPad4);
			    break;

			case VK_NUMPAD5:
			    arg = @symbol(KeyPad5);
			    break;

			case VK_NUMPAD6:
			    arg = @symbol(KeyPad6);
			    break;

			case VK_NUMPAD7:
			    arg = @symbol(KeyPad7);
			    break;

			case VK_NUMPAD8:
			    arg = @symbol(KeyPad8);
			    break;

			case VK_NUMPAD9:
			    arg = @symbol(KeyPad9);
			    break;

			case VK_LSHIFT:
			    arg = @symbol(Shift_L);
			    break;

			case VK_RSHIFT:
			    arg = @symbol(Shift_R);
			    break;

			case VK_LCONTROL:
			    arg = @symbol(Ctrl_L);
			    break;

			case VK_RCONTROL:
			    arg = @symbol(Ctrl_R);
			    break;

			case VK_CONTROL:
			    arg = @symbol(Ctrl);
			    break;

			case VK_SHIFT:
			    arg = @symbol(Shift);
			    break;

			case VK_TAB:
			    arg = @symbol(Tab);
			    break;

			case VK_ESCAPE:
			    arg = @symbol(Escape);
			    break;

			case VK_NUMLOCK:
			    arg = @symbol(NumLock);
			    break;

			case VK_SCROLL:
			    arg = @symbol(ScrollLock);
			    break;

			case VK_RETURN:
			    arg = @symbol(Return);
			    break;

			default:
			    nameBuffer[0] = 0;
			    /*GetKeyNameText(ev->ev_scanCode, nameBuffer, sizeof(nameBuffer));*/
			    DPRINTF(("char is <%d>\n", keyCode));
			    arg = __MKCHARACTER(keyCode & 0xFF);
			    break;
		    }
		 }

		DPRINTF(("%s: code=%x mod=%x\n", __stringVal(symS),
				keyCode, modifiers));

		__INST(altDown) = (modifiers & AltMask) ? true : false;
		__INST(metaDown) = (modifiers & MetaMask) ? true : false;
		__INST(shiftDown) = (modifiers & ShiftMask) ? true : false;
		__INST(ctrlDown) = (modifiers & ControlMask) ? true : false;

		(*(*ipS).ilc_func)(self, symS, nil, ipS,
				   arg,
				   __MKSMALLINT(x),
				   __MKSMALLINT(y),
				   theView);

		break;

	    default:
		DPRINTF((">>> unhandled event: %x\n", ev->ev_message));
		break;
    }
%}.
    ^ true
!

disposeEventsWithMask:aMask for:aWindowIdOrNil
    "dispose (throw away) specific events. If aWindowId is nil,
     events matching the mask are thrown away regardless of which
     view they are for. Otherwise, only matching events for that 
     view are flushed."

%{  /* NOCONTEXT */
   /*printf("disposeEventsWithMask:for: not yet implemented.\n");*/
   RETURN ( self );
%}.
    self primitiveFailed
!

eventMaskFor:anEventSymbol
    "return the eventMask bit-constant corresponding to an event symbol"

%{  /* NOCONTEXT */

    int m = 0;

#ifdef NOTDEF
    if (anEventSymbol == @symbol(keyPress)) m = KeyPressMask;
    else if (anEventSymbol == @symbol(keyRelease)) m = KeyReleaseMask;
    else if (anEventSymbol == @symbol(buttonPress)) m = ButtonPressMask;
    else if (anEventSymbol == @symbol(buttonRelease)) m = ButtonReleaseMask;
    else if (anEventSymbol == @symbol(buttonMotion)) m = ButtonMotionMask;
    else if (anEventSymbol == @symbol(pointerMotion)) m = PointerMotionMask;
    else if (anEventSymbol == @symbol(expose)) m = ExposureMask;
    else if (anEventSymbol == @symbol(focusChange)) m = FocusChangeMask;
    else if (anEventSymbol == @symbol(enter)) m = EnterWindowMask;
    else if (anEventSymbol == @symbol(leave)) m = LeaveWindowMask;
    else if (anEventSymbol == @symbol(keymapState)) m = KeymapStateMask;
    else if (anEventSymbol == @symbol(visibilityChange)) m = VisibilityChangeMask;
    else if (anEventSymbol == @symbol(structureNotify)) m = StructureNotifyMask;
    else if (anEventSymbol == @symbol(resizeRedirect)) m = ResizeRedirectMask;
    else if (anEventSymbol == @symbol(propertyChange)) m = PropertyChangeMask;
    else if (anEventSymbol == @symbol(colormapChange)) m = ColormapChangeMask;
#endif
    RETURN (__MKSMALLINT(m));
%}
!

eventPending
    "return true, if any event is pending.
     This looks for both the internal queue and the display connection."

%{  /* UNLIMITEDSTACK (WIN95 only) */
    MSG msg;

    if (__INST(inRecursiveDispatch) == true) {
	RETURN (false);
    }

    if (isInputEvent()) {
	RETURN (true);
    }
#if 0
    if (GetQueueStatus(QS_ALLINPUT)
     && PeekMessage(&msg, (HWND)0, 0, 0, PM_NOREMOVE)) {
	RETURN (true);
    }
#endif
%}.
    ^ false
!

eventPending:anEventSymbol for:aWindowIdOrNil
    "return true, if a specific event is pending"

    ^ self eventsPending:(self eventMaskFor:anEventSymbol) for:aWindowIdOrNil withSync:false
!

eventPendingWithSync:doSync
    "return true, if any event is pending.
     The doSync argument is ignored here - in windows, all drawing is synchronous."
    doSync notNil ifTrue:[self flush].
    ^ self eventPending
!

eventQueued
    "return true, if any event is queued"

    ^ self eventQueuedAlready

    "Created: 12.12.1995 / 21:43:00 / stefan"
!

eventQueuedAlready
    "return true, if any event is queued internally.
     (i.e. in X's internal event queue, which is both filled by explicit
      nextEvent calls AND whenever drawing is done and events are pending on
      the display connection)."

%{  /* UNLIMITEDSTACK (WIN95 only) */

    DDPRINTF(("peek q - "));
    if (isInputEvent()) {
	DDPRINTF(("true\n"));
	RETURN (true);
    }
    DDPRINTF(("false\n"));
    RETURN ( false );
%}
!

eventsPending:anEventMask for:aWindowIdOrNil withSync:doSync
    "return true, if any of the masked events is pending.
     The doSync argument is ignored here - in windows, all drawing is synchronous."

%{  /* NOCONTEXT */

#ifdef DOES_NOT_WORK
    /* getWinEvents(1); */
    DPRINTF(("************* peek mask %x - not implemented\n", __intVal(anEventMask)));
#endif
%}.
    ^ false
!

exposeEventPendingFor:aWindowIdOrNil withSync:doSync
    "return true, if any expose event is pending for a specific view,
     or any view (if the arg is nil).
     This is an X specific interface - not used on windows (scrolling is synchronous)"
%{  /* UNLIMITEDSTACK (WIN95 only) */
    printf("exposeEventPendingFor ");
    if (__isExternalAddress(aWindowIdOrNil))
    {
	HWND hWnd = _HWNDVal(aWindowIdOrNil);
	localPaintInfo *pi = GetWindow_paintInfoPtr(hWnd);
	if (pi && pi->event)
	{
	  localWindowInfo *ip;
	  printf("= true\n");
	  ip = GETLOCALWINDOWINFOPTR(hWnd);
	  ip->flag |= LI_EXPOSE;
	  RETURN(true);
	}
    }
    printf("= false\n");
%}.
    ^ false
!

getEventFor:aViewIdOrNil withMask:eventMask
    "read next event - put into local eventBuffer. 
     If aViewIdOrNil is nil, events for any view are fetched;
     otherwise only events for that specific view will be fetched.
     Returns true, if there was an event, false otherwise."

%{  /* UNLIMITEDSTACK */
    DPRINTF(("... > getEvent\n"));
    if (isInputEvent()) {
	/* no need to copy into buffer (will be dequeued) */
	DPRINTF(("... < getEvent true\n"));
	RETURN (true);
    }
    DPRINTF(("... < getEvent false\n"));
%}.
    ^ false
!

handleAllEvents
    "from now on, handle any kind of event.
     Ignored on windows systems."

!

handleExposeOnlyFor:aView
    "from now on, handle expose events only.
     Ignored on windows systems."

!

mappingChanged:what event:eB
    "One of Keyboard-, Modifier- or PointerMap has change, probably by xmodmap.
     Tell xlib about the fact."

    (what == #mappingKeyboard or:[what == #mappingModifier]) ifTrue:[
	self refreshKeyboardMapping:eB.
	"Maybe some of our modifiers have been changed"
	self initializeModifierMappings.
    ].

    "Created: 1.12.1995 / 16:28:23 / stefan"
!

primDeqEvent
%{  /* UNLIMITEDSTACK (WIN95 only) */
    struct queuedEvent *ev;
    ev = deqEvent();
    if (! ev) {
	DPRINTF(("no event in dispatchLastEvent\n"));
	RETURN (nil);
    }
    DDPRINTF(("DeqEvent %x\n",ev));
    RETURN ( __MKOBJ(ev));
%}
!

primFreeEvent:aEvent
%{  /* UNLIMITEDSTACK (WIN95 only) */
    struct queuedEvent *ev;
    if (__isExternalAddress(aEvent))
    {
       ev = ((struct queuedEvent *)(__MKCP(aEvent)));
       if (ev)
       {
	DDPRINTF(("FreeEvent %x\n",ev));
	freeEvent(ev);
       }
    }
%}
!

setEventMask:aMask in:aWindowId
    "tell X that we are only interested in events from aMask, which
     is the bitwise or of the eventMask bits (see 'eventMaskFor:')"

    ^ self
! !

!WinWorkstation methodsFor:'event sending'!

pointerEnter:buttonState x:x y:y view:aView
    "since windows does not itself handle per-view
     cursors, must do it here, manually."

    |cursor id|

    (cursor := aView cursor) notNil ifTrue:[
	(id := cursor id) notNil ifTrue:[
	    self setCursor:id.
	]
    ].
    super pointerEnter:buttonState x:x y:y view:aView
!

sendKeyOrButtonEvent:typeSymbol x:xPos y:yPos keyOrButton:keySymCodeOrButtonNr state:stateMask toViewId:targetId
    "send a keyPress/Release or buttonPress/Release event to some (possibly alien) view.
     TypeSymbol must be one of: #keyPress, #keyRelease, #buttonPress , #buttonRelease.
     For buttonEvents, the keySymCodeOrButtonNr must be the buttons number (1, 2 ...);
     for key events, it can be either a symbol (as listen in X's keySyms)
     or a numeric keysym code. If state is nil, the modifier bits (shift & control)
     are computed from the keyboardMap - if non-nil, these are passed as modifierbits.
     The non-nil case is the lowlevel entry, where state must include any shift/ctrl information
     (not very user friendly)"

    ^ false
!

setCursorInView:aView
    |cursor id|

    (cursor := aView cursor) notNil ifTrue:[
	(id := cursor id) notNil ifTrue:[
	    self setCursor:id.
	]
    ].
!

simulateKeyboardInput:aCharacterOrString inViewId:viewId
    "send input to some other view, by simulating keyPress/keyRelease
     events. 
     Only a few control characters are supported.
     Notice: not all alien views allow this kind of synthetic input;
	     some simply ignore it."

    |control code state|

    aCharacterOrString isString ifTrue:[
	aCharacterOrString do:[:char |
	    self simulateKeyboardInput:char inViewId:viewId
	].
	^ self
    ].

    control := false.
    code := aCharacterOrString asciiValue.

    (aCharacterOrString == Character cr) ifTrue:[
	code := #Return
    ] ifFalse:[
	(aCharacterOrString == Character tab) ifTrue:[
	    code := #Tab 
	] ifFalse:[
	    (aCharacterOrString == Character esc) ifTrue:[
		code := #Escape 
	    ]
	]
    ].

    control ifTrue:[
	state := self controlMask
    ].


    "/ the stuff below should not be needed 
    "/ (sendKeyOrButtonevent should be able to figure out things itself)
    "/ however, on some linux systems it seems to not work correctly.
    "/ Hopefully, this is correct ...

    code isNumber ifTrue:[
	code >= $A asciiValue ifTrue:[
	    code <= $Z asciiValue ifTrue:[
		state := self shiftMask
	    ]
	]
    ].

    self sendKeyOrButtonEvent:#keyPress x:0 y:0 keyOrButton:code state:state toViewId:viewId.
    self sendKeyOrButtonEvent:#keyRelease x:0 y:0 keyOrButton:code state:state toViewId:viewId

    "
      sending input to some (possibly alien) view:

      |point id|

      point :=  Display pointFromUser.
      id := Display viewIdFromPoint:point.
      Display simulateKeyboardInput:'Hello_world' inViewId:id
    "

    "Modified: 11.6.1996 / 10:59:42 / cg"
! !

!WinWorkstation methodsFor:'font stuff'!

createFontFor:aFontName
    "a basic method for font allocation; this method allows
     any font to be aquired (even those not conforming to
     standard naming conventions, such as cursor, fixed or k14)"

%{  /* UNLIMITEDSTACK (WIN95 only) */
    HGDIOBJ hFont;
    char *fn;

    if (__isString(aFontName)) {
	fn = __stringVal(aFontName);
	if (strcmp(fn, "fixed") == 0) {
	    hFont = GetStockObject(ANSI_FIXED_FONT);
	} else if (strcmp(fn, "variable") == 0) {
	    hFont = GetStockObject(ANSI_VAR_FONT);
	} else {
	    hFont = (HGDIOBJ)0;
	    hFont = GetStockObject(ANSI_FIXED_FONT);
	}
	if (hFont) {
	    DPRINTF(("createFontFor:aFontName: %s -> %x\n", fn, hFont));
	    RETURN ( __MKOBJ(hFont) );
	}
    }
%}.
    ^ nil
!

fontMetricsOf:fontId into:aBlock
    "evaluate aBlock, passing a fonts metrics as arguments"

    |data|

    data := Array new:10.
    (self primFontMetricsOf:fontId intoArray:data) isNil ifTrue:[
	self primitiveFailed.
	^ self
    ].

    aBlock value:#iso8859
	   value:(data at:1)
	   value:(data at:2)
	   value:(data at:3)
	   value:(data at:4)
	   value:(data at:5)
	   value:(data at:6)
	   value:(data at:7)
!

fontsInFamily:aFamilyName face:aFaceName filtering:filter
    "return a set of all available fonts in aFamily/aFace on this display.
     On WinWorkStations there is curently Face
     But only thise matching filter (if nonNil)."

    |allFonts fonts|

    allFonts := self listOfAvailableFonts.
    allFonts isNil ifTrue:[^ nil].

    fonts := Set new.
    allFonts do:[:fntDescr |
	(aFamilyName sameAs:(fntDescr family)) ifTrue:[
	    (filter isNil or:[filter value:fntDescr]) ifTrue:[
		fonts add:fntDescr
	    ]
	]
    ].
    ^ fonts
!

fontsInFamily:aFamilyName face:aFaceName style:aStyleName filtering:filter
    "return a set of all available font in aFamily/aFace/aStyle
     on this display.
     On WinWorkStations there is curently no style or Face
     But only those matching filter (if nonNIl)."

    |allFonts fonts|

    allFonts := self listOfAvailableFonts.
    allFonts isNil ifTrue:[^ nil].

    fonts := Set new.
    allFonts do:[:fntDescr |
	(aFamilyName sameAs:(fntDescr family)) ifTrue:[
	    (filter isNil or:[filter value:fntDescr]) ifTrue:[
		fonts add:fntDescr
	    ]
	]
    ].
    ^ fonts
!

fullNameOf:aFontId
    "the fonts fullName - this is very device specific and should only be
     used for user feed-back (for example: in the fontPanel).
     If the display/font do not provide that info, return nil."
    ^ nil
!

getAvailableFontsMatching:pattern
    "return an Array filled with font names matching aPattern"
    self halt.
    ^ nil
!

getDefaultFont
    "return a default font id - used when class Font cannot
     find anything usable"

     ^ self createFontFor:'fixed'
!

getFontWithFamily:familyString face:faceString
	    style:styleArgString size:sizeArg encoding:encodingSym

    "try to get the specified font, if not available, try next smaller
     font. Access to X-fonts by name is possible, by passing the X font name
     as family and the other parameters as nil. For example, the cursor font
     can be aquired that way."

    |styleString theName theId xlatedStyle id spacing|

    styleString := styleArgString.

    "special: if face is nil, allow access to X-fonts"
    faceString isNil ifTrue:[
	sizeArg notNil ifTrue:[
	    theName := familyString , '-' , sizeArg printString
	] ifFalse:[
	    theName := familyString
	].
	theName isNil ifTrue:[
	    "
	     mhmh - fall back to the default font
	    "
	    theName := 'fixed'
	].
	theId := self createFontFor:theName.
	theId isNil ifTrue:[
	    theId := self getDefaultFont
	].
	^ theId
    ].

    "/ spacing other than 'normal' is contained as last component
    "/ in style
    styleString notNil ifTrue:[
	((styleString endsWith:'-narrow') 
	 or:[styleString endsWith:'-semicondensed']) ifTrue:[
	    |i|
	    i := styleString lastIndexOf:$-.
	    spacing := styleString copyFrom:(i+1).
	    styleString := styleString copyTo:(i-1).
	] ifFalse:[
	    spacing := 'normal'.
	].
    ].

    xlatedStyle := styleString.
    xlatedStyle notNil ifTrue:[
	xlatedStyle := xlatedStyle first asString
    ].

    id := self 
	    getFontWithFoundry:'*'
	    family:familyString asLowercase
	    weight:faceString
	    slant:xlatedStyle
	    spacing:spacing
	    pixelSize:nil
	    size:sizeArg 
	    registry:encodingSym
	    encoding:'*'.

    id isNil ifTrue:[
	(encodingSym notNil and:[encodingSym ~= '*']) ifTrue:[
	    "/ too stupid: encodings come in both cases
	    "/ and X does not ignore case
	    "/
	    id := self 
		    getFontWithFoundry:'*'
		    family:familyString asLowercase
		    weight:faceString
		    slant:xlatedStyle
		    spacing:spacing
		    pixelSize:nil
		    size:sizeArg 
		    registry:encodingSym asUppercase
		    encoding:'*'.
	    id isNil ifTrue:[
		id := self 
			getFontWithFoundry:'*'
			family:familyString asLowercase
			weight:faceString
			slant:xlatedStyle
			spacing:spacing
			pixelSize:nil
			size:sizeArg
			registry:encodingSym asLowercase
			encoding:'*'.
	    ]
	]
    ].
    ^ id

    "Modified: 24.2.1996 / 22:37:24 / cg"
    "Modified: 4.7.1996 / 11:38:47 / stefan"
!

getFontWithFoundry:foundry family:family weight:weight
	      slant:slant spacing:spc pixelSize:pSize size:size 
	      registry:registry encoding:encoding

    "get the specified font, if not available, return nil.
     This is the new font creation method - all others will be changed to
     use this entry.
     Individual attributes can be left empty (i.e. '') or nil to match any.

     foundry: 'adobe', 'misc', 'dec', 'schumacher' ... usually '*'
     family:  'helvetica' 'courier' 'times' ...
     weight:  'bold' 'medium' 'demi' ...
     slant:   'r(oman)' 'i(talic)' 'o(blique)'
     spacing: 'narrow' 'normal' semicondensed' ... usually '*'
     pixelSize: 16,18 ... usually left empty
     size:      size in point (1/72th of an inch)
     registry:  iso8859, sgi ... '*'
     encoding:  vendor specific encoding (usually '*')
    "
    " 
	Windows 95 allows the creation of a font with the following parameters

		nHeight
		nWidth
		nEscapement
		nOrientation
		fnWeight        FW_DONTCARE, FW_NORMAL, FW_MEDIUM, FW_BOLD, ...
		fdwItalic       TRUE or FALSE
		fdwUnderline    TRUE or FALSE
		fdwStrikeOut    TRUE or FALSE
		fdwCharSet      ANSI_CHARSET, UNICODE_, SYMBOL_, SHIFTJIS_,...
		fdwOutputPrecision      DEFAULT, STRING, CHAR, ...
		fdwClipPrecision        DEFAULT, CHAR, STROKE, MASK, ...
		fdwQuality      DEFAULT, DRAFT, or PROOF.
		fdwPitchAndFamily
			DEFAULT, FIXED or VARIABLE pitch
			DECORATIVE, DONTCASE, MODERN, ROMAN, SCRIPT, or SWISS.
		lpszFace
			Typeface Name

	These two above descriptions will be matched as follows:

		foundry - ignored
		family  - mapped to type face name.
		weight  - mapped to fnWeight
		slant   - NOT USED INITIALLY  user for style
		spacing - NOT USED INITIALLY
		pixelSize - NOT USED INITIALLY
		size      - mapped to nHeight
		registry  - NOT USED INITIALLY
		encoding  - NOT USED INITIALLY used for dwType device, raster or truetype
	"

%{  /* UNLIMITEDSTACK (WIN95 only) */
    HGDIOBJ hFont;
    int  nHeight, nWidth, nEscapement, nOrientation;
    char* work;
    char* work2;
    DWORD fnWeight;
    DWORD fdwItalic;
    DWORD fdwUnderline;
    DWORD fdwStrikeOut;
    DWORD fdwCharSet;
    DWORD fdwOutputPrecision;
    DWORD fdwClipPrecision;
    DWORD fdwQuality;
    DWORD fdwPitchAndFamily;
    LPCTSTR lpszFace;
    static char temp[33];

/* INITIALIZE */
    strcpy( temp, "                           " );
    lpszFace = &temp[0];
    strcpy( (char *)lpszFace, "NULL" );
    nHeight  = 0;
    nWidth   = 0;
    nEscapement = 0;
    nOrientation = 0;
    fnWeight = FW_NORMAL;
    fdwItalic = FALSE;
    fdwUnderline = FALSE;
    fdwStrikeOut = FALSE;
    fdwCharSet   = ANSI_CHARSET;
    fdwOutputPrecision = OUT_DEFAULT_PRECIS;
    fdwClipPrecision   = CLIP_DEFAULT_PRECIS;
    fdwQuality         = DEFAULT_QUALITY;
    fdwPitchAndFamily  = FF_DONTCARE;

/* SET VALUES */
    if ( __isString( family ) ) {
	work = __stringVal( family );
	if ( strcmp( work, "nil" ) != 0 ) {
	    strncpy( (char *)lpszFace, work, 32 );
	}
    }
    if( __isString( weight ) ) {
	work = __stringVal( weight );
	if( strcmp( work, "bold" ) == 0 ) {
	    fnWeight = FW_BOLD;
    } else {
	if( strcmp( work, "medium" ) == 0 ) {
	    fnWeight = FW_MEDIUM;
	    } else {
		if( strcmp( work, "demi" ) == 0 )
		    fnWeight = FW_LIGHT;
	    }
	}
    }
    if(__isSmallInteger( size ) )
    {
	nHeight = __intVal( size );
    }
    work2 = __stringVal( slant );
    work  = __stringVal( slant );
    if( strncmp( work2, "italic", 6 ) == 0 )
    {
	fdwItalic = TRUE;
	if( work2[6] = '-' )
	   strncpy( work, &work2[7], ( strlen( work2 ) - 7 ) );
    }
    if( strncmp( work, "underline", 9 ) == 0 )
    {
	fdwUnderline = TRUE;
	if( work[10] == '-' )
	   strncpy( work2, &work[11], ( strlen( work ) - 10 ) );
    }
    if( strncmp( work2, "strikeOut", 9 ) == 0 )
	fdwStrikeOut = TRUE;

    hFont = CreateFont( nHeight,
			nWidth,
			nEscapement,
			nOrientation,
			fnWeight,
			fdwItalic,
			fdwUnderline,
			fdwStrikeOut,
			fdwCharSet,
			fdwOutputPrecision,
			fdwClipPrecision,
			fdwQuality,
			fdwPitchAndFamily,
			lpszFace );

    if( hFont != NULL )
    {
	DPRINTF(("createFontWithFoundry: %x\n", hFont));
	RETURN ( __MKOBJ(hFont) );
    }
    DPRINTF(("***** ERROR createFontWithFoundry failed ERROR *****\n" ));
%}.
    ^ nil

    "
     Display getFontWithFoundry:'*'
			 family:'courier'
			 weight:'medium'
			  slant:'r'
			spacing:nil
		      pixelSize:nil
			   size:13
		       registry:'iso8859'
		       encoding:'*'
    "

    "new NT Version: 20.2.1997 / 22:33:29 / dq"
!

listOfAvailableFonts
    "return a list with all available fonts on this display.
     Since this takes a long time, keep the result of the query for the
     next time. The elements of the returned collection are instances of
     FontDescription."

    |list typeFaceList|

    listOfFonts notNil ifTrue:[^ listOfFonts].

    list := OrderedCollection new.
    typeFaceList := OrderedCollection new.

    [
      self primEnumFontTypesInto:typeFaceList.

      "/Transcript showCR:typeFaceList.

      typeFaceList do:[:typeFace |
	  self primEnumFontsIn:typeFace into:list.
	  0
      ].
    ] valueUninterruptably.

    "/Transcript showCR:list.
    listOfFonts := list
		       collect:[:anArray |
			| fntDescr family face style size encoding |
			family := anArray at:14.
			face   := anArray at:5.
			style  := anArray at:16.
			size   := anArray at:1.
			encoding := anArray at:15.

			fntDescr := FontDescription
					family:family
					face:face
					style:style
					size:size
					encoding:encoding.
			fntDescr
		       ].

    ^ listOfFonts

    "
     Display listOfAvailableFonts.

     Display getAvailableFontsMatching:'*'.
    "

    "Modified: 27.9.1995 / 10:54:47 / stefan"
    "Modified: 17.4.1996 / 15:27:57 / cg"
!

primEnumFontTypesInto:typeFaceList
%{      /* UNLIMITEDSTACK (WIN95) */
	HDC dc;

	dc = CreateCompatibleDC( __rootDC );
	if (dc) {
	    if ( EnumFonts( dc, NULL, EnumFPTypeFaceProc, (DWORD)&(typeFaceList))) {
		DPRINTF(("EnumFonts successful\n"));
	    }
	    DeleteDC(dc);
	}
%}
!

primEnumFontsIn:typeFace into:list
%{      /* UNLIMITEDSTACK (WIN95) */
	HDC dc;
	char *cp;

	if (__isString(typeFace)) {
	    dc = CreateCompatibleDC( __rootDC );
	    if (dc) {    
		if (EnumFonts(dc, __stringVal(typeFace), EnumFontsProc, (DWORD)&(list))) {
		    DPRINTF(("EnumFonts Successful\n"));
		}
		if (DeleteDC(dc)) {
		    DPRINTF(("Device Context sucessfully deleted"));
		}
	    }
	}
%}.
!

primFontMetricsOf:fontId intoArray:data
    "evaluate aBlock, passing a fonts metrics as arguments"

%{  /* UNLIMITEDSTACK (WIN95 only) */
    HGDIOBJ hFont;
    HGDIOBJ prevFont;
    TEXTMETRIC tmet;
    int len;

    if (ISCONNECTED) {
	if (__isExternalAddress(fontId)) {
	    hFont = _HGDIOBJVal(fontId);
	    /*
	     * temporarily set this font in the root context
	     */
	    prevFont = SelectObject(__rootDC, hFont);
	    GetTextMetrics(__rootDC, &tmet);
	    SelectObject(__rootDC, prevFont);

	    __ArrayInstPtr(data)->a_element[0] = __MKSMALLINT(tmet.tmAscent);
	    __ArrayInstPtr(data)->a_element[1] = __MKSMALLINT(tmet.tmDescent);
	    __ArrayInstPtr(data)->a_element[2] = __MKSMALLINT(tmet.tmAscent);
	    __ArrayInstPtr(data)->a_element[3] = __MKSMALLINT(tmet.tmDescent);
	    __ArrayInstPtr(data)->a_element[4] = __MKSMALLINT(tmet.tmAveCharWidth);
	    __ArrayInstPtr(data)->a_element[5] = __MKSMALLINT(tmet.tmMaxCharWidth);
	    __ArrayInstPtr(data)->a_element[6] = __MKSMALLINT(tmet.tmAveCharWidth);
	    DPRINTF(("textMetrics h=%x  avgAsc=%d avgDesc=%d minW=%d maxW=%d avgW=%d\n",
			hFont, tmet.tmAscent, tmet.tmDescent, tmet.tmAveCharWidth, tmet.tmMaxCharWidth,
			tmet.tmAveCharWidth));
	    RETURN (self);
	}
    }
    RETURN (nil);
%}
!

releaseFont:aFontId

%{  /* UNLIMITEDSTACK (WIN95 only) */
    if (__isExternalAddress(aFontId)) {
	HGDIOBJ hFont = _HGDIOBJVal(aFontId);
	if (hFont)
	{
	  DelObject(hFont);
	}
    }
%}
!

sizesInFamily:aFamilyName face:aFaceName style:aStyleName filtering:filter
    "return a set of all available font sizes in aFamily/aFace/aStyle
     on this display.
     Redefined to handle X's special case of 0-size (which stands for any)"

    |sizes|

    sizes := super sizesInFamily:aFamilyName face:aFaceName style:aStyleName filtering:filter.
    (sizes notNil and:[sizes includes:0]) ifTrue:[
	"special: in X11R5 and above, size 0 means:
	 there are scaled versions in all sizes available"

	^ #(4 5 6 7 8 9 10 11 12 14 16 18 20 22 24 28 32 48 64)
    ].
    ^ sizes

    "
     Display sizesInFamily:'courier' face:'bold' style:'roman'
    "

    "Created: 27.2.1996 / 01:38:15 / cg"
!

widthOf:aString from:index1 to:index2 inFont:aFontId

%{  /* UNLIMITEDSTACK (WIN95 only) */
    char *cp;
    int len, n, i1, i2, l;
    OBJ cls;
    int nInstBytes;

    if (ISCONNECTED) {
	if (__bothSmallInteger(index1, index2)
	 && __isExternalAddress(aFontId)
	 && __isNonNilObject(aString)) {
	    HGDIOBJ hFont,prevFont;
	    SIZE tsize;

	    hFont = _HGDIOBJVal(aFontId);

	    i1 = __intVal(index1) - 1;
	    cls = __qClass(aString);

	    if (i1 >= 0) {
		i2 = __intVal(index2) - 1;
		if (i2 < i1) {
		    RETURN ( __MKSMALLINT( 0 ) );
		}

		cp = (char *) _stringVal(aString);
		l = i2 - i1 + 1;

		if ((cls == @global(String)) || (cls == @global(Symbol))) {
		    n = _stringSize(aString);
		    if (i2 < n) {
			cp += i1;

			prevFont = SelectObject(__rootDC, hFont);
			GetTextExtentPoint(__rootDC, cp, l, &tsize);
			SelectObject(__rootDC, prevFont);
			/*printf("font %x x=%d\n",hFont,tsize.cx);*/
			RETURN ( __MKSMALLINT(tsize.cx) );
		    }
		}

		nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
		cp += nInstBytes;

		if (__isBytes(aString)) {
		    n = __byteArraySize(aString) - nInstBytes;
		    if (i2 < n) {
			cp += i1;

			prevFont = SelectObject(__rootDC, hFont);
			GetTextExtentPoint(__rootDC, cp, l, &tsize);
			SelectObject(__rootDC, prevFont);
			/*printf("font %x x=%d\n",hFont,tsize.cx);*/
			RETURN ( __MKSMALLINT(tsize.cx) );
		    }
		}
	    }
	}
    }
#undef NLOCALBUFFER
%}.
"/  'no stringlen' printCR.
    ^ nil
! !

!WinWorkstation methodsFor:'grabbing '!

allowEvents:mode
!

grabKeyboardIn:aWindowId
    "grab the keyboard"

!

grabPointerIn:aWindowId withCursor:aCursorId pointerMode:pMode keyboardMode:kMode confineTo:confineId
    "grap the pointer - return true if ok"

%{  /* UNLIMITEDSTACK (WIN95 only) */
    if (__isExternalAddress(aWindowId)) {
	HWND hWnd = _HWNDVal(aWindowId);
	{
	  if (currentCapture != CAPTURE_NONE)
	  {
	    currentCapture = CAPTURE_NONE;
	    ReleaseCapture();
	  }
	  if (hWnd == __rootWin)
	  {
	     hWnd = __rootWinSpezial;
	     ShowWindow(hWnd,SW_SHOWNOACTIVATE);
	  }
	  /*printf("setCapture %x\n",hWnd);*/
	  currentCapture = CAPTURE_EXPLICIT;
	  SetCapture(hWnd);
	  if (__isExternalAddress(aCursorId))
	  {
	      SetCursor(_HCURSORVal(aCursorId));
	      RETURN ( self );
	  }
	}
    }
%}.
    ^ true
!

ungrabKeyboard
    "release the keyboard"

    activeKeyboardGrab := nil
!

ungrabPointer
    "release the pointer"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    if (currentCapture != CAPTURE_NONE)
    {
      /*printf("releaseCapture\n");*/
      currentCapture = CAPTURE_NONE;
      ReleaseCapture();
    }
%}.
    activePointerGrab := nil
! !

!WinWorkstation methodsFor:'graphic context stuff'!

noClipIn:aWindowId gc:aGCId
    "disable clipping rectangle"

%{  /* UNLIMITEDSTACK (WIN95 only) */


    if (__isExternalAddress(aWindowId)
     && __isExternalAddress(aGCId))
     {
	RECT rect;
	struct gcData *gcData = _GCDATA(aGCId);
/*        printf("disable clipping rectangle %x\n",_HWNDVal(aWindowId));*/
	SelectClipRgn(gcData->hDC,0);
#if 0
	if (gcData->clipByChild)
	{
	  if (gcData->hWnd)
	  {
	    ReleaseDC(gcData->hWnd,gcData->hDC);
	    gcData->hDC = GetDCEx(gcData->hWnd,0,DCX_CLIPCHILDREN);
	  }
	}
#endif
	RETURN (self);
    }
%}
!

setBackground:bgColorIndex in:aGCId
    "set background color to be drawn with"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF bgColor;

	hDC = _HDCVal(aGCId);
	bgColor = (COLORREF)st2RGB(__intVal(bgColorIndex));
	if (bgColor != gcData->bgColor) {
	    gcData->bgColor = bgColor;
	    SetBkColor(hDC, bgColor);
	}

	DPRINTF(("setBackground: %x\n", bgColor));
	RETURN (self);
    }
%}
!

setBitmapMask:aBitmapId in:aGCId
    "set or clear the drawing mask - a bitmap mask using current fg/bg"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    HDC hDC;

    if (__isExternalAddress(aGCId))
    {
	hDC = _HDCVal(aGCId);
	printf("masks not yet implemented\n");
	DPRINTF(("masks not yet implemented\n"));
	RETURN (self);
    }
%}
!

setClipByChildren:aBool in:aWindowId gc:aGCId
    "enable/disable drawing into child views"

%{  /* UNLIMITEDSTACK (WIN95 only) */


    if (ISCONNECTED && __isExternalAddress(aGCId))
    {
	struct gcData *gcData = _GCDATA(aGCId);
	if (gcData && gcData->hWnd)
	{
#if 1
	    if( aBool == true )
	    {
		/* set clip by child */
		if (gcData->hWnd)
		{
		  ReleaseDC(gcData->hWnd,gcData->hDC);
		  gcData->hDC = GetDCEx(gcData->hWnd,0,DCX_CLIPCHILDREN);
		  gcData->clipByChild = TRUE;
		  /*printf("%x",gcData->hDC);*/
		}

	    } else {
		if (gcData->hWnd)
		{
		  RECT rect;
		  /*printf("ExcludeClipRect %d %d %d %d\n", rect.left,rect.top,rect.right,rect.bottom);*/
		  /*GetClientRect(gcData->hWnd,&rect);
		  ExcludeClipRect(gcData->hDC, rect.left,rect.top,rect.right,rect.bottom);*/
		  ReleaseDC(gcData->hWnd,gcData->hDC);
		  gcData->hDC = GetDCEx(gcData->hWnd,0,DCX_PARENTCLIP);
		  /*SelectClipRgn(gcData->hDC,0);*/
		  gcData->clipByChild = FALSE;
		}
	    }
#else
	    LONG style, oldstyle;
	    style = GetWindowLong( gcData->hWnd, GWL_STYLE );
	    DPRINTF(("style retrieved %x\n", style ));
	    if (1/*style*/) {
		if( aBool == true ) {
		    /* set clip by child */

		    style = style | (WS_CLIPCHILDREN|WS_CLIPSIBLINGS);
		} else {
		    style = style & ~(WS_CLIPCHILDREN|WS_CLIPSIBLINGS);
		}

		if( ( oldstyle = SetWindowLong( gcData->hWnd, GWL_STYLE, style ) ) == 0 ) {
		    DPRINTF(("clipping by child failed - could not set value\n"));
		} else {
		    DPRINTF(("Style set %x OLD STYLE: %x\n", style, oldstyle ));
		}
		if (gcData->hWnd)
		{
		  ReleaseDC(gcData->hWnd,gcData->hDC);
		  gcData->hDC = GetDC(gcData->hWnd);
		  printf(" %x",gcData->hDC);
		}
	    } else {
		DPRINTF(("clipping by child failed - could not retrieve style\n"));
	    }
#endif
	} else {
	    DPRINTF(("clipping by child failed - invalid win\n" ));
	}
    }
%}.
    ^ self
!

setClipX:clipX y:clipY width:clipWidth height:clipHeight in:aDrawableId gc:aGCId
    "clip to a rectangle"

"
      p--w---
      |     |
      h     |  the clipping rectangle
      |     |
      -------
	  where p = ( clipX, clipY ), w = clipWidth, h = clipHeight
"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    /*RETURN (self);*/
    if (  __isExternalAddress(aGCId)
       && __bothSmallInteger(clipX, clipY)
       && __bothSmallInteger(clipWidth, clipHeight) ) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC   hDC;
	HRGN  region;
	int   x, y;
#if 0
	if (gcData->clipByChild)
	{
	  if (gcData->hWnd)
	  {
	    ReleaseDC(gcData->hWnd,gcData->hDC);
	    gcData->hDC = GetDCEx(gcData->hWnd,0,DCX_CLIPCHILDREN);
	  }
	}
	else
#endif
	  hDC = _HDCVal(aGCId);

	x = __intVal(clipX);
	y = __intVal(clipY);
	/*printf("setClipX %x %d %d %d %d\n",_HWNDVal(aDrawableId),x,y,__intVal(clipWidth),__intVal(clipHeight));*/
	region = CreateRectRgn( x, y,
				( x + __intVal(clipWidth)),
				( y + __intVal(clipHeight)) );
	if( region == NULL ) {
	    DPRINTF((" clipping region creation failed!\n"));
	} else {
#if 1
	    if (SelectClipRgn(hDC, region) == ERROR )
	    {
		DPRINTF((" clipping region release unsuccessful\n" ));
	    }
#else
	    if (ExtSelectClipRgn(hDC, region,RGN_AND) == ERROR )
	    {
		DPRINTF((" clipping region release unsuccessful\n" ));
	    }
#endif
	    /*printf("%x c\n",hDC);*/
	    DelObject(region);
	}
	RETURN (self);
    }
%}
!

setDashes:dashList dashOffset:offset in:aGCId
    "set line attributes"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	DPRINTF(("dashes not yet implemented\n"));
	RETURN (self);
    }
%}
!

setFont:aFontId in:aGCId
    "set font to be drawn in"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    if (__isExternalAddress(aGCId)
     && __isExternalAddress(aFontId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	HDC hDC;
	HGDIOBJ hFont;
	TEXTMETRIC tmet;

	hDC = gcData->hDC;
	hFont = _HGDIOBJVal(aFontId);

	SelectObject(hDC, hFont);
	GetTextMetrics(hDC, &tmet);
	gcData->fontAscent = tmet.tmAscent;
	DPRINTF(("setFont: %x\n", hFont));
	RETURN ( self );
    }
%}
!

setForeground:fgColorIndex background:bgColorIndex in:aGCId
    "set foreground and background colors to be drawn with"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF fgColor, bgColor;

	hDC = gcData->hDC;

	fgColor = (COLORREF)st2RGB(__intVal(fgColorIndex));
	if (fgColor != gcData->fgColor) {
	    gcData->fgColor = fgColor;
	    if (gcData->selected.hBrush) {
		SelectObject(hDC,gcData->save.hBrush);
		DelObject(gcData->selected.hBrush);
		gcData->selected.hBrush = (HBRUSH)0;
	    }
	    if (gcData->selected.hPen) {
		SelectObject(hDC,gcData->save.hPen);
		DelObject(gcData->selected.hPen);
		gcData->selected.hPen = (HPEN)0;
	    }
	    SetTextColor(hDC, fgColor);
	}

	bgColor = (COLORREF)st2RGB(__intVal(bgColorIndex));
	if (bgColor != gcData->bgColor) {
	    gcData->bgColor = bgColor;
	    SetBkColor(hDC, bgColor);
	}

	DDPRINTF(("setForeground: %x background: %x\n", fgColor, bgColor));
	RETURN (self);
    }
%}
!

setForeground:fgColorIndex background:bgColorIndex mask:aBitmapId in:aGCId
    "set foreground and background colors to be drawn with using mask or
     solid (if aBitmapId is nil)"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF fgColor, bgColor;

	hDC = _HDCVal(aGCId);

	fgColor = (COLORREF)st2RGB(__intVal(fgColorIndex));
	if (fgColor != gcData->fgColor) {
	    gcData->fgColor = fgColor;
	    if (gcData->selected.hBrush) {
		SelectObject(hDC,gcData->save.hBrush);
		DelObject(gcData->selected.hBrush);
		gcData->selected.hBrush = (HBRUSH)0;
	    }
	    if (gcData->selected.hPen) {
		SelectObject(hDC,gcData->save.hPen);
		DelObject(gcData->selected.hPen);
		gcData->selected.hPen = (HPEN)0;
	    }
	    SetTextColor(hDC, fgColor);
	}
	bgColor = (COLORREF)st2RGB(__intVal(bgColorIndex));
	if (bgColor != gcData->bgColor) {
	    gcData->bgColor = bgColor;
	    SetBkColor(hDC, bgColor);
	}

	DDPRINTF(("setForeground: %x background: %x\n", fgColor, bgColor));
	RETURN (self);
    }
%}
!

setForeground:fgColorIndex background:bgColorIndex mask:aBitmapId lineWidth:lw in:aGCId
    "set foreground and background colors to be drawn with using mask or
     solid (if aBitmapId is nil); also set lineWidth"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF fgColor, bgColor;

	hDC = _HDCVal(aGCId);

	fgColor = (COLORREF)st2RGB(__intVal(fgColorIndex));
	if (fgColor != gcData->fgColor) {
	    gcData->fgColor = fgColor;
	    if (gcData->selected.hBrush) {
		SelectObject(hDC,gcData->save.hBrush);
		DelObject(gcData->selected.hBrush);
		gcData->selected.hBrush = (HBRUSH)0;
	    }
	    if (gcData->selected.hPen) {
		SelectObject(hDC,gcData->save.hPen);
		DelObject(gcData->selected.hPen);
		gcData->selected.hPen = (HPEN)0;
	    }
	    SetTextColor(hDC, fgColor);
	}
	bgColor = (COLORREF)st2RGB(__intVal(bgColorIndex));
	if (bgColor != gcData->bgColor) {
	    gcData->bgColor = bgColor;
	    SetBkColor(hDC, bgColor);
	}

	if (__intVal(lw) != gcData->lineWidth) {
	    if (gcData->selected.hPen) {
		SelectObject(hDC,gcData->save.hPen);
		DelObject(gcData->selected.hPen);
		gcData->selected.hPen = (HPEN)0;
	    }
	    gcData->lineWidth = __intVal(lw);
	}

	DDPRINTF(("setForeground: %x background: %x\n", fgColor, bgColor));
	RETURN (self);
    }
%}
!

setForeground:fgColorIndex in:aGCId
    "set foreground color to be drawn with"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	struct gcData *gcData = _GCDATA(aGCId);
	COLORREF fgColor;

	hDC = _HDCVal(aGCId);

	fgColor = (COLORREF)st2RGB(__intVal(fgColorIndex));
	if (fgColor != gcData->fgColor) {
	    gcData->fgColor = fgColor;
	    if (gcData->selected.hBrush) {
		SelectObject(hDC,gcData->save.hBrush);
		DelObject(gcData->selected.hBrush);
		gcData->selected.hBrush = (HBRUSH)0;
	    }
	    if (gcData->selected.hPen) {
		SelectObject(hDC,gcData->save.hPen);
		DelObject(gcData->selected.hPen);
		gcData->selected.hPen = (HPEN)0;
	    }
	    SetTextColor(hDC, fgColor);
	}

	DDPRINTF(("setForeground: %x\n", fgColor));
	RETURN (self);
    }
%}
!

setFunction:aFunctionSymbol in:aGCId
    "set alu function to be drawn with"

%{  /* UNLIMITEDSTACK (WIN95 only) */


    if (__isExternalAddress(aGCId)) {
	HDC hDC = _HDCVal(aGCId);
	struct gcData *gcData = _GCDATA(aGCId);
	int fun = -1;
	int bfun = -1;

	if (aFunctionSymbol == @symbol(copy))
	{
	  fun = R2_COPYPEN;
	  bfun = BITBLT_COPY;
	}
	else if (aFunctionSymbol == @symbol(copyInverted))
	{
	  fun = R2_NOTCOPYPEN;
	  bfun = BITBLT_COPYINVERTED;
	}
	else if (aFunctionSymbol == @symbol(xor))
	{
	  fun = R2_XORPEN;
	  bfun = BITBLT_XOR;
	}
	else if (aFunctionSymbol == @symbol(and))
	{
	  fun = R2_MASKPEN;
	  bfun = BITBLT_AND;
	}
	else if (aFunctionSymbol == @symbol(or))
	{
	  fun = R2_MERGEPEN;
	  bfun = BITBLT_OR;
	}
	if (fun != -1)
	{
#if 0
	    printf("set func to");
	    switch (bfun)
	    {
	      case BITBLT_COPY:
		printf("BITBLT_COPY\n");
		break;
	      case BITBLT_COPYINVERTED:
		printf("BITBLT_COPYINVERTED\n");
		break;
	      case BITBLT_XOR:
		printf("BITBLT_XOR\n");
		break;
	      case BITBLT_AND:
		printf("BITBLT_AND\n");
		break;
	      case BITBLT_OR:
		printf("BITBLT_OR\n");
		break;
	    }
#endif
	    gcData->rop2 = fun;
	    gcData->bitbltrop2 = bfun;
	    SetROP2(hDC, fun);
	}
	else
	{
	    printf("unsuported Rasterfunction\n");
	    gcData->rop2 = R2_COPYPEN;
	    SetROP2(hDC, R2_COPYPEN);
	    gcData->bitbltrop2 = BITBLT_COPY;
	}
	RETURN (self);
    }
    else
      printf("Rasterfunction no GC\n");
%}
!

setGraphicsExposures:aBoolean in:aGCId
    "set or clear the graphics exposures flag"

!

setLineWidth:aNumber style:lineStyle cap:capStyle join:joinStyle in:aGCId
    "set line attributes"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    HDC hDC;

    if (__isExternalAddress(aGCId)
     && __isSmallInteger(aNumber)) {
	struct gcData *gcData = _GCDATA(aGCId);
	hDC = _HDCVal(aGCId);

	if (gcData->selected.hPen) {
	    SelectObject(hDC,gcData->save.hPen);
	    DelObject(gcData->selected.hPen);
	    gcData->selected.hPen = (HBRUSH)0;
	}

	gcData->lineWidth = __intVal(aNumber);
	if (lineStyle == @symbol(solid)) {
	    gcData->lineStyle = PS_SOLID;
	} else if (lineStyle == @symbol(dashed)) {
	    gcData->lineStyle = PS_DASH;
	} else
	    gcData->lineStyle = PS_DASH;

	if (capStyle == @symbol(round)) {
	    gcData->capStyle = PS_ENDCAP_ROUND;
	} else if (capStyle == @symbol(square)) {
	    gcData->capStyle = PS_ENDCAP_SQUARE;
	} else if (capStyle == @symbol(flat)) {
	    gcData->capStyle = PS_ENDCAP_FLAT;
	} else
	    gcData->capStyle = PS_ENDCAP_FLAT;

	if (joinStyle == @symbol(bevel)) {
	    gcData->joinStyle = PS_JOIN_BEVEL;
	} else if (joinStyle == @symbol(miter)) {
	    gcData->joinStyle = PS_JOIN_MITER;
	} else if (joinStyle == @symbol(round)) {
	    gcData->joinStyle = PS_JOIN_ROUND;
	} else
	    gcData->joinStyle = PS_JOIN_MITER;

	RETURN (self);
    }
%}
!

setMaskOriginX:orgX y:orgY in:aGCId
    "set the mask origin"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	DPRINTF(("mask origin not yet implemented\n"));
	RETURN (self);
    }
%}
!

setPixmapMask:aPixmapId in:aGCId
    "set or clear the drawing mask - a pixmap mask providing full color"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    HDC hDC;

    if (__isExternalAddress(aGCId)) {
	hDC = _HDCVal(aGCId);
	printf("pixmask origin not yet implemented\n");
	DPRINTF(("pixmask origin not yet implemented\n"));
	RETURN (self);
    }
%}
! !

!WinWorkstation methodsFor:'initialize / release'!

close
    "close down the connection to the X-server"

!

initializeDefaultValues
    focusMode := #activeWindow.

    buttonTranslation := ButtonTranslation.
    multiClickTimeDelta := MultiClickTimeDelta.

    self initializeModifierMappings
!

initializeEventBuffer
!

initializeFor:aDisplayName
    "initialize the receiver for a connection to an X-Server;
     the argument, aDisplayName may be nil (for the default server from
     DISPLAY-variable or command line argument) or the name of the server 
     as hostname:number"

    displayId notNil ifTrue:[
	"/ already connected - trying to trick me ?
	^ self
    ].

    displayId := self primInitializeFor:aDisplayName.
    displayId isNil ifTrue:[^ self].

    dispatching := false.
    isSlow := false.
    shiftDown := false.
    ctrlDown := false.
    metaDown := false.
    altDown := false.
    motionEventCompression := true.
    buttonsPressed := 0.

    self initializeScreenProperties.
    self initializeDeviceResourceTables.

    self initializeDefaultValues.
    self initializeEventBuffer.
    self initializeSpecialFlags.
    self initializeKeyboardMap.
!

initializeModifierMappings
    shiftModifiers := #(#'Shift_L' #'Shift_R' #'Shift').
    ctrlModifiers := #(#'Ctrl_L' #'Ctrl_R' #'Ctrl').
    metaModifiers := #(#'Alt_L' #'Alt').
    altModifiers := #(#'Alt_R').
!

initializeScreenProperties
    super initializeScreenProperties.

%{  /* UNLIMITEDSTACK (WIN95 only) */

    int scr;
    int maxRGBDepth;
    int rgbRedMask, rgbGreenMask, rgbBlueMask;
    int nvi, i, val, capabilities,__planes,__numcolors,__numpens,__ras;
    char *type, *nm;
    int dummy;
    int mask, shift, nBits;
    RECT rect;
    HDC _rootDC;
    OBJ id;
    if (firstInstance)
    {
	WNDCLASS wc;
	firstInstance = 0;
	DPRINTF(("first create - registerClass\n"));

	wc.style = /* CS_HREDRAW | CS_VREDRAW |*/ CS_OWNDC  | CS_DBLCLKS;
	wc.lpfnWndProc = (WNDPROC) MainWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = N_WINDOW_PRIVATE;
	wc.hInstance = (HANDLE) __getHInstance();
	wc.hIcon = NULL;
	wc.hCursor = 0;

	wc.hbrBackground = 0;

	wc.lpszMenuName =  NULL;
	wc.lpszClassName = app_name;

	if (!RegisterClass(&wc)) {
	    DPRINTF(("RegisterClass failed\n"));
/*            return NULL;     */
	}

	wc.style = 0;
	wc.lpfnWndProc = (WNDPROC) MainWndProcRoot;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = N_WINDOW_PRIVATE;
	wc.hInstance = (HANDLE) __getHInstance();
	wc.hIcon = NULL;
	wc.hCursor = 0;

	wc.hbrBackground = GetStockObject(HOLLOW_BRUSH);

	wc.lpszMenuName =  NULL;
	wc.lpszClassName = app_nameroot;

	if (!RegisterClass(&wc)) {
	    DPRINTF(("RegisterClass failed\n"));
/*            return NULL;     */
	}
	hCreateEvent = CreateEvent(
	    NULL,        /* no security attributes */
	    FALSE,
	    FALSE,
	    THREADEVENTNAME);  /* name of mutex */

	if (hCreateEvent == NULL)
	{
	    DPRINTF(("CreateEvent failed\n"));
/*            return NULL;     */
	}
	hInputEvent = CreateEvent(
	    NULL,        /* no security attributes */
	    FALSE,
	    FALSE,
	    THREADINPUTEVENTNAME);  /* name of mutex */

	if (hInputEvent == NULL)
	{
	    DPRINTF(("InputEvent failed\n"));
/*            return NULL;     */
	}
	hdispatchMutex = CreateMutex(
	    NULL,                       /* no security attributes */
	    FALSE,                      /* initially not owned */
	    THREADMUTEXNAME);  /* name of mutex */

	if (hdispatchMutex == NULL)
	{
	    DPRINTF(("CreateMutex failed\n"));
/*            return NULL;     */
	}
	DuplicateHandle(GetCurrentProcess(),hdispatchMutex,GetCurrentProcess(),&hdispatchMutex,DUPLICATE_SAME_ACCESS,FALSE,DUPLICATE_SAME_ACCESS);

	__setWaitInputEvent(waitInputEvent);
	bdispatchThreadState = TRUE;
	_masterThreadId = GetCurrentThreadId();

	DuplicateHandle(GetCurrentProcess(),GetCurrentThread(),GetCurrentProcess(),&_masterThread,DUPLICATE_SAME_ACCESS,FALSE,DUPLICATE_SAME_ACCESS);


#if 0
	_beginthread(dispatchThread, 0, 0);
#else
	if (!CreateThread (NULL,0,dispatchThread,NULL,0,&_dispatchThreadId))
	{
	    DPRINTF(("CreateThread failed\n"));
/*            return NULL;     */
	}
	else
#endif
	{
	  DWORD dwWaitResult;

	  /* Request ownership of mutex. */

	  dwWaitResult = WaitForSingleObject(
	    hCreateEvent,   /* handle of mutex */
	    5000L);   /* time-out interval */
	}
    }

    __rootWin = GetDesktopWindow();
    __PROTECT__(self);
    id = __MKOBJ(__rootWin);
    __UNPROTECT__(self);
    __INST(rootWin) = id; __STORE(self, id);

    _rootDC = GetDC(__rootWin); /*CreateDC("DISPLAY", NULL, NULL, NULL);*/
    __PROTECT__(self);
    id = __MKOBJ(_rootDC);
    __UNPROTECT__(self);
    __INST(rootDC) = id; __STORE(self, id);

    GetWindowRect(__rootWin, &rect);
    __INST(width) = __MKSMALLINT(rect.right-rect.left);
    __INST(height) = __MKSMALLINT(rect.bottom-rect.top);
    printf("screen is %d/%d\n", __intVal(__INST(width)), __intVal(__INST(height)));

    __planes = GetDeviceCaps(_rootDC, PLANES);
    __depth = GetDeviceCaps(_rootDC, BITSPIXEL);
    if (__depth == 15)
      __depth = 16;

    __numcolors = GetDeviceCaps(_rootDC, NUMCOLORS);
    __numpens = GetDeviceCaps(_rootDC, NUMPENS);
    printf("screen has %d planes\n",__planes);
    printf("screen is %d depth\n",__depth);
    printf("numcolors is %d\n",__numcolors);
    printf("numpens is %d\n",__numpens);

    __ras = GetDeviceCaps(_rootDC, RASTERCAPS);

    printf("device support:\n");
    if (__ras & RC_BANDING)
      printf(" RC_BANDING");

    if (__ras & RC_BITBLT)
      printf(" RC_BITBLT");

    if (__ras & RC_BITMAP64)
      printf(" RC_BITMAP64");

    if (__ras & RC_DI_BITMAP)
      printf(" RC_DI_BITMAP");

    if (__ras & RC_DIBTODEV)
      printf(" RC_DIBTODEV");

    if (__ras & RC_FLOODFILL)
      printf(" RC_FLOODFILL");

    if (__ras & RC_PALETTE)
      printf(" RC_PALETTE");

    if (__ras & RC_SCALING)
      printf(" RC_SCALING");

    if (__ras & RC_STRETCHBLT)
      printf(" RC_STRETCHBLT");

    if (__ras & RC_STRETCHDIB)
      printf(" RC_STRETCHDIB");
    printf("\n");
    __INST(depth) = __MKSMALLINT(__depth);
    __INST(ncells) = __MKSMALLINT(1<<__depth);

    printf("cursor size %d %d\n",GetSystemMetrics(SM_CXCURSOR),GetSystemMetrics(SM_CYCURSOR));

    val = GetDeviceCaps(_rootDC, HORZSIZE);
    printf("HORSIZE=%d\n",val);
    __INST(widthMM) = __MKSMALLINT(val);
    val = GetDeviceCaps(_rootDC, VERTSIZE);
    printf("VERTSIZE=%d\n",val);
    __INST(heightMM) = __MKSMALLINT(val);


    capabilities = GetDeviceCaps(_rootDC, RASTERCAPS);

    __INST(whitepixel) = __MKSMALLINT(WhitePixel);
    __INST(blackpixel) = __MKSMALLINT(BlackPixel);

    if (! (capabilities & RC_PALETTE)) {
	DPRINTF(("no palette\n"));
	if (__depth == 1) {
	    __INST(visualType) = @symbol(GrayScale);
	    __INST(hasColors) = false;
	    __INST(hasGreyscales) = false;
	    __INST(monitorType) = @symbol(monochrome);
	} else {
	    __INST(hasColors) = true;
	    __INST(hasGreyscales) = true;
	    if ((__depth == 16) || (__depth == 15))
	    {
	      __INST(visualType) = @symbol(DirectColor);
	      __INST(visualType) = @symbol(TrueColor);
	      __INST(redShift) = __MKSMALLINT(10);
	      __INST(greenShift) = __MKSMALLINT(5);
	      __INST(blueShift) = __MKSMALLINT(0);
	      __INST(bitsPerRGB) = __MKSMALLINT(5);
	      __INST(bitsRed) = __INST(bitsGreen) = __INST(bitsBlue) = __MKSMALLINT(5);
	      __INST(blueMask) = __MKSMALLINT(0x1f);
	      __INST(greenMask) = __MKSMALLINT(0x3e0);
	      __INST(redMask) = __MKSMALLINT(0x7c00);
	    }
	    else
	    {
	      __INST(visualType) = @symbol(TrueColor);
	      __INST(redShift) = __MKSMALLINT(0);
	      __INST(greenShift) = __MKSMALLINT(8);
	      __INST(blueShift) = __MKSMALLINT(16);
	      __INST(bitsPerRGB) = __MKSMALLINT(8);
	      __INST(bitsRed) = __INST(bitsGreen) = __INST(bitsBlue) = __MKSMALLINT(8);
	      __INST(redMask) = __MKSMALLINT(0xFF);
	      __INST(greenMask) = __MKSMALLINT(0xFF00);
	      __INST(blueMask) = __MKSMALLINT(0xFF0000);
	    }
	}
    } else {
	val = GetDeviceCaps(_rootDC, SIZEPALETTE); /* First two entries are black and white. */
	printf("SizeofPalette %d\n",val);
	__INST(ncells) = __MKSMALLINT(val);
	__INST(blackpixel) = __MKSMALLINT(0);
	__INST(whitepixel) = __MKSMALLINT(1);
	__INST(hasColors) = true;
	__INST(hasGreyscales) = true;
	__INST(usingSystemPalette) = true;
	{
	  __INST(redShift) = __MKSMALLINT(0);
	  __INST(greenShift) = __MKSMALLINT(2);
	  __INST(blueShift) = __MKSMALLINT(4);
	  __INST(bitsPerRGB) = __MKSMALLINT(16);
	  __INST(bitsRed) = __INST(bitsGreen) = __INST(bitsBlue) = __MKSMALLINT(2);
	  __INST(redMask) = __MKSMALLINT(0x3);
	  __INST(greenMask) = __MKSMALLINT(0xc);
	  __INST(blueMask) = __MKSMALLINT(0x30);
	}
    }

    __INST(monitorType) = @symbol(unknown);

%}.
!

initializeSpecialFlags
    "perform additional special server implementation flags"
!

primInitializeFor:aDisplayName
    "initialize the receiver for a connection to an X-Server;
     the argument, aDisplayName may be nil (for the default server from
     DISPLAY-variable or command line argument) or the name of the server
     as hostname:number"

%{  /* UNLIMITEDSTACK (WIN95 only) */
    RETURN ( __MKSMALLINT(1) );
%}.
!

reinitialize
    rootWin := rootDC := nil.
    super reinitialize.
! !

!WinWorkstation methodsFor:'keyboard mapping'!

altModifierMask
    "return the mask (in motionEvents) for the alt-key modifier.
     Notice: ST/X may use the left ALT key as CMD/Meta key,
     therefore return a variable here, which can be changed during startup."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(AltMask));
%}

    "Created: 23.3.1996 / 12:43:22 / cg"
    "Modified: 23.3.1996 / 12:44:56 / cg"
!

leftAltMask
    "return the mask bit for the left Alt modifier key.
     See comment in altModifierMask: / metaModifierMask: for what
     this could be used."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(LeftAltMask));
%}
!

metaModifierMask
    "return the mask (in motionEvents) for the meta-key modifier.
     Notice: ST/X may use the left ALT key as CMD/Meta key,
     therefore return a variable here, which can be changed during startup."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(MetaMask));
%}

    "Created: 23.3.1996 / 12:43:39 / cg"
    "Modified: 23.3.1996 / 12:45:09 / cg"
!

modifierMapping
    "Get the Modifier Mapping.
     We return an array of arrays of keycodes"

    ^ nil
!

rightAltMask
    "return the mask bit for the right Alt modifier key.
     See comment in altModifierMask: / metaModifierMask: for what
     this could be used."

%{  /* NOCONTEXT */
    RETURN (__MKSMALLINT(RightAltMask));
%}
!

stringFromKeycode:code
    "Get a KeySymbol (a smalltalk symbol) from the keycode."

    ^ ''

    "
	Display stringFromKeycode:28
    "
! !

!WinWorkstation methodsFor:'misc'!

beep
    "output an audible beep"

%{  /* UNLIMITEDSTACK (WIN95 only) */
    Beep(__intVal(@global(BeepFrequency)), 
	 __intVal(@global(BeepDuration)));
%}
!

flush
    "send all buffered drawing to the display.
     This may be required to make certain, that all previous operations
     are really sent to the display before continuing. For example,
     after a cursor-change with a followup long computation.
     (otherwise, the cursor change request may still be in the output buffer)
     See also #sync, which even waits until the request has been processed."

%{  /* UNLIMITEDSTACK (WIN95 only) */
     GdiFlush();
%}
!

refreshKeyboardMapping:eB
!

setInputFocusTo:aWindowId
    self setInputFocusTo:aWindowId revertTo:nil
!

setInputFocusTo:aWindowId revertTo:revertSymbol
    "set the focus to the view as defined by aWindowId.
     Passing nil set the focus to no window and lets the display discard all
     input until a new focus is set.
     RevertSymbol specifies what should happen if the view becomes invisible;
     passing one of #parent, #root or nil specifies that the focus should be
     given to the parent view, the root view or no view."

%{  /* UNLIMITEDSTACK (WIN95 only) */
    if (__isExternalAddress(aWindowId)) {
	HWND hWnd = _HWNDVal(aWindowId);

	if (hWnd)
	{
	    if (GetFocus() != hWnd)
	    {
	      DPRINTF(("SetFocus to %x\n",hWnd));
	      SetFocus(hWnd);
	    }
	}
	RETURN ( self );
    }
%}
! !

!WinWorkstation methodsFor:'pointer queries '!

anyButtonStateMask
    "return an integer for masking out any button from a
     buttonStates value."

    "/ should use ``Display buttonXMotionMask bitOr:....''

    |s |

%{
    s = __MKSMALLINT(Button1Mask|Button2Mask|Button3Mask);
%}.
    ^ s

    "Modified: 23.3.1996 / 12:41:33 / cg"
    "Created: 23.3.1996 / 12:46:35 / cg"
!

buttonStates
    "return an integer representing the state of the pointer buttons;
     a one-bit in positions 0.. represent a pressed button.
     See the button1Mask/button2Mask/button3Mask,
     shiftMask/controlMask and modifierMask methods for the meaning of the bits."

    |s |

%{
    s = __MKSMALLINT(__modifiers);
%}.
    ^ s

    "
     Display buttonStates
    "

    "is the control-key pressed ?

     Display buttonStates bitTest:(Display controlMask)
    "

    "is the alt/meta-key pressed ?

     Display buttonStates bitTest:(Display altModifierMask)
     Display buttonStates bitTest:(Display metaModifierMask)
    "
!

leftButtonStateMask
    "return an integer for masking out the left button from a
     buttonStates value"

    "/ should use ``Display button1MotionMask''

    |s |

%{
    s = __MKSMALLINT(Button1Mask);
%}.
    ^ s

    "Modified: 23.3.1996 / 12:41:33 / cg"
!

middleButtonStateMask
    "return an integer for masking out the middle button from a
     buttonStates value"

    "/ should use ``Display button2MotionMask''

    |s |

%{
    s = __MKSMALLINT(Button2Mask);
%}.
    ^ s

    "Modified: 23.3.1996 / 12:41:43 / cg"
!

pointerPosition
    "return the current pointer position in root-window coordinates"

%{  /* UNLIMITEDSTACK (WIN95 only) */
    POINT p;

    if (GetCursorPos(&p)) {
	RETURN (__MKPOINT_INT(p.x, p.y));
    }
    RETURN (__MKPOINT_INT(0, 0));
%}
!

rightButtonStateMask
    "return an integer for masking out the right button from a
     buttonStates value"

    "/ should use ``Display button3MotionMask''

    |s |

%{
    s = __MKSMALLINT(Button3Mask);
%}.
    ^ s

    "Modified: 23.3.1996 / 12:41:52 / cg"
!

rootPositionOfLastEvent
    "return the position in root-window coordinates
     of the last button, key or pointer event"

    |x y|

%{
    x = __MKSMALLINT(evRootX);
    y = __MKSMALLINT(evRootY);
%}.
    ^ x @ y
!

setPointerPosition:newPosition
    "change the pointer position in root-window coordinates."

%{  /* UNLIMITEDSTACK (WIN95 only) */
    if (__isPoint(newPosition)) {
	OBJ xpos, ypos;

	xpos = __point_X(newPosition);
	ypos = __point_Y(newPosition);
	SetCursorPos(__intVal(xpos), __intVal(ypos));
    }
%}
!

setPointerPosition:newPosition in:aWindowId
    "change the pointer position to a new position relative to the
     given windows origin (which may be the rootWindow).
     Be careful with this - its usually not very ergonimically
     to change the mousePointer position.
     This interface is provided for special applications (presentation
     playback) and should not be used in normal applications."

    self setCursorPosition:(self translatePoint:newPosition from:aWindowId to:rootView id).
! !

!WinWorkstation methodsFor:'retrieving pixels'!

getBitsFromId:aDrawableId x:srcx y:srcy width:w height:h into:imageBits
    "get bits from a drawable into the imageBits. The storage for the bits
     must be big enough for the data to fit. If ok, returns an array with some
     info and the bits in imageBits. The info contains the depth, bitOrder and
     number of bytes per scanline. The number of bytes per scanline is not known
     in advance, since the X-server is free to return whatever it thinks is a good padding."

    |rawInfo info|

    ((w <= 0) or:[h <= 0]) ifTrue:[
	self primitiveFailed.
	^ nil
    ].

    rawInfo := Array new:8.
		  "1 -> bit order"
		  "2 -> depth"
		  "3 -> bytes_per_line"
		  "4 -> byte_order"
		  "5 -> format"
		  "6 -> bitmap_unit"
		  "7 -> bitmap_pad"
		  "8 -> bits_per_pixel"

    "/ had to extract the getPixel call into a separate method, to specify
    "/ unlimitedStack (some implementations use alloca and require huge amounts
    "/ of temporary stack space

    (self primGetBitsFrom:aDrawableId x:srcx y:srcy width:w height:h into:imageBits infoInto:rawInfo) ifTrue:[
	info := IdentityDictionary new.
	info at:#bitOrder put:(rawInfo at:1).
	info at:#depth put:(rawInfo at:2).
	info at:#bytesPerLine put:(rawInfo at:3).
	info at:#byteOrder put:(rawInfo at:4).
	info at:#format put:(rawInfo at:5).
	info at:#bitmapUnit put:(rawInfo at:6).
	info at:#bitmapPad put:(rawInfo at:7).
	info at:#bitsPerPixel put:(rawInfo at:8).
	^ info
    ].
    "
     some error occured - either args are not smallintegers, imageBits is not a ByteArray
     or is too small to hold the bits
    "
    ^ self primitiveFailed
!

getBitsFromPixmapId:aDrawableId x:srcx y:srcy width:w height:h into:imageBits
    "get bits from a drawable into the imageBits. The storage for the bits
     must be big enough for the data to fit. If ok, returns an array with some
     info and the bits in imageBits. The info contains the depth, bitOrder and
     number of bytes per scanline. The number of bytes per scanline is not known
     in advance, since the X-server is free to return whatever it thinks is a good padding."

    |rawInfo info|

    ((w <= 0) or:[h <= 0]) ifTrue:[
	self primitiveFailed.
	^ nil
    ].

    rawInfo := Array new:8.
		  "1 -> bit order"
		  "2 -> depth"
		  "3 -> bytes_per_line"
		  "4 -> byte_order"
		  "5 -> format"
		  "6 -> bitmap_unit"
		  "7 -> bitmap_pad"
		  "8 -> bits_per_pixel"

    "/ had to extract the getPixel call into a separate method, to specify
    "/ unlimitedStack (some implementations use alloca and require huge amounts
    "/ of temporary stack space

    (self primGetBitsFromPixmap:aDrawableId x:srcx y:srcy width:w height:h into:imageBits infoInto:rawInfo) ifTrue:[
	info := IdentityDictionary new.
	info at:#bitOrder put:(rawInfo at:1).
	info at:#depth put:(rawInfo at:2).
	info at:#bytesPerLine put:(rawInfo at:3).
	info at:#byteOrder put:(rawInfo at:4).
	info at:#format put:(rawInfo at:5).
	info at:#bitmapUnit put:(rawInfo at:6).
	info at:#bitmapPad put:(rawInfo at:7).
	info at:#bitsPerPixel put:(rawInfo at:8).
	^ info
    ].
    "
     some error occured - either args are not smallintegers, imageBits is not a ByteArray
     or is too small to hold the bits
    "
    ^ self primitiveFailed
!

getPixelX:x y:y from:aDrawableId
    "return the pixel value at x/y; coordinates start at 0/0 for the upper left.
     Nil is returned for invalid coordinates or if any other problem arises."

    'getPixelX:y:from: not yet implemented' printCR.
    ^ nil
!

primGetBitsFrom:aDrawableId x:srcX y:srcY width:w height:h into:imageBits infoInto:info
    "since XGetImage may allocate huge amount of stack space
     (some implementations use alloca), this must run with unlimited stack."

    "'primGetBitsFrom:x:y:width:height:into:infoInto: not yet implemented' printCR.
    ^ false"
%{  /* UNLIMITEDSTACK */
    int            height, width;
    int            numBytes;
    HWND        hWnd;
    HBITMAP hBitmap = 0;
    HDC bDC = 0;
    struct
    {
      BITMAPINFOHEADER bmiHeader;
      /*RGBQUAD rgb[256];*/
    } bitmap;

    if (ISCONNECTED
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(srcX, srcY)
     && __bothSmallInteger(w, h)
     && __isArray(info)
     && __isByteArray(imageBits))
    {
	hWnd = _HWNDVal( aDrawableId );
	printf("primGetBits %x\n",hWnd);
	if( hWnd != 0 )
	{
	    HDC wDC = GetDC(hWnd);
	    bDC = CreateCompatibleDC(__rootDC);
	    printf("srcX %d srcY %d w %d h %d\n",__intVal(srcX),__intVal(srcY),__intVal(w),__intVal(h));
	    height =  __intVal(h);/* -  __intVal(srcY);*/
	    width  =  __intVal(w);/* -  __intVal(srcX);*/
	    printf("width %d height %d\n",width,height);
	    hBitmap = CreateCompatibleBitmap(__rootDC,width,height);
	    if (!hBitmap)
	      goto fail;

	    bitmap.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	    bitmap.bmiHeader.biPlanes = 1;
	    bitmap.bmiHeader.biCompression = BI_RGB;
	    bitmap.bmiHeader.biSizeImage = 0;
	    bitmap.bmiHeader.biXPelsPerMeter = 0;
	    bitmap.bmiHeader.biYPelsPerMeter = 0;
	    bitmap.bmiHeader.biClrUsed = 0;
	    bitmap.bmiHeader.biClrImportant = 0;

	    bitmap.bmiHeader.biWidth = width;
	    bitmap.bmiHeader.biHeight = -height;
	    bitmap.bmiHeader.biBitCount = 24;

	    SelectObject(bDC,hBitmap);
	    if (BitBlt(bDC,
		   0,0,
		   width,height,
		   wDC,
		   __intVal(srcX), __intVal(srcY),
		   SRCCOPY)
		 == 0
		)
	    {
	       printf("ERROR in GetBitsFrom: BitBlt\n");
	    }
	    ReleaseDC(hWnd,wDC);
	    if (GetDIBits(bDC,hBitmap,0,height,0,&bitmap,DIB_RGB_COLORS) == 0)
	    {
		printf("noinfo returned\n");
		goto fail;
	    }
	    printf("bitmap info:%d %d %d %d\n",bitmap.bmiHeader.biWidth,bitmap.bmiHeader.biHeight,bitmap.bmiHeader.biBitCount,bitmap.bmiHeader.biSizeImage);
	    numBytes = bitmap.bmiHeader.biSizeImage;
	    if( numBytes != 0 )
	    {
	      if (numBytes > __byteArraySize(imageBits)) {
		  /* imageBits too small */
		  printf("provided byteArray too small\n");
		  goto fail;
	      }
	      printf("numBytes %d\n",numBytes);

	      bitmap.bmiHeader.biHeight = -height;
	      if (GetDIBits(bDC,hBitmap,0,height,__ByteArrayInstPtr(imageBits)->ba_element,&bitmap,DIB_RGB_COLORS) == 0)
	      {
		  printf("zero bits returned\n");
		  goto fail;
	      }
	    }
	    else
	    {
		printf("unacceptable bitmap\n");
		goto fail;
	    }
	}
	else
	{
	    printf("unacceptable bitmap\n");
	    goto fail;
	}

	__ArrayInstPtr(info)->a_element[0] = @symbol(msbFirst);
	__ArrayInstPtr(info)->a_element[1] = __MKSMALLINT(1);
	__ArrayInstPtr(info)->a_element[2] = __MKSMALLINT((width * 3 + 1 )/ 2 * 2);
	__ArrayInstPtr(info)->a_element[3] = @symbol(msbFirst);
	__ArrayInstPtr(info)->a_element[4] = @symbol(XYPixmap);
	__ArrayInstPtr(info)->a_element[5] = __MKSMALLINT(0);
	__ArrayInstPtr(info)->a_element[6] = __MKSMALLINT(16);
	__ArrayInstPtr(info)->a_element[7] = __MKSMALLINT(bitmap.bmiHeader.biBitCount);
	RETURN ( true );
    }
fail:
    if (bDC)
      DeleteDC(bDC);
    if (hBitmap)
      DelObject(hBitmap);

%}.
    ^ false
!

primGetBitsFromPixmap:aDrawableId x:srcx y:srcy width:w height:h into:imageBits infoInto:info
    "since XGetImage may allocate huge amount of stack space
     (some implementations use alloca), this must run with unlimited stack."

%{  /* UNLIMITEDSTACK */
    int            height, width;
    int            numBytes;
    unsigned char* ep = 0;
    HBITMAP        xBitMap;

    if (ISCONNECTED
     && __isExternalAddress(aDrawableId)
     && __bothSmallInteger(srcx, srcy)
     && __bothSmallInteger(w, h)
     && __isArray(info)
     && __isByteArray(imageBits)) {

/* if BITMAP */

	xBitMap = _HBITMAPVAL( aDrawableId );
	if( xBitMap != 0 )
	{
	    height =  __intVal(h) -  __intVal(srcy);
	    width  = ( ( __intVal(w) -  __intVal(srcx) ) + 15 ) / 16; /* in Bytes */
	    numBytes = height * 2 * width;
	    if( numBytes != 0 )
	    {
		if( ep = (unsigned char *) malloc(numBytes) )
		{
		    if( numBytes = GetBitmapBits( xBitMap, numBytes, ep ) == 0 )
		    {
			printf("zero bits returned\n");
			goto fail;
		    }
		}
		else
		{
		    printf("malloc failed\n");
		    goto fail;
		}
	    }
	    else
	    {
		printf("unacceptable bitmap\n");
		goto fail;
	    }
	}
	else
	{
	    printf("unacceptable bitmap\n");
	    goto fail;
	}

	if (numBytes > __byteArraySize(imageBits)) {
	    /* imageBits too small */
	    printf("provided byteArray too small\n");
	    goto fail;
	}
	__ArrayInstPtr(info)->a_element[0] = @symbol(msbFirst);
	__ArrayInstPtr(info)->a_element[1] = __MKSMALLINT(1);
	__ArrayInstPtr(info)->a_element[2] = __MKSMALLINT(width);
	__ArrayInstPtr(info)->a_element[3] = @symbol(msbFirst);
	__ArrayInstPtr(info)->a_element[4] = @symbol(XYBitmap);
	__ArrayInstPtr(info)->a_element[5] = __MKSMALLINT(0);
	__ArrayInstPtr(info)->a_element[6] = __MKSMALLINT(16);
	__ArrayInstPtr(info)->a_element[7] = __MKSMALLINT(1);
	bcopy(ep, __ByteArrayInstPtr(imageBits)->ba_element, numBytes);
	free( ep );
	RETURN ( true );
    }
fail: 
    if (ep) {
	free( ep );
    }
%}.
    ^ false
! !

!WinWorkstation methodsFor:'style defaults'!

defaultStyleValueFor:aKey
    "return a default style value, given a key.
     These defaults are used if nothing is specified
     in the style sheet
     This allows for empty values in style sheets, and defaults
     being provided by the display (which makes sense with Windows,
     where the systemDefaults are used ..."

    <resource: #style (#viewSpacing
		       #borderColor #borderWidth
		       #viewBackground #shadowColor #lightColor
		      )>

    |clr|

"/    aKey == #shadowColor ifTrue:[
"/        ^ Color black
"/    ].
"/    aKey == #lightColor ifTrue:[
"/        ^ Color white
"/    ].

    aKey == #viewBackgroundColor ifTrue:[
	clr := self getSystemColor:#COLOR_WINDOW.
    ].
    aKey == #textForegroundColor ifTrue:[
	clr := self getSystemColor:#COLOR_WINDOWTEXT
    ].


"/    aKey == #scrollerViewBackgroundColor ifTrue:[
"/        ^ Color white
"/    ].

"/    aKey == #textForegroundColor ifTrue:[
"/        ^ Color black.
"/    ].
"/    aKey == #textBackgroundColor ifTrue:[
"/        ^ Color white.
"/    ].

    clr notNil ifTrue:[^ clr].
    ^ super defaultStyleValueFor:aKey
! !

!WinWorkstation methodsFor:'window stuff'!

clearRectangleX:x y:y width:width height:height in:aWindowId
    "clear a rectangular area to viewbackground"
%{
    DPRINTF(("clearRect\n"));
%}.
    super clearRectangleX:x y:y width:width height:height in:aWindowId
!

clearWindow:aWindowId
    "clear a window to viewbackground"

%{
    DPRINTF(("clearWin\n"));
%}.
    super clearWindow:aWindowId
!

configureWindow:aWindowId sibling:siblingId stackMode:modeSymbol
    "configure stacking operation of aWindowId w.r.t siblingId"

!

lowerWindow:aWindowId
    "bring a window to back"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    if (__isExternalAddress(aWindowId)) {
	HWND win = _HWNDVal(aWindowId);

	if (win)
	{
	    SetWindowPos(win, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
	}
	RETURN ( self );
    }
%}
!

mapView:aView id:aWindowId iconified:aBoolean atX:x y:y width:w height:h
    "make a window visible - either as icon or as a real view - needed for restart"

    "/ 'mapView:id:iconified:...height: not yet implemented' errorPrintCR.
%{  /* UNLIMITEDSTACK */
    RECT rec;
    if (__isExternalAddress(aWindowId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(w, h)) {
	HWND win = _HWNDVal(aWindowId);

	if (win)
	{
	    rec.left = __intVal(x);
	    rec.top = __intVal(y);
	    rec.right = rec.left + __intVal(w);
	    rec.bottom = rec.top + __intVal(h);
	    AdjustWindowRectEx(&rec,GetWindowLong(win,GWL_STYLE),0,GetWindowLong(win,GWL_EXSTYLE));
	    DPRINTF(("mapView %x x:%d y:%d w:%d h:%d -> x:%d y:%d w:%d h:%d\n",win,__intVal(x),__intVal(y),__intVal(w),__intVal(h),rec.left,rec.top,
			 rec.right - rec.left, rec.bottom - rec.top));
	    SetWindowPos(win, (HWND)0,
			 rec.left, rec.top,
			 rec.right - rec.left, rec.bottom - rec.top,
			 SWP_NOACTIVATE | SWP_NOZORDER);
		if (aBoolean == true)
		{
		  ShowWindow(win, SW_SHOWMINNOACTIVE);
		}
		else
		{
		  ShowWindow(win, SW_SHOWNORMAL);
		}
	}
	RETURN ( self );
    }
%}
!

mapWindow:aWindowId
    "make a window visible"

%{  /* UNLIMITEDSTACK */

    if (__isExternalAddress(aWindowId)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
	    ShowWindow(win, SW_SHOW);
/*
	    enqEvent(win, WM_SHOWWINDOW, TRUE, 0, 0, 0, 0);
*/
	}
	RETURN ( self );
    }
%}
!

moveResizeWindow:aWindowId x:x y:y width:w height:h
    "move and resize a window"

%{  /* UNLIMITEDSTACK (WIN95 only) */
    RECT rec;
    if (__isExternalAddress(aWindowId)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(w, h)) {
	HWND win = _HWNDVal(aWindowId);

	if (win)
	{
	    rec.left = __intVal(x);
	    rec.top = __intVal(y);
	    rec.right = rec.left + __intVal(w);
	    rec.bottom = rec.top + __intVal(h);
	    AdjustWindowRectEx(&rec,GetWindowLong(win,GWL_STYLE),0,GetWindowLong(win,GWL_EXSTYLE));
	    DPRINTF(("moveresize %x x:%d y:%d w:%d h:%d -> x:%d y:%d w:%d h:%d\n",win,__intVal(x),__intVal(y),__intVal(w),__intVal(h),rec.left,rec.top,
			 rec.right - rec.left, rec.bottom - rec.top));
	    SetWindowPos(win, (HWND)0,
			 rec.left, rec.top,
			 rec.right - rec.left, rec.bottom - rec.top,
			 SWP_NOACTIVATE | SWP_NOZORDER);
	}
	RETURN ( self );
    }
%}
!

moveWindow:aWindowId x:x y:y
    "move a window"

%{  /* UNLIMITEDSTACK (WIN95 only) */
    RECT rec;

    if (__isExternalAddress(aWindowId)
     && __bothSmallInteger(x, y)) {
	HWND win = _HWNDVal(aWindowId);

	if (win)
	{
	    rec.left = __intVal(x);
	    rec.top = __intVal(y);
	    rec.right = rec.left + 10;
	    rec.bottom = rec.top + 10;
	    AdjustWindowRectEx(&rec,GetWindowLong(win,GWL_STYLE),0,GetWindowLong(win,GWL_EXSTYLE));
	    DPRINTF(("move %x x:%d y:%d -> x:%d y:%d\n",win,__intVal(x),__intVal(y),rec.left,rec.top));
	    SetWindowPos(win, (HWND)0,
			 rec.left, rec.top,
			 0, 0,
			 SWP_NOACTIVATE | SWP_NOSIZE | SWP_NOZORDER);
	}
	RETURN ( self );
    }
%}
!

raiseWindow:aWindowId
    "bring a window to front"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    if (__isExternalAddress(aWindowId)) {
	HWND hWnd = _HWNDVal(aWindowId);

	if (hWnd) {
	    SetWindowPos(hWnd, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
	}
	RETURN ( self );
    }
%}
!

resizeWindow:aWindowId width:w height:h
    "resize a window"

%{  /* UNLIMITEDSTACK (WIN95 only) */
    RECT rec;
    if (__isExternalAddress(aWindowId)
     && __bothSmallInteger(w, h)) {
	HWND hWnd = _HWNDVal(aWindowId);

	if (hWnd)
	{
	    rec.left = 0;
	    rec.top = 0;
	    rec.right = __intVal(w);
	    rec.bottom = __intVal(h);
	    AdjustWindowRectEx(&rec,GetWindowLong(hWnd,GWL_STYLE),0,GetWindowLong(hWnd,GWL_EXSTYLE));
	    DPRINTF(("resize %x w:%d h:%d -> w:%d h:%d\n",hWnd,__intVal(w),__intVal(h),rec.right - rec.left, rec.bottom - rec.top));
	    SetWindowPos(hWnd, (HWND)0,
			 0, 0,
			 rec.right - rec.left, rec.bottom - rec.top,
			 SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOZORDER);
	}
	RETURN ( self );
    }
%}
!

primSetWindowIconId:wiconId width:wiconWidth height:wiconHeight in:aWindowId
%{  /* UNLIMITEDSTACK (WIN95 only) */

    unsigned char* cp;
    unsigned char* ep;
    HBITMAP        xBitMap, maskBitmap;
    ICONINFO       iconInfo;
    int            height, width;
    int            nBytes, nBits;
    int            index;
    HICON          xIcon = (HICON)0, yIcon = (HICON)0;
    printf("primSetWindowIconId\n");
    if (__isExternalAddress(aWindowId)
     && __isExternalAddress(wiconId)
     && __bothSmallInteger(wiconWidth, wiconHeight))
    {
	HWND win = _HWNDVal(aWindowId);

	xBitMap = _HBITMAPVAL( wiconId );
	if( xBitMap != 0 )
	{
	  BITMAP bm;
	  if (GetObject(xBitMap, sizeof(bm), (LPSTR)&bm))
	  {
	    int d = bm.bmPlanes * bm.bmBitsPixel;
	    BYTE *ep,*bp;

	    printf("Bitmap w:%d h:%d p:%d d:%d\n",bm.bmWidth,bm.bmHeight,bm.bmPlanes,bm.bmBitsPixel);
	    height = __intVal( wiconHeight );
	    width  = __intVal( wiconWidth  );
	    nBytes = ( width + 31 ) / 8;
	    nBytes = height * nBytes;
	    ep = (unsigned char *) malloc(nBytes);
	    if( ep != 0 ) {
		memset(ep,0,nBytes);
		maskBitmap = CreateBitmap(width, height, 1, 1, ep );
		free(ep);
		if( maskBitmap != NULL ) {
		    DPRINTF(( "BITMAP mask CREATED!!!\n" ));
		    iconInfo.fIcon = TRUE;
		    iconInfo.hbmMask  =maskBitmap;
		    iconInfo.hbmColor = xBitMap;
		    xIcon = CreateIconIndirect( &iconInfo );
		    DPRINTF(( "ICON CREATED!!!\n" ));
		    DelObject( maskBitmap );
		} else {
		    DPRINTF(( "BITMAP mask CREATION failed!!!\n" ));
		}
	    } else {
		DPRINTF(( " malloc failed\n" ));
	    }
	  }
	} else {
	    DPRINTF((" xBitMap is zero \n" ));
	}
#if 0
	xBitMap = _HBITMAPVAL( wiconId );
	if( xBitMap != 0 )
	{
	    height = __intVal( wiconHeight );
	    width  = __intVal( wiconWidth  );
	    nBytes = ( width + 15 ) / 16;
	    nBytes = height * 2 * nBytes;
	    if( nBytes != 0 )
	    {
		cp = (unsigned char *) malloc(nBytes);
		ep = (unsigned char *) malloc(nBytes);
		if( ( cp != 0 ) && ( ep != 0 ) )
		{
		    for( index = 0; index < nBytes; index++ )
			*ep++ = 0x00;
		    nBits = GetBitmapBits( xBitMap, nBytes, cp );
		    xIcon = CreateIcon( (HANDLE) __getHInstance(),
					width,
					height,
					1,
					1,
					ep,
					cp );
		    DPRINTF(( "ICON CREATED\n"));
		    DPRINTF(( "xIcon: %d, height: %d, width: %d\n" ));
		    printf( "xIcon: %d, height: %d, width: %d\n" );
		}
		else
		{
		    DPRINTF(( " malloc failed\n" ));
		}
	    }
	    else
	    {
		DPRINTF(( " nBytes is zero \n" ));
	    }
	}
	else
	{
	    DPRINTF((" xBitMap is zero \n" ));
	}
#endif
	if (xIcon) {
	   yIcon = (HICON)GetClassLong(win,GCL_HICON);
	   SetClassLong(win,GCL_HICON,(DWORD)xIcon);
/* It has to be checked whether thia can be deleted!!!!! */
	    if( yIcon ) {
		if( DestroyIcon( yIcon ) )
		    DPRINTF(( "Old icon deleted\n" ));
	    }
	}
	RETURN (self);
    }
%}
!

setBackingStore:how in:aWindowId
    "turn on/off backing-store for a window"
    'setBackingStore:in: not yet implemented' errorPrintCR.

!

setBitGravity:how in:aWindowId
    "set bit gravity for a window"
    "/ 'setBitGravity:in: not yet implemented' errorPrintCR.

!

setCursor:aCursorId
    "define the current cursor"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    HCURSOR newCursor;

    if (ISCONNECTED
     && __isExternalAddress(aCursorId))
     {
	SetCursor(_HCURSORVal(aCursorId));
	RETURN ( self );
    }
%}
!

setCursor:aCursorId in:aWindowId
    "define a windows cursor
     Ignored here, since in windows, an application
     has to manage the cursor itself."

%{  /* UNLIMITEDSTACK (WIN95 only) */

    HCURSOR newCursor;

    if (ISCONNECTED
     && __isExternalAddress(aWindowId)
     && __isExternalAddress(aCursorId)) {
	HWND win = _HWNDVal(aWindowId);
	POINT p;

	/*printf("SetWindowCursor\n");*/
	SetWindow_Cursor(win, _HCURSORVal(aCursorId));
	/*
	 * if the pointer is currently in that window ...
	 */
	GetCursorPos(&p);
	if (WindowFromPoint(p) == win) {
	   SetCursor(_HCURSORVal(aCursorId));
	}
	RETURN ( self );
    }
%}
!

setIconName:aString in:aWindowId
    "define a windows iconname"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    if (__isExternalAddress(aWindowId)
     && (__isString(aString) || __isSymbol(aString))) {
	HWND win = _HWNDVal(aWindowId);

	SetWindowText(win, __stringVal(aString));
	RETURN (self);
    }
%}
!

setSaveUnder:yesOrNo in:aWindowId
    "turn on/off save-under for a window"

!

setTransient:aWindowId for:aMainWindowId
    "set aWindowId to be a transient of aMainWindow"

!

setWindowBackground:aColorIndex in:aWindowId
    "set the windows background color. This is the color with which
     the view is filled whenever exposed. Do not confuse this with
     the background drawing color, which is used with opaque drawing."
%{  /* UNLIMITEDSTACK (WIN95 only) */

    if (__isExternalAddress(aWindowId)
     && (__isSmallInteger(aColorIndex))) {
	HWND win = _HWNDVal(aWindowId);
	HBRUSH hBrush = CreateSolidBrush(st2RGB(__intVal(aColorIndex)));
	SetWindow_bgBrush(win,hBrush);
	RETURN (self);
    }
%}
!

setWindowBackgroundPixmap:aPixmapId in:aWindowId
    "set the windows background pattern to be a form.
     This is the pattern with which the view is filled whenever exposed.
     Do not confuse this with the background drawing color, which is used
     with opaque drawing."

!

setWindowBorderColor:aColorIndex in:aWindowId
    "set the windows border color"

!

setWindowBorderPixmap:aPixmapId in:aWindowId
    "set the windows border pattern"

!

setWindowBorderWidth:aNumber in:aWindowId
    "set the windows border width"

!

setWindowClass:wClass name:wName in:aWindowId
    "define class and name of a window.
     This may be used by the window manager to
     select client specific resources."

!

setWindowGravity:how in:aWindowId
    "set window gravity for a window"

!

setWindowIcon:aForm in:aWindowId
    "define a bitmap to be used as icon"

    |wiconId wiconHeight wiconWidth|

    aForm notNil ifTrue:[
	wiconId := aForm id.
	wiconHeight := aForm height.
	wiconWidth  := aForm width.
	self
	    primSetWindowIconId:wiconId
	    width:wiconWidth
	    height:wiconHeight
	    in:aWindowId
    ].
!
setWindowIcon:aForm mask:aMaskForm in:aWindowId
    "set a windows icon & iconMask"

!

setWindowIconWindow:aView in:aWindowId
    "define a window to be used as icon"

!

setWindowName:aString in:aWindowId
    "define a windows name"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    if (__isExternalAddress(aWindowId)
     && (__isString(aString) || __isSymbol(aString))) {
	HWND win = _HWNDVal(aWindowId);

	SetWindowText(win, __stringVal(aString));
	RETURN (self);
    }
%}
!

unmapWindow:aWindowId
    "make a window invisible"

%{  /* UNLIMITEDSTACK (WIN95 only) */

    if (__isExternalAddress(aWindowId)) {
	HWND win = _HWNDVal(aWindowId);

	if (win) {
	    ShowWindow(win, SW_HIDE);
/*
	    enqEvent(win, WM_SHOWWINDOW, FALSE, 0, 0, 0, 0);
*/
	}
	RETURN ( self );
    }
%}
! !

!WinWorkstation class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libview/WinWorkstation.st,v 1.33 1998-01-20 23:56:18 cg Exp $'
! !
WinWorkstation initialize!
